Sun Jan 10 17:25:24 2010  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/webrick/accesslog.rb : Escape needed.

	* lib/webrick/httpstatus.rb : ditto.

	* lib/webrick/httprequest.rb : ditto.

	* lib/webrick/httputils.rb : ditto.

	* test/webrick/test_cgi.rb (TestWEBrickCGI::test_bad_): Test for it.

Sat Dec  5 18:52:56 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* string.c (rb_str_justify): CVE-2009-4124.
	  Fixes a bug reported by 
	  Emmanouel Kellinis <Emmanouel.Kellinis AT kpmg.co.uk>, KPMG London;
	  Patch by nobu.

Sat Dec  5 14:29:49 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/extend-command.rb (IRB::ExtendCommandBundle::def_extend_command):
	  extension commands with optional parameters have been broken because of 
	  a spec change of UnboundMethod#arity.

Sat Dec  5 14:24:10 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/extend-command.rb (IRB::ExtendCommandBundle::def_extend_command):
	  gives eval a source location for readability of backtrace.

	* lib/irb/extend-command.rb (IRB::ContextExtender::def_extend_command):
	  ditto

	* lib/irb/extend-command.rb (IRB::MethodExtender::def_pre_proc):
	  ditto

	* lib/irb/extend-command.rb (IRB::MethodExtender::def_post_proc):
	  ditto

Tue Jul 21 21:37:19 2009  Keiju Ishitsuka  <keiju@emperor2.pendome>

	* lib/irb/cmd/help.rb: fixed irb's "help" command. [ruby-core:22310].

Thu Jul 23 14:35:02 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_{open,wopen}): fixed typos. these conditions
	  mean to call runtime's open() if textmode.

Fri Sep 25 16:01:45 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c, include/ruby/win32.h (rb_w32_access): new function to
	  replace MSVCRT's access().
	  [ruby-core:25761]

	* file.c (eaccess): workaround for recent MSVCRT is no longer needed.

Mon Sep 28 19:36:20 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/wini32.c (LK_ERR): with overlapped I/O, LockFileEx() returns
	  ERROR_IO_PENDING if the file is locked.

Mon Nov 23 04:12:00 2009  Tanaka Akira  <akr@fsij.org>

	* enc/trans/newline.trans (fun_so_universal_newline): generate \n
	  after \r\n detection instead of just after \r.
	  [ruby-list:45988] [ruby-core:25881] [ruby-core:26788]

Tue Dec  1 12:01:13 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (dyna_push_gen, dyna_pop_gen): no needs to save both of
	  args and vars.  [ruby-core:26961]

	* parse.y (dyna_push_gen): use rb_node_newnode() for ripper.
	  [ruby-core:26961]

	* parse.y (dyna_push_gen, dyna_pop_gen): adjust local vtable level
	  for the case of syntax errors in method name or argument inside
	  do block.   [ruby-core:26961]

Tue Oct 20 15:28:49 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (method_call): dispatch symbols.  a patch from Andy Keep in
	  [ruby-core:26169].  [ruby-core:26165]

	* parse.y (mlhs_basic): fixed handling splat in middle of mlhs.  a
	  patch from Andy Keep in [ruby-core:26163]
Thu Oct 15 16:57:38 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_intern3): check symbol table overflow.
	  [ruby-core:26092]

Sun Oct 11 15:54:52 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/gdbm/gdbm.c (fgdbm_select): fixed rdoc.  a patch from Justin
	  Collins in [ruby-core:26050].

Sat Aug 22 01:29:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (rm_f, rm_rf): pass the last hash through if exists.
	  [ruby-dev:39153]

Tue Oct 20 14:50:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): dispatch delayed heredoc
	  contents.  based on a patch from Andy Keep in [ruby-core:24855].

Fri Jan 30 18:04:23 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_write): limit write size to 32KB if the file
	  seems to be console.  [ruby-core:21613]

Sat Oct  3 22:14:18 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (bv_decls, bvar): fix for block variables.
	  [ruby-dev:39423]

Sat Oct  3 00:47:52 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ripper/dummyparser.rb (DummyParser): improvement by Magnus
	  Holm in [ruby-core:25884].
	  * remove scanner events which simply returned the first argument.
	  * all parser events are now automatically generated.
	  * simplify blocks.

Fri Oct  2 20:37:37 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (ripper_yylval_id, ripper_get_{id,value}): wrap ID by
	  NODE to track local variable assignment.

	* parse.y (lvar_defined_gen, assignable_gen): enable local
	  variable check.  [ruby-core:24923]

	* parse.y (validate): use value only.

	* test/ripper/test_parser_events.rb (test_local_variables): tests
	  based on a patch from Magnus Holm in [ruby-core:25885].

Fri Oct  2 15:34:15 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (ruby_suppress_tracing): get rid of clobbering by
	  longjmp.

Fri Oct 16 12:03:31 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/csv.rb (CSV#raw_encoding): returns ASCII-8BIT when the io
	  doesn't have encoding.

Fri Oct 16 03:15:52 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/csv.rb (CSV#read_to_char): set encoding and verify data
	  which read from io before encode it to @encoding.

	* lib/csv.rb (CSV#raw_encoding): add to get @io's encoding.

	* lib/csv.rb (CSV#read_io): add to read string and set @io's
	  encoding.

Mon Sep 28 22:33:11 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dln.c (aix_loaderror): needs format string.

Mon Sep 28 10:06:38 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* stringio/stringio.c (strio_read): set ASCII-8BIT encoding
	  when length argument is given.

Sun Sep 27 13:06:43 2009  Tanaka Akira  <akr@fsij.org>

	* lib/pp.rb (PP:ObjectMixin#pretty_print): delegates has no inspect
	  method.  [ruby-core:25804]

Sat Sep 26 08:35:12 2009  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (compile_string): rename to parse_string(), because
	  this function only parse String to NODE.

Thu Sep 24 09:41:42 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/mathn.rb (Bignum#**): Fixed bignum**fixnum that was broken when
	  requiring lib/mathn
	  [ruby-core:25740]

Tue Sep 22 05:04:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/bigdecimal/lib/bigdecimal/{ludcmp,math}.rb: depend on
	  bigdecimal.

	* ext/bigdecimal/lib/bigdecimal/*.rb: made module functions.

Tue Sep 22 01:10:02 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* ossl_config.c (ossl_config_add_value_m, ossl_config_set_section):
	  Check if frozen (or untrusted for $SECURE >= 4) [ruby-core:18377]

Sun Sep 20 11:11:34 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* struct.c (rb_struct_equal, rb_struct_eql): Handle comparison of
	  recursive structures [ruby-core:24759]

	* range.c (range_eq, range_eql):  ditto for ranges

Fri Sep 18 23:51:17 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (r_object0): entry regexp object before its encoding
	  name.  [ruby-core:25625]

Sun Aug 16 00:30:33 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* include/ruby/oniguruma.h
	  (ONIGENC_CTYPE_SPECIAL_MASK): added.
	  (ONIGENC_CTYPE_D): ditto.
	  (ONIGENC_CTYPE_S): ditto.
	  (ONIGENC_CTYPE_W): ditto.

	* regparse.c: \d, \s and \w are now non Unicode class.
	  [ruby-dev:39026]
	  (fetch_token_in_cc): use ONIGENC_CTYPE_[DSW] for \d/\s/\w.
	  (fetch_token): ditto.
	  (add_ctype_to_cc): add routines for ONIGENC_CTYPE_[DSW].
	  (parse_exp): ditto.

	* test/ruby/test_regexp.rb (TestRegexp#test_char_class):
	  add tests for above.

Fri Sep 18 16:15:04 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each), parse.y (stmt, arg): arg_concat()
	  on op_asgn was inversed.  [ruby-core:25629] [Bug #2050]

Sat Sep  5 15:21:13 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

 * compile.c (iseq_compile_each): op_asgn to aref should return rhs.
   [ruby-core:25387]

Sun Feb 15 03:50:21 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* hash.c (rb_hash): always return a fixnum value because a return
	  value of rb_hash may be used as a hash value itself and bignums have
	  no unique VALUE.

	* test/ruby/test_hash.rb: add a test for above.

Tue Nov 17 16:04:13 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* regparse.c (parse_char_class): fixes a wrong merge r25531.

Tue Nov 17 16:01:02 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* insns.def (opt_case_dispatch): need cast.

Tue Nov 17 15:46:23 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* dir.c (READDIR): this branch doesn't have rb_w32_readdir_with_enc().

Fri Sep 18 07:06:41 2009  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/fileutils/test_fileutils.rb: add a test for [ruby-dev:39345]

Fri Sep 18 06:36:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (rm_f, rm_rf): FileUtils.rm can take an array.
	  [ruby-dev:39345]

Thu Oct 29 01:22:01 2009  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* ext/socket/extconf.rb : Compilation failure on AIX.
	  ss_len (a member of struct sockaddr_storage) has preceding __,
	  but ss_family does not have it from AIX 5.2.

Mon Sep 28 01:28:17 2009  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* Makefile.in (miniruby): suppress duplication warning on AIX.

Mon Sep 28 01:13:25 2009  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* common.mk (ruby.imp): add text section [Bug #2064].

	* common.mk (ruby.imp): do not export Init_*.

Thu Sep 24 01:14:18 2009  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* dln.c (aix_loaderror): fixed typo. suppress warnings.

Sun Aug  9 16:36:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (ruby.imp): excluded prelude.o to get rid of circular
	  dependency.  [ruby-dev:39052]

Thu Sep 17 06:03:40 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb (Matrix#rank): Two bug fixes. One made
	  Matrix[[0,0],[0,0],[1,0]].rank raise a NoMethodError while the other
	  one had Matrix[[0,1],[0,0],[1,0]].rank raise a TypeError.

Wed Sep 16 17:20:49 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb (Matrix#/): Fix obvious bug

Wed Sep 16 13:39:10 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb (determinant): Bug fix where determinant failed on
	  some matrices [ruby-core:23597]

Mon Sep 14 06:42:21 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/cgi/cookie.rb (value): Keep CGI::Cookie#value in sync with the
	  cookie itself. Based on a patch by Arthur Schreiber [ruby-core:17634]

Mon Sep 14 05:21:12 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/net/http.rb (fetch): Handle properly default values; a patch by
	  Arthur Schreiber [ruby-core:18308]

Sun Sep 13 12:07:49 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (SYM2ID): needs parens.

	* include/ruby/ruby.h (NUM2INT, NUM2LL, INT2NUM, UINT2NUM),
	  (LONG2NUM, ULONG2NUM, NUM2CHR, rb_type_p, rb_special_const_p):
	  GCC specific optimization.

Sun Sep 13 09:38:06 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/prime.rb (EratosthenesGenerator#initialize): call super.
	  (TrialDivisionGenerator, Generator23): ditto.  [ruby-core:25539]

Sun Sep 13 08:30:30 2009  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c: fix WIN32OLE_TYPELIB.new when the 1st 
	  argument is the non-registered file.

Sun Nov  1 22:04:33 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_module.rb (TestModule#test_method_added): new test
	  method. Patch by James M. Lawrence.
	  c.f. [ruby-core:25536], r24867.

Sun Sep 13 01:15:49 2009  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb (URI::FTP#buffer_open): fix the %2F handling.

Sat Sep 12 22:47:24 2009  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb (URI::FTP#buffer_open): use the port specified in
	  the URI.

Sat Sep 12 07:52:59 2009  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (EVENTSINK_Invoke): initialize result
	  variant value.

Fri Sep 11 10:38:33 2009  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* lib/net/http.rb (Net::HTTPHeader::encode_kvpair): also call to_s
	  to k.  A patch from swdyh <youhei@gmail.com>
	  http://github.com/swdyh/ruby/tree/c847f43c2ccb679b9ff728f8b1b16c6ceeb57f39

Fri Sep 11 09:45:11 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dln.c (aix_loaderror): get rid of using uninitialized value in the
	  case loadquery fails.  fixed wrong index variable usage.  see
	  [ruby-core:25479].

Fri Sep 11 01:14:00 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/net/http.rb (fetch): rdoc fix, patch by Arthur Schreiber.
	  [ruby-core:18309].

Thu Sep 10 21:22:01 2009  Tanaka Akira  <akr@fsij.org>

	* test/dl/test_cptr.rb (test_free=): test SEGV at first.
	  [ruby-dev:39269]

Tue Mar  3 15:05:19 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/lib/dl/value.rb (DL::ValueUtil#wrap_arg): NULL for nil.

Tue Sep  8 08:32:30 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/dl/test_{cfunc,ptr}.rb: added tests from Aaron Patterson.
	  see [ruby-dev:39249].

Tue Mar  3 15:03:19 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/dl: moved from ext/dl/test.

Sat Sep  5 10:38:46 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): &&= and ||= should return rhs.
	  [ruby-dev:39163] (#1996), [ruby-core:25143]

Fri Sep  4 04:46:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/webrick/httpservlet/abstract.rb (do_OPTIONS): method names
	  are symbols now.  [ruby-core:24580]

Sun Mar 15 09:17:26 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (.y.c): use SRC_FILE which contains slashes instead of
	  backslashes.  [ruby-core:22891]

Tue Sep  1 19:56:28 2009  Koichi Sasada  <ko1@atdot.net>

	* vm_eval.c (eval_string_with_cref): fix to check local_table_size.
	  [ruby-dev:39205] [Bug #2024]

Sun Aug 30 16:38:56 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_enc_symname2_p): not depend on nul terminator.

Sun Aug 30 01:15:31 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/zlib/zlib.c (gzfile_read_all): use gzfile_newstr;
	  set and convert its encoding. [ruby-dev:38304]

Thu Aug 27 18:31:07 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_remove_method_id): exported.

	* numeric.c (num_sadded): fix for non-ascii method name.

Thu Aug 27 08:16:34 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/strscan/strscan.c (strscan_set_string): set string should not be
	  dupped or frozen, because freezing it causes #concat method failure,
	  and unnecessary to dup without freezing.  a patch from Aaron
	  Patterson at [ruby-core:25145].

Wed Aug 26 12:36:58 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (collect_local_variables_in_env): skips internal variables.
	  [ruby-core:25125]

Mon Aug 24 16:35:57 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* st.c (st_delete_safe): deals with packed entries.
	  [ruby-core:25080]

	* st.c (st_cleanup_safe): ditto.  [ruby-core:25081]

Sun Aug 23 00:56:13 2009  Tanaka Akira  <akr@fsij.org>

	* thread.c (rb_thread_schedule): don't recur infinitely.
	  (rb_threadptr_execute_interrupts): ditto.
	  [ruby-dev:38060]

Sat Aug 22 00:03:19 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread.c (rb_check_deadlock): decrease number of sleepers before
	  deadlock detection because the deadlock exception makes main thread
	  run.  [ruby-dev:39142]

Fri Aug 21 15:01:35 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/readline/readline.c (readline_readline): use rb_prep_terminal
	  only on Windows.

Thu Aug 20 14:39:47 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/readline/readline.c (Init_readline): add rl_prep_terminal(1).
	  insited by jitte [ruby-list:43546]

Thu Aug 20 08:39:50 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* thread.c (rb_thread_terminate_all): do not ignore interrupt when
	  reaping threads on termination.  [ruby-dev:39107]

Thu Aug 20 01:06:48 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (DEFINE_STRUCT_DIRENT): use union to allocate sufficient
	  memory space for Solaris.  a patch from Naohisa GOTO
	  <ngoto at gen-info.osaka-u.ac.jp> in [ruby-dev:39132].
	  [ruby-dev:39062]

	* configure.in (SIZEOF_STRUCT_DIRENT_TOO_SMALL): Solaris dirent
	  check.

Thu Aug 20 23:39:51 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* parse.y (reduce_nodes_gen): preserve NODE_FL_NEWLINE flag during
	  node reducing.  [ruby-core:24463]

Wed Aug 19 02:54:01 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_settracefunc.rb (test_return, test_return2): add two
	  tests for [ruby-dev:38701] and [ruby-core:24463].

Wed Aug 19 01:08:34 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* compile.c (NODE_RETURN): fire return event at explicit return.
	  [ruby-dev:38701]

Tue Aug 18 11:37:24 2009  wanabe  <s.wanabe@gmail.com>

	* vm_insnhelper.c (vm_call_cfunc): ensure hook c-return.
	  [Bug #1588]

	* test/ruby/test_settracefunc.rb (TestSetTraceFunc#test_raise):
	  follow above.

Mon Aug 17 14:35:03 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (lex_get_str, lex_io_gets, rb_parser_compile_string):
	  must be ascii compatible.

Sun Aug 16 23:58:22 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (yylex): should dispatch scan-event even when follows
	  just after delayed-token.  [ruby-dev:37855] [Bug #1071]

Sun Aug 16 15:25:26 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/csv.rb: Change magic comment to US-ASCII in order to
	  make literals as US-ASCII.

Sun Aug 16 10:45:10 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* regparse.c (parse_char_class, parse_exp, parse_branch),
	  (parse_subexp): fixed memory leak.  a patch from Ralf Junker
	  <ralfjunker AT gmx.de> at [ruby-core:24921].

Sun Aug 16 01:10:00 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* regparse.c (add_ctype_to_cc_by_range): fix the first
	  character bigger than sb_out was dropped.

	* test/ruby/test_regexp.rb (TestRegexp#test_posix_bracket):
	  add tests for above.

Fri Aug 14 14:31:33 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rubyhdrdir): fixed typo.  [ruby-dev:39079]

Fri Aug 14 00:29:22 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* doc/ChangeLog-1.8.0: add forgotten entry contributed by
	  TAKAHASHI Kaoru.  [ruby-dev:39065]

Fri Aug 14 00:19:49 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/delegate.rb (Delegator#method_missing): __FILE__ may contain
	  multi-byte characters.  a patch from Kenta Murata in [ruby-dev:39066].

Thu Aug 13 21:01:03 2009  wanabe  <s.wanabe@gmail.com>

	* vm.c (vm_exec): returning from lambda runs ensure section.
	  [Bug #1729]

Wed Aug 12 15:52:04 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* class.c (rb_define_module_id_under): fix the name.

	* class.c (rb_define_module_under): fix for prevvious changes.

Wed Aug 12 15:32:16 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_define_class_id_under, rb_define_module_id_under):
	  new functions to define a nested class/module with non-ascii
	  name.

	* struct.c (make_struct): use name with encoding.

	* struct.c (inspect_struct): ditto.  [ruby-core:24849]

Wed Aug 12 Wed Aug 12 14:54:34 2009  Koichi Sasada  <ko1@atdot.net>

	* insns.def, vm.c, vm_insnhelper.c, vm_insnhelper.h: check
	  definition of (classes)#=== for case/when optimization.
	  Fix Bug #1376 [ruby-core:23190].

	* string.c (Init_String), bignum.c (Init_Bignum),
	  numeric.c (Init_Numeric): define String#===, Symbol#===,
	  Bignum#===, Fixnum#===, Float#=== as same as (classes)#==.

Wed Aug 12 12:59:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_new_frozen): must not change encoding of frozen
	  shared string.  [ruby-dev:39068]

Fri Oct 23 10:51:04 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_m17n.rb (TestM17N#test_sprintf_s):
	  added an assertion for [ruby-list:46274].
	  see also r24506.

Tue Oct 20 17:57:31 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (w_symbol, r_symreal): fixed the order of symbol and
	  its encoding modifier, in order to make the dump readable from
	  1.8.  [ruby-dev:39515]

Mon Aug 10 21:45:26 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>
 
 	* include/ruby/intern.h (rb_path2class): no deprecation.

Mon Aug 10 06:55:45 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (class2path, w_unique, w_extended, w_class, w_uclass):
	  deal with non-ascii class path.  [ruby-core:24790]

	* marshal.c (r_unique, path2class, path2module, obj_alloc_by_path),
	  (r_object0): ditto.

	* variable.c (rb_path_to_class): new encoding-aware function to
	  get a class from its name.

Sat Aug  8 06:18:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (w_symbol r_symlink, r_symbol, r_object0): fix for
	  non-ascii symbols.  loading such symbols can cause segfaults in
	  older versions.  [ruby-core:24788]

Sun Aug  9 07:25:07 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/ripper/eventids2.c (token_to_eventid): added
	  keyword_do_LAMBDA.  [ruby-dev:39049]

Fri Aug  7 03:22:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_exc_raise, rb_exc_fatal): nil is used to reraise.

Wed Aug  5 12:54:00 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_exc_raise, rb_exc_fatal): require exception object.
	  [ruby-core:24767]

Fri Aug  7 01:49:41 2009  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/sha2/sha2.c: The ULL suffix is not supported by
	  pre-C99 compilers, so resurrect the ULL() macro to regain
	  portability. [ruby-dev:39032]

Fri Aug  7 01:35:26 2009  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/*/extconf.rb: inttypes.h and unistd.h need not be
	  checked here. [ruby-dev:39032]

Thu Aug  6 21:18:15 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/digest/sha2/lib/sha2.rb: should require sha2.so.

Thu Aug  6 21:11:40 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/digest/sha2/sha2.c (*_Final): typos.

Thu Aug  6 19:46:56 2009  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/sha2/sha2.h (BYTE_ORDER): Define BYTE_ORDER as
	  necessary. [ruby-dev:39029]

Thu Aug  6 01:37:20 2009  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/sha2/sha2.[ch]: Update to 1.0 RELEASE which fixes an
	  off-by-one bug in SHA-256 hashing.  Reduce differences from
	  the original while at it. [Bug #1799]

Thu Aug  6 16:25:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (enc_capable, rb_enc_get_index): Symbol is encoding
	  capable.

	* encoding.c (rb_enc_associate_index): cannot set encoding on
	  special constants.

Wed Aug  5 19:11:01 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ruby.c (rb_stdio_set_default_encoding): declared.

Wed Aug  5 18:46:01 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* debug.c (ruby_dummy_gdb_enums): made public.  [ruby-dev:39001]

Wed Aug  5 12:39:23 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_longjmp): reset raised flag before fatal error.

	* eval_error.c (error_print): file can be NULL. line can be 0.

Wed Aug  5 01:38:27 2009  Yusuke Endoh  <mame@tsg.ne.jp>
 
	* lib/pp.rb (guard_inspect_key): untrust internal hash to prevent
	  unexpected SecurityError.

	* test/ruby/test_object.rb: add a test for [ruby-dev:38982].

Tue Aug  4 22:10:34 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (has_redirection): need to execute shell if commandline
	  includes newline.  cf. [ruby-core:24560]

Tue Aug  4 05:43:03 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* thread.c (recursive_push): need to set UNTRUST.  [ruby-dev:38997]

Mon Aug  3 18:25:08 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* sample/svr.rb: obsolete TCPserver renamed.  [ruby-core:24712]

	* sample/tsvr.rb: ditto.

	* sample/dualstack-httpd.rb: ditto.

Mon Aug  3 18:12:54 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* thread.c (recursive_push): untrust internal hash to prevent
	  unexpected SecurityError.  a patch from Kazuhiro NISHIYAMA.
	  Fix: #1864  [ruby-dev:38982]

Mon Aug  3 17:06:05 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/README: updated.  a patch from Daniel Bovensiepen.
	  [ruby-core:24693]

Mon Aug  3 16:28:09 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_connect): return value was broken when some
	  error occurred.
	  [ruby-core:24234]

Mon Aug  3 15:48:40 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_{permutation,combination}): disallow reentrance
	  with continuation since work-buffers cannot restore.

	* array.c (rb_ary_{permutation,combination,product}): must not use
	  ary_discard on strings.

Sat Aug  1 19:23:27 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (tr_trans): change condition of singlebyte
	  optimization.

Sat Aug  1 05:18:36 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (tr_trans): can't use singlebyte optimization when
	  the replacement is multibyte. [ruby-core:24612]

Fri Jul 31 16:28:33 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* io.c (rb_stdio_set_default_encoding): added.

	* ruby.c (process_options): call rb_stdio_set_default_encoding
	  after setting defualt internal and external.

Fri Jul 31 18:01:34 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/securerandom.rb (SecureRandom.random_bytes): return string should
	  be ASCII-8BIT.  [ruby-core:24640]

Fri Jul 31 10:54:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (literal_concat_gen): reduced unnecessary node at string
	  literal concatenation with empty head dstr.  [ruby-dev:38968]

Fri Jul 31 02:57:39 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* parse.y (literal_concat_gen): NODE_DSTR was incorrectly handled as
	  NODE_STR.  [ruby-dev:38968]

	* bootstraptest/test_syntax.rb: add a test for above.

Thu Jul 30 23:04:32 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* gem_prelude.rb (Gem.path): uses Gem.default_path as a default value
	  so that ruby finds gems in ~/.gem/.
	  (Gem.user_home): reduced version of lib/rubygems.rb's.
	  Gem.default_path needs it.

Thu Jul 30 21:39:42 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* compile.c (iseq_compile_each): fix stack consistency error.
	  [ruby-core:24611]

	* bootstraptest/test_method.rb: add tests for above.

Thu Jul 30 16:45:39 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* insns.def (defineclass): preserve encoding of class/module
	  names.  [ruby-core:24600]

	* variable.c (rb_set_class_path_string): set class path with a
	  string value.

Sat Jul 25 17:49:03 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (argf_eof): should not have reached EOF before trying to
	  read.  based on a patch by Heesob Park <phasis AT gmail.com> a
	  [ruby-core:24559].  [ruby-core:24557]

Thu Jul 23 17:31:02 2009  Keiju Ishitsuka  <keiju@ruby-lang.org>

	* lib/irb/ruby-lex.rb: make irb be able to parse
	  string_dvar. [ruby-core: 24051]

Wed Jul 22 22:23:24 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* vm_core.h (struct rb_iseq_t): add a new field line_no.  This field
	  represents line number from which the original code of the iseq
	  starts.  [ruby-dev:38698]

	* iseq.c, compile.c: ditto.

	* parse.y: line number hack (for Proc#source_location) is no longer
	  needed.

	* test/ruby/test_settracefunc.rb: line number of set_trace_func is now
	  compatible with 1.8's.

Wed Jul 22 02:33:57 2009  Keiju Ishitsuka  <keiju@emperor2.pendome>

	* lib/irb.rb: forget svn commit.

Wed Jul 22 00:34:39 2009  Keiju Ishitsuka  <keiju@ruby-lang.org>

	* lib/irb.rb, lib/irb/init.rb, lib/irb/ext/save-history.rb: add
	  IRB::irb_at_exit. no use finalizer saving history. [ruby-dev-38563]

Tue Jul 21 20:41:20 2009  Keiju Ishitsuka  <keiju@emperor2.pendome>

	* lib/tracer.rb: no show lines unkonwn line number. [ruby-core:22096],
          no trace display  c-call and c-return as default.

Tue Jul 21 16:07:57 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/tracer.rb: toplevel caller exists now.  [ruby-core:24454]

Mon Jul 20 12:51:39 2009  wanabe  <s.wanabe@gmail.com>

	* lib/matrix.rb (Matrix#rank): revert a part of r20859 to avoid
	  infinite loop.  [Bug #1020]

Sun Jul 19 17:32:37 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_read): should taint the result.   [ruby-dev:38826]

Sat Jul 18 23:44:59 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* re.c (reg_enc_error): use rb_enc_get to get the encoding of
	  a Regexp object. REGEXP(re)->ptr->enc is the encoding of the
	  regexp engin for patterns and target strings.
	  [ruby-core:23208]

Sat Jul 18 07:06:31 2009  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb,ext/tk/lib/tk/grid.rb: Bug fix on grid_slaves().
	  Extend usage pattern of grid_column()/grid_row().

Sat Jul 18 06:30:35 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/win32.h: include winsock headers in extern "C++" for
	  C++ extension libraries.

	* include/ruby/missing.h (vsnprintf): workaround for VC++.
	  [ruby-core:23096]

Sat Jul 18 00:23:47 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/readline/readline.c (Init_readline): rl_catch_signals does
	  not exist on some platform like Mac OS X 10.5.

	* ext/readline/extconf.rb: checks existance of rl_catch_signals.

Fri Jul 17 22:29:21 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/readline/readline.c (Init_readline): use rl_catch_sigwinch only
	  when existing.

	* ext/readline/extconf.rb: check existance of rl_catch_sigwinch, and
	  workaround for native Win32 readline port.

Fri Nov 28 17:52:26 2008  Keiju Ishitsuka  <keiju@ruby-lang.org>

	* lib/foerwardable.rb: should be usable def_single_delegator for
	  Class and Module.
	  [ruby-dev:38815]

Thu Jul 16 18:28:09 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* id.c (Init_id), vm.c (vm_exec): @#__ThrowState__ is no longer
	  used.  [ruby-dev:38760]

Thu Jul 16 08:56:32 2009  Koichi Sasada  <ko1@atdot.net>

	* dir.c (push_glob): re-fix GC problem.

Wed Jul 15 23:45:11 2009  Koichi Sasada  <ko1@atdot.net>

	* dir.c (push_glob): fix GC problem.

Tue May  5 10:42:28 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json: Update to JSON 1.1.4.

Wed Jul 15 16:29:35 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (LIBPATHFLAG): path is already quoted in mkmf.rb.

Tue Jul 14 17:29:20 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_str_index_m): return nil if pos is out of string.
	  [ruby-core:23660]

Tue Jul 14 01:06:31 2009  Yusuke Endoh  <mame@tsg.ne.jp>

 	* enumerator.c (yielder_yield_i): use rb_proc_new instead of
 	  rb_iterate.  [ruby-dev:38518]
 
 	* README.EXT: rb_iterate is obsolete since 1.9; use rb_block_call
 	  instead.
 
 	* README.EXT.ja: ditto.

Mon Jul 13 22:49:50 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/prime.rb (Prime#prime_division): now decomposes
	  negative integer into a decomposition with element [-1, 1].

	* test/test_prime.rb: test for it.

Mon Jul 13 22:28:03 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (pipe_open): handles leaked on win32 when an error occurs.

Tue Jul 14 01:24:56 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* marshal.c (r_object0): should return real object.

Mon Jul 13 20:21:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (r_object0): should not shadow outer variable not to
	  return Qnil always.

Mon Jul 13 19:41:05 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* marshal.c (r_object0): copy instance variables to new regexp.

Fri Jul 10 14:41:34 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* marshal.c (r_object0): set encoding only if the encoding
	  is not US-ASCII.

Fri Jul 10 11:41:39 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (rb_obj_{untrust,untrusted,trust}): added
	  prototypes.  [ruby-dev:38756]

Fri Jul 10 10:25:19 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_search_superclass): checks for implici
	  argument passing before method search.  [ruby-core:24244]

Thu Jul  9 21:56:59 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* marshal.c (r_object0): replace \u by u when the regexp is
	  made by Ruby 1.8. [ruby-dev:36750]

Wed Jul  8 16:47:03 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_file_s_basename): returns new string instead of
	  shared string from FilePathStringValue().  [ruby-core:24199]

Wed Jul  8 04:28:16 2009  Eric Hodel  <drbrain@segment7.net>

	* ext/.document:  Update with extensions that appear to have
	  documentation.  [ruby-core:24181]

Tue Jul  7 10:12:37 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* io.c (rb_io_ext_int_to_encs): Set external encoding if
	  ext==intern. [ruby-dev:38278]

Mon Jul  6 08:00:10 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* enum.c (enum_to_a): should propagate taint to the return value.
	  [ruby-core:24152]

	* enum.c (enum_sort_by): ditto.

Mon Jul  6 09:31:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (make_curry_proc): should propagate lambda-ness.
	  [ruby-core:24127]

Sun Jul  5 14:04:36 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_threadptr_exec_event_hooks): new function to
	  execute event hooks, with preserving errinfo.  [ruby-core:24118]

Sun Jul  5 08:08:25 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_yield_setup_block_args): restores the firs
	  arg where is overwritten at funcall.  [ruby-core:24139]

Fri Jul  3 19:48:40 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c: undef-ed shome methods.  [ruby-core:24110]

	* complex.c (Numeric#arg): NaN for NaN.  [ruby-core:24116]

Thu Jul  2 07:53:44 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): fixed wrong variable.

Tue Jun 30 18:19:07 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (rb_hash_hash): documentation fix.  a patch from
	  Marc-Andre Lafortune.  [ruby-core:23943]

	* object.c (rb_mod_cmp): ditto.

	* range.c (range_eq): ditto.

	* string.c (rb_str_partition, rb_str_rpartition): ditto.

	* struct.c (rb_struct_s_def): ditto.

Wed Jul  1 08:46:11 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (w_encoding): encodings need extra depth.
	  [ruby-core:24100]

Tue Jun 30 17:44:24 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (reg_match_pos): adjust offset based on characters, not
	  bytes.  [ruby-dev:38722]

	* string.c (rb_str_offset): new function.

	* string.c (rb_str_index_m): no call to rb_reg_adjust_startpos().

Tue Jun 30 16:48:49 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/compile_prelude.rb: use US-ASCII name.

Tue Jun 30 11:05:59 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dln.c (dln_find_1): fixed index overrun.

Mon Jun 29 18:55:55 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dln.c (dln_find_1): fix for files with dots.  [ruby-dev:38588]

Mon Jun 29 17:14:31 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (file_expand_path): should copy original encoding.
	  [ruby-dev:38612]

Sat Jun 27 03:09:04 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (argf_rewind): need to rewind $. and ARGF.lineno.
	  [ruby-core:24046]

	* io.c (struct argf): refactoring on $. and ARGF.lineno behavior.

Fri Jun 26 21:48:30 2009  Tanaka Akira  <akr@fsij.org>

	* ext/pty/pty.c (pty_getpty): check dup failure.

Thu Jun 25 17:58:39 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (argf_binmode_m): should call rb_io_ascii8bit_binmode() to
	  set its encoding to ASCII-8BIT.  [ruby-core:24029]

Thu Jun 25 06:25:49 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* enum.c (first_i): wrong condition for no argument #first.
	  [ruby-core:24017]

Wed Jun 24 15:02:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_set_encode): show the erred file name instead of
	  the file that requires it.  [ruby-core:24006]

Mon Jun 22 16:14:30 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_set_arguments, iseq_compile_each): internal
	  arrays must be hidden.  [ruby-dev:38613]

	* vm.c (Init_top_self): ditto.

Tue Jun 23 01:17:38 2009  Tanaka Akira  <akr@fsij.org>

	* ruby.c (process_options): don't specify .so for encdb here.
	  "." is replaced by "_" in load_encoding.

	* encoding.c (load_encoding): add .so here. 

Mon Jun 22 14:41:47 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (process_options), enc/prelude.rb: encdb and transdb are
	  extension libraries.

	* ruby.c (process_options): set progname earlier.

Sun Jun 21 22:33:05 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* load.c (Init_load): $: must be readonly.  [ruby-dev:38690]

	* ruby.c (ruby_prog_init): $-W must be readonly.  [ruby-dev:38691]

Sun Jun 21 10:47:21 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/fileutils.rb (FileUtils::Entry_#copy_file): open with
	  default umask.  [ruby-core:23952]

Sun Jun 21 10:46:32 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (enc_arg): default interanl encoding may not be set.
	  [ruby-core:23932]

Sat Jun 20 07:17:52 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/monitor.rb (MonitorMixin::extend_object): should use
	  #__send__ instead of #send to avoid possible name conflict.  
	  [ruby-core:23907]

Fri Jun 19 20:53:54 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* encoding.c (rb_enc_name_list): update RDoc.  [ruby-core:23926]

Fri Jun 19 20:44:45 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c: constant COMPLEX_NAME has been removed.

	* rational.c: constant RATIONAL_NAME has been removed.

Fri Jun 19 17:04:59 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (flo_cmp): should always return nil for NaN.

	* numeric.c (flo_cmp): handle infinite value specially using
	  infinite? method internally.  [ruby-dev:38681]

Fri Jun 19 09:28:45 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* numeric.c (*_numerator,*_denominator): moved to rational.c.

	* rational.c (*_numerator,*_denominator): moved from numeric.c.

Fri Jun 19 08:14:07 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* bignum.c (big_lshift, big_rshift): return Bignum always withou
	  normalization.  [ruby-dev:38679]

Thu Jun 18 20:32:11 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* numeric.c ( num_numerator, num_denominator): use
	  to_r [ruby-core:23910].

Thu Jun 18 01:35:51 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (flo_cmp): Infinity is greater than any bignum
	  number.  [ruby-dev:38672]

	* bignum.c (rb_big_cmp): ditto.

Thu Jun 18 01:29:16 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (file_expand_path): drive letter is ascii only.
	  [ruby-dev:38612]

Wed Jun 17 23:46:08 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* rational.c (nurat_coerce): accepts Complex when the imag is
	  exact zero.

Wed Jun 17 16:57:40 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* load.c (rb_f_require): RDoc updated.  a patch from Run Paint Run
	  Run in [ruby-core:23833].

	* load.c (rb_mod_autoload): ditto.  [ruby-core:23835]

Wed Jun 17 12:37:37 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* thread.c (ruby_thread_stack_overflow): call rb_exc_raise() on
	  stack overflows in the signal handler, if sigaltstack is
	  available.  On stack overflow (and with sigaltstack), the signal
	  handler is more likely to have room to create an exception
	  object.  [ruby-core:23813]

Wed Jun 17 08:14:01 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c (nucomp_coerce): accepts Complex instances.

	* rational.c (nurat_coerce): accepts Rational
	  instances. [ruby-core:23859]

Wed Jun 17 07:36:22 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/webrick/httputils.rb (parse_form_data): escape boundary of
	  multipart/form-data when embed in regexp.

Tue Jun 16 22:47:37 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (fptr_finalize): skip close(2) for fd 0,1,2.

Wed Jun 17 00:31:30 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* test/ruby/test_argf.rb (TestArgf#test_skip): updated test
	  according to clarified behavior.

Tue Jun 16 06:40:31 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (argf_skip): should close only when current_file is available.

Mon Jun 15 22:35:31 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* bignum.c (rb_big2db): (-Float::MAX.to_i*2).to_f should return
	  -HUGE_VAL (-Infinity).

Mon Jun 15 18:48:41 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (argf_each_line): should return self.  [ruby-core:23852]

	* io.c (argf_each_byte, argf_each_char): ditto.

Mon Jun 15 17:48:42 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (os_obj_of): invoke garbage collection before iteration, to
	  avoid accessing half recycled object references.  [ruby-dev:38613]

Sat Jun 13 07:06:54 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_f_catch): updated rdoc about generalized argument,
	  and the case without arguments.  [ruby-core:23827]

Sat Jun 13 06:45:46 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_f_throw): fixed rdoc about execption.
	  [ruby-core:23824]

Fri Jun 12 14:56:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (file_expand_path): associate the input encoding when
	  copying an absolute path.  [ruby-dev:38594]

Thu Jun 11 15:27:17 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/prime.rb: documentation typo fixed.  a patch from okkez.
	  [ruby-dev:38586]

Wed Jun 10 18:15:17 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* dir.c (dir_s_getwd): directory path's encoding should be filesystem's
	  one.

	* lib/tmpdir.rb: ditto (but not finished yet.)

Tue Jun  9 22:38:09 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/cmath.rb (log10): raised exception when the given number is
	  a negative real.

Tue Jun  9 15:13:14 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (dir_s_glob): fixed rdoc.  a patch from Joseph Pecoraro a
	  [ruby-core:23767].

Tue Jun  9 10:58:48 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in, win32/Makefile.sub (RMALL): need for distclean-rdoc.

Tue Jun  2 17:32:40 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* enum.c (first_i): Enumerator#first should consume only what is
	  needed.   a patch from Marc-Andre Lafortune.  [ruby-core:23661]

	* enum.c (enum_first): call to_int once for an argument.  based on
	  a patch from Marc-Andre Lafortune.

Tue Jun  2 13:27:21 2009  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/ripper/test_filter.rb: add tests. see [ruby-dev:37856]

Mon Jun  1 11:21:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* cont.c (cont_capture, fiber_store): reraise transferred error.

	* cont.c (fiber_switch): transfers dead fiber error to the previouse
	  or root fiber if the current fiber is dead.  [ruby-core:23651]

Mon Jun  1 07:20:02 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_to_f): returns Inf if
	  exp is bigger than DBL_MANT_DIG.

Sun May 31 23:26:36 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (istrailinggarbage): fixed typo.

Tue May 26 05:39:28 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (FilePathValue): prevent from GC.

	* include/ruby/ruby.h (NUM2LONG): added GCC specific optimization.

Tue May 26 03:38:37 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_each_char, rb_str_each_codepoint): string
	  length must be long.

Mon May 25 08:06:52 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_partition): should use the converted result.  a
	  patch from Marc-Andre Lafortune at [ruby-core:23540].

	* string.c (rb_str_rpartition): ditto.

Mon May 25 05:32:19 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/cgi/core.rb (CGI::HTTP_STATUS): typo fixed.  a patch from
	  Nobuhiro IMAI.  [ruby-dev:38538]

Mon May 25 06:25:38 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* test/ruby/test_hash.rb (TestHash::test_equal2): recursive hashes
	  are handled properly now. ref: [ruby-core:23402]

	* test/ruby/test_m17n.rb (TestM17N#test_sprintf_p): test fixed

Sun May 24 22:48:17 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_exec_recursive_paired): new function for proper
	  handling of recursive arrays.  [EXPERIMENTAL] [ruby-core:23402]

	* array.c (rb_ary_equal, rb_ary_eql, rb_ary_cmp): use above.

	* hash.c (hash_equal): ditto.

Sun May 24 22:39:33 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (syserr_initialize): errno is int.

Sat May 23 18:53:13 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/lib/dl/cparser.rb (DL::CParser#parse_struct_signature):
	  splitting with regexp source string is obsolete.  a patch from
	  Minwoo Lee at [ruby-core:23494].

	* ext/dl/cptr.c (rb_dlptr_cmp): return signed value, and restric
	  to Fixnum.  [ruby-dev:38533]

Fri May 22 18:44:34 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* instruby.rb (rdoc): considers --program-prefix and --program-suffix
	  for the path to ri documents.
	  fixes [ruby-core:23519]. c.f. [ruby-dev:38255].

Wed May 20 20:54:37 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* spec/.gitignore: ignores rubyspec/ and mspec/.

Wed May 20 06:20:05 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/tempfile.rb (Tempfile#unlink): close first for Windows.  a
	  patch from Florian Frank.  [ruby-core:23505]

Wed May 20 00:05:52 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* vm_method.c (rb_attr): should preserve encoding info.
	  [ruby-dev:38498]

Sun May 17 14:23:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (rb_parse_in_eval): returns true in true eval, not in
	  main.  [ruby-dev:38382]

	* parse.y (program): inherits dvars in eval or main.

Sun May 17 13:15:32 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (rb_vm_get_sourceline): should not access out of bound.

Sun May 17 09:31:05 2009  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (foletypelib_name): should return
	  encoded name corresponding to WIN32OLE.codepage.

Sat May 16 18:26:42 2009  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/parser.rb, test/test_parser_1.0.rb: fix foaf:Image
	element causes parse error even if ignore_unknown_element mode.

Sat May 16 18:05:07 2009  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/maker/entry.rb: fix a typo.

Sat May 16 18:02:57 2009  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/maker/feed.rb, test/test_maker_atom_entry.rb,
	test/test_maker_atom_feed.rb: fix duplicated dc:date.
	Reported by Kazuhiro NISHIYAMA. Thanks!!! [ruby-list:46014]

Sat May 16 17:57:39 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/lib/dl/callback.rb (DL#remove_callback_internal): ignore
	  unbound function.  [ruby-dev:38474]

Sat May 16 13:49:24 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (rb_autoload_load): gets rid of false warning.
	  [ruby-core:23466]

Sat May 16 10:59:54 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* sample/drb/dhasenc.rb: add magic comment for encoding.

	* sample/mine.rb: ditto.

	* ext/tk/sample/tcltklib/sample1.rb: ditto.

Fri May 15 15:15:12 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (rb_autoload_load): checks if iv_tbl is valid.
	  [ruby-dev:38456]

Sat May 16 09:19:16 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (magic_comment_encoding): use rb_compile_warning() to
	  show the currently parsing file name.  [ruby-core:23469]

Thu May 21 21:47:34 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/pty/pty.c (getDevice): fixes a mistake in merging r20877.
	  Patch by Takahiro Kambe <taca AT back-street.net>.

Thu May 14 16:07:48 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_ungetbyte): encoding should no
	  be effective.

Sun May 10 11:36:11 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/cfunc.c (rb_dlcfunc_instance_p): new function to check if
	  the argument is an instance of DL::CFunc.

	* ext/dl/cptr.c (rb_dlptr_initialize, rb_dlptr_s_malloc): checks
	  if DL::CFunc.  [ruby-dev:38403].

	* ext/dl/lib/dl/cparser.rb (DL::CParser#parse_signature): strips
	  spaces.  based on a patch from Takashi Tamura in [ruby-dev:38398].

	* ext/dl/lib/dl/value.rb (DL::ValueUtil#wrap_arg): block must be
	  given if arg is not bound.  [ruby-dev:38404]

	* ext/dl/cfunc.c (rb_dlcfunc_instance_p): new function to check if
	  the argument is an instance of DL::CFunc.

Sat May  9 11:14:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_f_catch): gets rid of issue with gcc 4.4.  a patch
	  from Alexey Froloff in [ruby-core:23398].  [ruby-core:22924]

Thu May  7 21:42:51 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_rubyoptions.rb (test_indentation_check): add a test
	  for indentation check.  [ruby-dev:38382]

Thu May  7 16:40:09 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_flatten_bang): returns nil if nothing changed.
	  a patch from Marc-Andre Lafortune in [ruby-core:23382].

Thu May  7 14:26:14 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_sample): negative sample number is invalid.
	  [ruby-core:23374]

Tue May 12 14:35:29 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* win32/Makefile.sub: fixes build failures on win32.
	  fixed by usa.

Tue May 12 13:43:35 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* win32/Makefile.sub: fixes a mistake in merging r22822.

Sun Mar  8 23:02:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (LDFLAGS): always prepends -link.

Mon May 11 23:14:06 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/dl/dl.c (rb_dlhandle_initialize): prohibits DL::dlopen
	  with a tainted name of library.
	  Patch by sheepman <sheepman AT sheepman.sakura.ne.jp>.

	* ext/dl/dl.c (rb_dlhandle_sym): ditto

Mon May 11 22:33:46 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/dl/lib/dl/func.rb (DL::Function#call): prevents
	  passing tainted arguments to a C function.
	  Patch by sheepman <sheepman AT sheepman.sakura.ne.jp>.

	* ext/dl/lib/dl/func.rb (DL::Function#check_safe_obj): 
	  new method for checking #call's arguments.

Tue Mar 10 04:53:16 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (MINIRUBY): keep macro into Makefile.

	* configure.in (RUBY_CHECK_SIZEOF): fix for fallback.

Thu Feb 19 15:47:11 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* template/fake.rb.in: extracted from Makefile.in.

	* configure.in (fake.rb): prefixed with $(arch)-.

Sun Apr 26 20:21:39 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* .gitignore: added.

Fri May  1 13:18:01 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval_intern.h (_longjmp): never return.  see [ruby-core:23241]

Sun Apr 26 20:33:12 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* tool/transcode-tb (ActionMap#generate_node):
	  Use ActionMap#gennode instead of generate_node
	  because of initialization.

Sun Apr 26 18:35:32 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_reopen): keeps pathv for prep_stdio.  [ruby-dev:38131]

Sun Apr 26 15:13:09 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser#parse_in_order): do not make an
	  option from non-option argument.  [ruby-dev:38333]

Sat Apr 25 19:11:13 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (ac_cv_func_daemon): use daemon(3) only on *BSD.

	* process.c (proc_daemon): double fork to ensure not having ctty.
	  [ruby-core:23305]

Sun Apr 19 14:43:18 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (ruby_cleanup): the order of local variables on stack is
	  undefined.  should use outermost VALUE for ruby_init_stack.

Mon Apr 13 11:35:55 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* sprintf.c (rb_str_format): optimize previous commit.
	  [ruby-list:45954]

Mon Apr 13 10:58:54 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* sprintf.c (rb_str_format): check encoding compatibility only on
	  real parts.

Sun Apr 19 13:17:25 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gem_prelude.rb (Gem::QuickLoader#push_gem_version_on_load_path):
	  check for requirement if the gem is installed.  a patch from
	  Kyosuke MOROHASHI at [ruby-dev:38020].

Wed Apr 15 20:24:49 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* array.c (rb_ary_flatten): flatten(0) works as Array#dup.
	  [ruby-core:23168]

	* test/ruby/test_array.rb: add a test for above.

Fri Apr 17 00:45:09 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* dir.c (bracket): fix escape handling for range character in bracket
	  of fnmatch pattern.  e.g., '[a\-c]' should not match 'b'.

Wed Apr 15 11:53:35 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* dir.c (fnmatch_helper): use rb_enc_precise_mbclen and
	  fail if bytes are invalid. [ruby-dev:38307]

Tue Apr 14 18:11:26 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (bracket): if same in bytes, path is matching.
	  [ruby-dev:38305]

Sun Apr 12 19:54:56 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (bracket, fnmatch_helper): compare bytewise first, to get
	  rid of invalid byte sequence.  [ruby-dev:38303]

Wed Apr  8 21:58:12 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* string.c (rb_str_dump): buffer length plus one byte for null
	  terminator.  [ruby-dev:38294]

	* test/ruby/test_m17n.rb (test_str_dump): add a test for above.

Wed Apr  8 20:08:16 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_rstrip_bang): should not sign-expand non-ascii.
	  [ruby-core:23158]

Wed Apr  8 17:29:29 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_str_chop_bang): reset coderange. [ruby-core:23155]

Tue Apr  7 13:14:32 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (LIBRUBY_DLDFLAGS): compatibility version is
	  ruby_version.

Sat Apr  4 17:05:15 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/intern.h (RB_NUM_COERCE_FUNCS_NEED_OPID): macro to
	  check compatibility.  [ruby-dev:38162]

Fri Apr  3 14:02:42 2009  Akinori MUSHA  <knu@iDaemons.org>

	* lib/irb/completion.rb (IRB::InputCompletor::Operators): Add
	  overloadable negative operators.

	* lib/irb/ruby-lex.rb (RubyLex#lex_init): Support overloadable
	  negative operators.

	* lib/irb/ruby-lex.rb (RubyLex#identify_identifier): Minus signs
	  need to be escaped in regexp character class.

	* misc/ruby-mode.el (ruby-font-lock-keywords, ruby-parse-partial):
	  Support overloadable negative operators.

Wed Apr  1 20:37:49 2009  Tanaka Akira  <akr@fsij.org>

	* configure.in (rb_cv_fork_with_pthread): fail if the child process
	  fail.

Mon Mar 30 19:04:25 2009  Tanaka Akira  <akr@fsij.org>

	* .gdbinit (rp): show negative fixnum correctly.

Mon Mar 30 12:12:46 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (eval_string_with_cref): replaces the message if
	  frozen.  [ruby-dev:38208]

Sun Mar 29 08:59:26 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/pathname.rb (Pathname#relative_path_from): compares path
	  components according to system default case-sensitiveness.
	  [ruby-core:22829]

Sat Mar 28 11:10:32 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (ruby.imp): all symbols in static library need to be
	  exported, so that encoding-extensions can be loaded.  based on a
	  patch from Yutaka Kanemoto <kinpoco AT gmail.com> a
	  [ruby-talk:332282].

Fri Mar 27 01:33:37 2009  Tanaka Akira  <akr@fsij.org>

	* time.c (time_cmp): negate the result of reverse comparison.

Fri Mar 27 01:19:50 2009  Tanaka Akira  <akr@fsij.org>

	* bignum.c (rb_cmpint): FIX2INT may fail on LP64 platforms.

Fri Mar 13 21:11:51 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/sdbm/_sdbm.c: should include "ruby/defines.h" as well for
	  prototypes of compatibility functions on Win32 platform.
	  [ruby-core:22870]

Thu Mar 26 11:33:13 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rdoc/ri/paths.rb (RDoc::RI::Paths): considers
	  --program-prefix and --program-suffix.  reapplied r19923.

Mon Mar 23 21:41:14 2009  Akinori MUSHA  <knu@iDaemons.org>

	* ext/dbm/dbm.c (fdbm_initialize): Make the file variable
	  volatile, because FilePathValue() currently does not protect the
	  given variable from GC. (Probably it should)

	* ext/sdbm/init.c (fsdbm_initialize): Ditto.

Mon Mar 23 06:51:16 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/depend (link_so): replaces $(TARGET) with basename of the
	  target.  [ruby-talk:330286]

Wed Mar 18 02:41:33 2009  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb (open_server_inaddr_any): fixed multiple network
	  families problem. a patch from Charl Matthee at [ruby-core:21033].

Tue Mar 17 21:42:54 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/make-snapshot (package): creates .revision.time and passes
	  CHDIR to create prerequisite files.

Tue Mar 17 18:00:55 2009  Akinori MUSHA  <knu@iDaemons.org>

	* enumerator.c (Enumerator#{each_,}{with_index,with_object}): Fix
	  a bug where any parameter but the first one is dropped even if
	  multiple values are yielded with. [Bug #1198]

Tue Mar 17 14:25:16 2009  Tanaka Akira  <akr@fsij.org>

	* lib/pathname.rb (Pathname#sub): set $~ in block.binding.
	  [ruby-dev:38173]

Sun Mar 15 02:09:31 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (bmcall): should not uninitialized variable.  a patch from
	  pegacorn at [ruby-dev:38169].

Sat Mar 14 18:18:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_proc_call, rb_node_arity, bmcall, curry): checks
	  overflow.

	* proc.c (rb_proc_parameters): unnamed_parameters() expects in
	  not VALUE.

Fri Mar 13 09:17:12 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/fileutils.rb (FileUtils#fu_get_gid): stringify group
	  argument before making regexp match.  [ruby-dev:38155]

Fri Mar 13 15:10:43 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl_x509ext.c (ossl_x509ext_set_value): should use
	  OPENSSL_free instead of free.  a patch from Charlie Savage a
	  [ruby-core:22858].

Fri Mar 13 08:06:48 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* util.c (rv_strdup): macro to duplicate nul-terminated string.
	  [ruby-core:22852]

Thu Mar 12 22:14:01 2009  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_ssl.c (ossl_ssl_def_const): use INT2NUM because
	  OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG doesn't fit into Fixnum.

Thu Mar 12 05:22:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (copy_stream_fallback_body): off_t may be larger than long.

	* iseq.c (rb_iseq_disasm): RSTRING_LEN() returns long.

	* process.c (rb_f_sleep): time() needs time_t.

Thu Mar 12 05:12:53 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (ruby_init_stack): range of rlim_cur may be
	  larger than int.

	* missing/vsnprintf.c (BSD_vfprintf): commented out code which has
	  no effect at all.

Wed Mar 11 20:13:38 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/handle.c (rb_dlhandle_sym): RTLD_NEXT is not for symbol
	  name.   [ruby-dev:38150]

Wed Mar 11 13:03:12 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/handle.c (rb_dlhandle_sym): fixed heap corruption.
	  [ruby-core:22822]

Tue Mar 10 13:45:54 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (LDFLAGS): moved -link to TRY_LINK, LINK_SO
	  and so on.  based on a patch by Charlie Savage at
	  [ruby-core:22794]

	* win32/Makefile.sub (config.h): passes LDFLAGS to rbconfig.rb so
	  that extconf.rb could refer it.  [ruby-core:22725]

Wed Mar  4 05:19:27 2009  James Edward Gray II  <jeg2@ruby-lang.org>

  * lib/csv.rb: Some minor documentation fixes from Gregory Brown.

Wed Mar  4 00:54:43 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/prime.rb (Prime::prime?): used to return a wrong answer.
	  [ruby-core:22646].

	* test/test_prime.rb (test_prime?): test case for [ruby-core:22646].

Thu Mar  5 11:27:16 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (miniruby.exe): workaround for a failure of
	  mt.exe on Windows 7 beta.  [ruby-talk:330284]

Wed Mar  4 21:21:51 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/thread.rb (SizedQueue#push): fix limit condition.
	  [ruby-dev:38135]

Wed Mar  4 03:42:56 2009  James Edward Gray II  <jeg2@ruby-lang.org>

	* lib/csv.rb: A patch from Madoka Yakamamoto to prevent an infinite
	  loop while reading some encodings.

Mon Mar  2 21:01:36 2009  Tanaka Akira  <akr@fsij.org>

	* file.c: include fcntl.h for O_RDONLY on Solaris.

Mon Mar  2 19:43:02 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/uri/common.rb (URI::Parser#escape): escaped string is ascii
	  only.

	* lib/uri/common.rb (URI::Parser#unescape): converts bytewise.
	  [ruby-dev:38005], [ruby-dev:38110]

Mon Mar  2 10:50:53 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/handle.c (rb_dlhandle_sym): get rid of buffer overrun,
	  and try ASCII WINAPI versions too.

Mon Mar  2 00:56:45 2009  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/observer.rb: The module oberservable uses now a hash to
	  store listeners. merged a patch from Alessandro Di Maria in
	  [ruby-core:22560].

Sun Mar  1 19:52:46 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/win32/lib/Win32API.rb (initialize): passes res
	  arguments to DL.

Sun Mar  1 19:36:18 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* util.c (ruby_dtoa): allocates one more byte to get rid of buffer
	  overrun.  a patch from Charlie Savage at [ruby-core:22604].

Sun Mar  1 19:10:59 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (.y.c): removed extra backslash.  [ruby-core:22602]

Sun Mar  1 19:02:03 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/cfunc.c (rb_dlcfunc_call): fix for stdcall and missing
	  argument numbers.  [ruby-core:22601]

	* ext/dl/dl.h (DLSTACK_PROTO0_): added.

	* ext/dl/mkcallback.rb (gencallback, gen_callback_file),
	  (rb_dl_init_callbacks): omit stdcall functions unless supported.

	* lib/rubygems/config_file.rb (SHGetFolderPath): stdcall.

Sun Mar  1 17:27:14 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (gfDebug): uncommented out.
	  [ruby-core:22600]

Sun Mar  1 16:15:31 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (rb_waitpid): use wait_each() on no waitpid platforms.
	  [ruby-dev:38054]

Sun Mar  1 16:01:01 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (proc_daemon): stops and restarts timer thread because
	  daemon(3) implies fork(2).  [ruby-dev:38055]

Fri Feb 27 22:02:34 2009  Tanaka Akira  <akr@fsij.org>

	* util.c: fix SEGV by test_time.rb with
	  gcc version 4.4.0 20090219 (Red Hat 4.4.0-0.21) on Fedora 11 Alpha.

Fri Feb 27 18:30:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (cdhash_type, iseq_set_sequence): should not call
	  methods of the argument of case, to keep the semantics of
	  case/when.  [ruby-dev:38079]

Fri Feb 27 18:01:20 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (ruby_get_stack_grow_direction): no needs to use thread
	  here, and not initialized yet.  [ruby-core:22439]

Fri Feb 27 17:45:25 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (file_load_ok): checks if regular file, except for the
	  platform disallows to open directories, e.g. dosish.
	  [ruby-dev:38097], [Bug #1221]

Wed Feb 25 12:27:59 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_force_encoding): should clear coderange at changing
	  encoding.  [ruby-core:22437]

Wed Feb 25 12:06:09 2009    <nobu@ruby-lang.org>

	* io.c (rb_io_getline_1): enables limit even if rs is given.
	  [ruby-core:22434]

Wed Feb 25 02:28:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_chomp_bang): coderange may change.
	  [ruby-core:22414]

Wed Feb 25 02:17:30 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_delete_bang): should recalculate coderange.
	  [ruby-talk:329267]

Tue Feb 24 19:01:05 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (main): split from exts and makes main program after
	  building exts with miniruby, to get rid of overwriting running
	  program.  [ruby-core:22339]

	* Makefile.in, win32/Makefile.sub (RUNCMD, MKMAIN_CMD): macros to
	  run script file.

	* ext/extmk.rb (parse_args): added --command-output option which
	  creates script file to make main program.

Tue Feb 24 17:58:07 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (ripper.c): exec can't work on Windows.

	* ext/ripper/depend (.SUFFIXES): nmake doesn't have .y by default.

	* Makefile.in (id.h): overwrites unconditinally.

Tue Feb 24 13:13:49 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* missing/vsnprintf.c (BSD_vfprintf): ptrdiff_t may be larger than
	  long.

Tue Feb 24 10:49:37 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (rb_waitpid): last argument was missing.

	* process.c (waitall_each): fixed typo.  a patch from shinichiro.h
	  <shinichiro.hamaji AT gmail.com> at [ruby-dev:38054].

Tue Feb 24 01:22:19 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* bootstraptest/test_thread.rb: fix for environment where fork is not
	  available.

Tue Feb 24 01:19:38 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread.c (thread_cleanup_func): unlock all locked mutexes even when
	  forking.  [ruby-core:22269]

Mon Feb 23 14:47:04 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/fileutils.rb (mv): added description for the case of
	  different partitions.  [ruby-talk:329072]

Sun Feb 22 22:42:20 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (tr_trans): should recalculate coderange.
	  [ruby-core:22326] (reopened at [ruby-core:22328])

Sun Feb 22 14:33:06 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (tr_trans): should not be affected by the encoding of
	  replacement unless actually modified.  [ruby-talk:328967]

Fri Feb  6 12:11:24 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ruby.c (process_options): set initial default_external before -r.

Sun Feb 22 10:43:57 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (method_missing): should not pop cfp if missing method
	  is method_missing.  [ruby-core:22298]

	* vm_eval.c (rb_raise_method_missing): new function to directly
	  raise NoMethodError.

	* vm_insnhelper.c (vm_call_method): fixed the case method_missing
	  is missing.

Fri Feb 20 23:28:11 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* util.c (rv_alloc, freedtoa): use our normal xmalloc()/xfree() because
	  couldn't free the returned pointer from ruby_dtoa().

	* missing/vsnprintf.c (cvt): receive buffer and use/return it instead
	  of returning the pointer returned from BSD__dtoa().

	* missing/vsnprintf.c (BSD_vfprintf): pass buf to cvt() as the buffer.
	  [ruby-core:22184]

Thu Feb 19 15:39:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl_ocsp.c (ossl_ocspbres_verify): OCSP_basic_verify
	  returns positive value on success, not non-zero.  [ruby-core:21762]

Wed Feb 18 12:35:31 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_file_s_extname): fix for spaces before extention.
	  [ruby-dev:38044]

Wed Feb 18 10:29:12 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (thread_start_func_2): do not delete main thread from
	  living_threads.  [ruby-core:19385], [ruby-core:22158]

Tue Feb 17 05:41:08 2009  Koichi Sasada  <ko1@atdot.net>

	* compile.c: fix to add "ensure" codes across "while" clause
	  before "return" expression.  [ruby-dev:37967]

	* bootstraptest/test_flow.rb: add a test.

Sun Feb 15 11:45:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (rb_define_hooked_variable): suppress false assertion
	  with VC9.  [ruby-core:22115]

Fri Feb 13 15:11:11 2009  Koichi Sasada  <ko1@atdot.net>

	* vm_eval.c (eval_string_with_cref): use rb_vm_get_ruby_level_next_cfp() 
	  instead of vm_get_ruby_level_caller_cfp().  checking a upper frame
	  is not enough.  [ruby-dev:37984]

	* proc.c, vm_core.h: declare rb_vm_get_ruby_level_next_cfp()
	  on vm_core.h.

Thu Feb 12 22:51:18 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (hide_obj): OBJ_FREEZE() is not an expression.  a patch
	  from nagachika <nagachika00 AT gmail.com> at [ruby-dev:37977].

	* compile.c (insn_set_sc_state): fixed typoe.

Thu Feb 12 19:42:33 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (compile_array_, defined_expr, iseq_compile_each): hide
	  and freeze internal literal objects, to prevent from modifying.
	  [ruby-dev:37959]

	* iseq.c (insn_operand_intern): copy internal literal objects.

	* insns.def (putstring, duparray): ditto.

	* string.c (rb_str_replace): exported.

Thu Feb 12 17:17:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_ungetc): calculates new position
	  before reallocation.  [Bug#1099]

Mon Feb  9 20:11:55 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/win32ole/win32ole.c (load_conv_function51932): fixed for the
	  case IMultiLanguage is not available.  [ruby-dev:37950]

Mon Feb  9 11:31:09 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* io.c (io_encoding_set): ignore second argument when external and
	  internal are same. [ruby-dev:37939]

Sun Feb  8 23:28:05 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* include/ruby/st.h, st.c: order entries by a linked list instead of
	  a loop to fix iteration miss when hash is modified during iteration.
	  [ruby-dev:37910]

Sun Feb  8 22:44:20 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/backward/rubysig.h (rb_thread_blocking_region_begin),
	  (rb_thread_blocking_region_end): marked as deprecated.

	* include/ruby/backward/rubysig.h (TRAP_BEG): fix for C++.  a
	  patch from Aman Gupta at [ruby-core:21934]

Sun Feb  8 19:05:24 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/backward/rubysig.h: extern "C" was missing.
	  [ruby-core:21929]

Sun Feb  8 18:34:43 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_s_binread): ensures file path.  [ruby-dev:37940]

Fri Feb  6 23:28:33 2009  Tanaka Akira  <akr@fsij.org>

	* io.c (io_fread): use rb_io_wait_readable for retry
	  avoid Errno::EINTR on ruby -e 'trap(:CHLD) {}; spawn("sleep 1"); STDIN.read'

Fri Feb  6 20:37:42 2009  Tanaka Akira  <akr@fsij.org>

	* signal.c (register_sigaltstack): ignore sigaltstack error.
	  It fails on OpenBSD 4.4 when pthread library is linked.

Fri Feb  6 12:03:47 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ruby.c (process_options): -K and -E in shebang should be reflect to
	  default_external. [ruby-dev:37920]

Fri Feb  6 02:51:59 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_each_codepoint): update RDoc for
	  String#codepoints.  a patch from Radoslaw Bulat in
	  [ruby-core:21835]

Fri Feb  6 01:09:13 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* cont.c (cont_mark, cont_capture, cont_restore_1): use #else instead
	  of #elif.  a patch from NISHIMATSU Takeshi <t_nissie at yahoo.co.jp>
	  in [ruby-list:45856].

Thu Feb  5 07:39:33 2009  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* ext/readline/readline.c (Init_readline): remove_history(0) may be
	  NULL.  [ruby-dev:37891]

Thu Feb  5 03:55:22 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (LOCALTIME): should call tzset() before localtime_r().
	  [ruby-dev:37896]

Wed Feb  4 11:45:06 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/mkexports.rb: shouldn't export DllMain.
	  reported at http://pc11.2ch.net/test/read.cgi/tech/1233686068/21

Wed Feb  4 10:12:05 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* missing/vsnprintf.c (BSD_vfprintf): should support 't' format
	  modifier to handle PRIdPTRDIFF.  thanks for the info from
	  Kazuhiro NISHIYAMA.  [ruby-core:21807]

Tue Feb  3 23:37:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (load_file_internal): resets EOF flag after parse.

Tue Feb  3 14:12:10 2009  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb: validate data before sending to a server.
	  [ruby-core:20320]

Tue Feb  3 12:09:08 2009  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (hmac_md5): should use String#ord to get ascii
	  code from the one-character string.

Mon Feb  2 17:05:55 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_find_file_ext): should not be infected from other
	  load paths.

Sat Jan 31 19:09:30 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (rb_require_safe): raises when the path to be loaded is
	  tainted.  [ruby-dev:37843]

Mon Feb  2 08:12:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/xmlrpc/server.rb (Server#serve): gets rid of hardcoded
	  platform names. (win64 support)

	* lib/resolv.rb (Resolv::Hosts::DefaultFileName),
	  (Resolv::DNS::Config.default_config_hash): tries win32/resolv on
	  mswin64 too. (win64 support)

	* lib/rubygems/specification.rb (Gem::Specification#ruby_code):
	  aded mswin64. (win64 support)

	* lib/drb/extservm.rb (DRb::ExtServManager#invoke_service_command):
	  spawn is better to start a process in background.

	* ext/extmk.rb: uses FNM_SYSCASE. (win64 support)

	* instruby.rb: installs win32.h on mswin64 platform. (win64 support)
	  [ruby-core:21722]

Mon Feb  2 12:41:52 2009  Shugo Maeda  <shugo@ruby-lang.org>

	* complex.c (f_signbit): regard NaN as a positive value.
	  [ruby-dev:37861].

Mon Feb  2 06:51:36 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* encoding.c (rb_filesystem_encoding): Windows' filesystem encoding is
	  sometimes ANSI code page and sometimes OEM code page. we should check
	  whether code page is used.

Sun Feb  1 05:19:43 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (rb_const_get_0), vm_insnhelper.c (vm_get_ev_const):
	  avoids infinite self recursion autoload.  [ruby-core:21696]

Fri Jan 30 14:31:14 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* tool/make-snapshot (prereq): remove enc.mk from tarball because
	  BSD make checks $(srcdir)/enc.mk and try to run $(builddir)/enc.mk.

Fri Jan 30 14:11:48 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* enc/depend: extract comile rules to each target for VC++.

Fri Jan 30 12:59:49 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* cygwin/GNUmakefile.in (RUBYDEF): depends on makefiles.

	* cygwin/GNUmakefile.in (RUBYDEF): adds DATA to non-function symbols
	  which is not marked as T.

Tue Jan 20 16:17:12 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* cont.c (ruby_Init_{Continuation_body,Fiber_as_Coroutine}): prefixed
	  with ruby_ to export.

	* ext/continuation/continuation.c, ext/fiber/fiber.c: ditto.

Thu Jan 29 16:22:41 2009  Shugo Maeda  <shugo@ruby-lang.org>

	* load.c (rb_feature_provided): should not calculate len by pointer
	  subtraction because feature may be a expanded path.
	  [ruby-core:21267]

Thu Jan 29 14:12:15 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (BASERUBY): erases RUBYOPT at the test.

	* configure.in (OBJCOPY): not used on Windows.

Thu Jan 29 12:29:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rake.rb (FileUtils#rake_system): no longer needs workaround
	  on Windows.  [ruby-core:21339]

	* lib/rake/win32.rb (Rake::Win32#rake_system): ditto.

	* lib/rake/win32.rb (Rake::Win32#win32_system_dir): no longer
	  needs environment variables other than APPDATA now.

	* lib/rake.rb (Rake::Application#standard_system_dir): uses
	  platfrom specific definition on Windows system.

Thu Jan 29 00:24:48 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/zlib/zlib.c (zstream_run): previous change didn't resolve the
	  problem.

Fri Jan 30 01:39:27 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* parse.y (top_compstmt, top_stmts, top_stmt): prohibit BEGIN {} in
	  non-toplevel scope.  [ruby-core:21657]

	* test/ruby/test_beginendblock.rb (test_begininclass): add a test for
	  above.

Wed Jan 28 22:51:12 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/zlib/zlib.c (zstream_run): desperately guard the variable.
	  [ruby-core:20576]

Mon Jan 19 11:46:39 2009  Koichi Sasada  <ko1@atdot.net>

	* vm_eval.c, eval.c (rb_f_block_given_p): move definition of
	  "iterator?" and "block_given?" to make static.

	* vm.c (vm_get_ruby_level_caller_cfp): make it static.

	* eval_intern.h, vm_insnhelper.c: move decl. of
	  vm_get_ruby_level_caller_cfp()
	  from eval_intern.h to vm_insnhelper.c.

Mon Jan 19 11:27:39 2009  Koichi Sasada  <ko1@atdot.net>

	* vm.c: add a prefix "rb_" to exposed functions
	  vm_get_ruby_level_next_cfp(), rb_vm_make_env_object(),
	  vm_stack_to_heap(), vm_make_proc(), vm_invoke_proc(),
	  vm_get_sourceline(), vm_cref(), vm_localjump_error(),
	  vm_make_jump_tag_but_local_jump(), vm_jump_tag_but_local_jump().
  	  This changes may affect only core because most of renamed functions
	  require a pointer of not-exposed struct such as rb_thread_t or NODE.
	  In short, they are core functions.

	* cont.c, eval.c, eval_intern.h, load.c, proc.c, thread.c,
	  vm_core.h, vm_dump.c, vm_eval.c, vm_exec.c, vm_insnhelper.c:
	  ditto.

Mon Jan 19 11:02:30 2009  Koichi Sasada  <ko1@atdot.net>

	* vm_dump.c: add a prefix "rb_vmdebug_" to
	  vm_stack_dump_raw(), vm_stack_dump_raw_current(),
	  vm_env_dump_raw(), vm_proc_dump_raw(), vm_stack_dump_th(),
	  vm_debug_print_register(), vm_thread_dump_regs(),
	  vm_debug_print_pre(), vm_debug_print_post(),
	  vm_thread_dump_state().
	  This change also may affect core (in fact, user of
	  above functions may be only ko1).

	* vm_core.h: ditto.

	* vm_exec.h (SDR2): remove duplicate definition.

Mon Jan 19 09:53:43 2009  Koichi Sasada  <ko1@atdot.net>

	* iseq.c:
	  rename ruby_iseq_disasm_insn() -> rb_iseq_disasm_insn().
	  rename ruby_iseq_disasm() -> rb_iseq_disasm().

	* compile.c:
	  rename ruby_iseq_compile() -> rb_iseq_compile_node().
	  rename ruby_iseq_translate_threaded_code() ->
	         rb_iseq_translate_threaded_code().
	  rename ruby_insns_name_array() -> rb_insns_name_array().
	  rename ruby_iseq_build_from_ary() -> rb_iseq_build_from_ary().

	* iseq.c, compile.c: remove ruby_insn_make_insn_table() and make
	  static function insn_make_insn_table().

	* iseq.h, ruby.c, vm.c, vm_core.h, vm_eval.c, vm_dump.c, 
	  blockinlining.c: ditto.
	  Rename strange "ruby_" prefix to "rb_" prefix.
	  This changes may affect only core because renamed functions
	  require a pointer of rb_iseq_t which is not exposed.

Mon Jan 19 08:56:53 2009  Koichi Sasada  <ko1@atdot.net>

	* eval.c, vm_eval.c (rb_f_local_variables): move definition from eval.c
	  to vm_eval.c because vm_collect_local_variables_in_heap() should
	  be static function.

	* vm.c (vm_collect_local_variables_in_heap): make it static.

Tue Jan 27 14:41:33 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* cygwin/GNUmakefile.in (RUBYDEF): needs DATA marks to export
	  non-function symbols.  [ruby-core:21582]

	* win32/mkexports.rb (Exports::Mingw#each_export): ditto.

Sun Jan 25 12:17:21 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* cygwin/GNUmakefile.in (RUBYDEF): needs read-only section too.

Tue Jan 20 15:32:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in (miniruby): renames and then removes, to get rid of
	  EPERM on cygwin and mingw.

	* Makefile.in ($(LIBRUBY_SO)): use wildcard option of objcopy.

	* configure.in (DLDFLAGS): do not export all symbols.

	* cygwin/GNUmakefile.in (RUBYDEF): rejects symbols prefixex with
	  Init_.

	* win32/mkexports.rb (Exports::Mingw): includes all symbols except for
	  prefixed with Init_ as well as mswin32.

Wed Jan 28 15:24:11 2009  TAKANO Mitsuhiro (takano32)  <tak@no32.tk>

	* math.c: SEGV is caused by implicit rb_to_float declaration
	  test_complexrational.rb: [BUG] in IA-64 architecture

Tue Jan 27 03:23:43 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): should point correct path to
	  ruby.h and defines.h.   [ruby-core:21570]

Mon Jan 26 16:00:40 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_aset): fixed arguments evaluation order.

Sun Jan 25 12:02:56 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (clean-ext): condition of EXTS was inverted.

Sun Jan 25 11:50:20 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (create_makefile):fixed the variables order because
	  converter proc refers the separator.

Sun Jan 25 11:25:10 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in, win32/Makefile.sub (RMDIRS): remove directory and
	  parents.

	* Makefile.in, win32/Makefile.sub (distclean-rdoc): added to remove
	  temprary rdoc.

	* Makefile.in, win32/Makefile.sub (clean-ext): skips non-existent
	  directories.

	* common.mk (clean, distclean): cleans rdoc.

	* common.mk (clean-extout): removes extout directory.

	* configure.in (RMDIRS, RMALL): added to clean extout.

	* lib/fileutils.rb (FileUtils#rmdir): added :parents option.

	* lib/mkmf.rb (create_makefile): cleans installed files at clean
	  instead of distclean.

	* lib/mkmf.rb (create_makefile): added clean-so and clean-rb.

	* lib/mkmf.rb (def init_mkmf): added DISTCLEANDIRS.

	* lib/un.rb (rmdir): added -p option.

	* tool/rmdirs, win32/rmdirs.bat: removes directory and the parents.

	* win32/rm.bat: added -r option.

Sun Jan 25 09:09:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (join_path): use strlcat() to force link.

	* dir.c (glob_helper): no strcpy() is needed since len is known.

Sat Jan 24 08:22:35 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (configuration): tools under the top source
	  directory are not installed, so unusable outside extmk.rb.

Fri Jan 23 17:24:31 2009  WATANABE Hirofumi  <eban@ruby-lang.org>

	* golf_prelude.rb (Enumerator#inspect): avoid warning.

Fri Jan 23 15:12:52 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (mkintpath): new function which converts native path
	  to format acceptable in Makefile.

	* lib/mkmf.rb (configuration): leaves PATH_SEPARATOR unchanged.

	* lib/mkmf.rb (configuration): convers srcdir, topdir and hdrdir.
	  a patch by Alexey Borzenkov <snaury AT gmail.com> at
	  [ruby-core:21448].

	* lib/mkmf.rb (try_func): got rid of c-mode confusion.

Fri Jan 23 13:26:45 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* signal.c (trap_handler): also accepts symbols.  [ruby-dev:37823]

Thu Jan 22 18:14:04 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): removes installed files under
	  extout at distclean.

Thu Jan 22 17:12:37 2009  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/core.rb (CGI.parse): generate only key on params hash
	  if request have only key uri parameters.
		(ex. index.cgi?aaa&bbb=1 # params=>{:aaa=>[],:bbb=>["1"]})

	* test/cgi/test_cgi_core.rb: fix test for key only params.

Thu Jan 22 16:29:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rubygems/installer.rb (Gem::Installer#initialize): fixed
	  typos.

Thu Jan 22 14:53:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_process.rb (MANDATORY_ENVS): needs RUBYLIB to run
	  tests without install.

Thu Jan 22 12:19:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (define_final): cannot define finalizer for immediate
	  values.  [ruby-core:21500]

	* gc.c (define_final): freezes or hides internal values.

Thu Jan 22 11:33:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_time_timeval): made a real prototype.  a patch from
	  Marcus Rueckert <darix AT opensu.se> at [ruby-core:21492].

Wed Jan 21 21:43:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_ungetbyte, rb_io_ungetc): allows nil to reset EOF
	  flag with ungetting nothing.

	* ruby.c (load_file_internal): rests EOF flag to make possible to
	  load from stdin after reading data.

Wed Jan 21 15:32:15 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_ungetbyte, rb_io_ungetc): clears EOF flag.

Wed Jan 21 13:58:17 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/io.h (FMODE_EOF): EOF flag on TTY.

	* io.c (io_set_eof): sets EOF flag for TTY.

	* io.c (io_seek): clears EOF flag.

	* io.c (io_fillbuf): returns EOF if already met EOF.  [ruby-dev:37798]

	* io.c (io_fillbuf, io_fread, io_getpartial): sets EOF.

Wed Jan 21 14:41:48 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* array.c (take_items): to_ary() raises ArgumentError if cannot to
	  convert to Array. [ruby-dev:37797]

Wed Jan 21 21:12:47 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* introduces r21693 again for merging r21713.

Tue Jan 20 19:12:18 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* reverts r21693.

Tue Jan 20 18:49:59 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/rdoc/ri/path.rb: Gem::Enable was removed.
	  Use just defined?(Gem).
	  And this prevents unexpected directory creation at
	  installation. [ruby-core:20990]

Tue Jan 20 17:59:52 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* Reverts r21598 and r21599 because the original behavior is
	  intentional.

Tue Jan 20 09:26:05 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/nkf/nkf-utf8/nkf.c (nkf_buf_push): maybe a bug.

	* ext/nkf/nkf-utf8/nkf.c (options): no need to support help option.

Tue Jan 20 06:48:56 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (take_items), enum.c (enum_zip): tries to convert to
	  array first.  [ruby-core:21442]

Tue Jan 20 03:50:37 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/nkf.c: Update nkf to 2.0.9.
	  revert -s meaning as Shift_JIS, etc.

Mon Jan 19 14:31:59 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_thread_execute_interrupts): needs
	  rb_signal_buff_size to be declared.

Mon Jan 19 13:34:25 2009  Koichi Sasada  <ko1@atdot.net>

	* ruby.c (require_libraries): reset th->parse_in_eval while
	  loading libraries.  fixes [ruby-dev:37780]

Sat Jan 17 21:04:27 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/erb.rb: changes style of the rdoc for suppressing
	  warning. [ruby-core:21117] 

Sat Jan 17 17:58:22 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/xmp.rb: multilingualizes XMP::StringInputMethod.
	  [ruby-core:21383].

Sat Jan 17 11:12:21 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_dump.c (vm_stack_dump_each): initialized at declarations.

	* vm_dump.c (rb_vm_bugreport): constified to suppress a warning.

Sat Jan 17 19:33:48 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* configure.in (VCSUP): fixed the cases for git-svn or git.

	* win32/Makefile.sub (VCSUP): ditto.

	* Makefile.in (up): `cd' is necessary for git and git-svn.

Fri Jan 16 18:51:11 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (up): tell nmake that need to run command via
	  shell.

Fri Jan 16 17:33:59 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (Makefile): set VCS and VCSUP to support `git svn'
	  and git.

	* Makefile.in, win32/Makefile.sub (up): split from common.mk.

Mon Dec 29 22:37:57 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_pack): template f should not accept non float
	  values.  [ruby-dev:37656]

Fri Jan 16 18:43:30 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/make-snapshot (package): includes all rules and expand
	  configured values from the environment to create *.inc, sets RM
	  for ripper.c, and needs chdir if absolute path is given with
	  -exported option.

Thu Jan 15 14:27:27 2009  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* LEGAL: Added information for missing/langinfo.c

Fri Jan 16 13:39:24 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/minitest/unit.rb: temporarily merges Kouji's patch without
	  maintainer's permission in order to release 1.9.1 RC2. 
	  [ruby-core:21364] .
	  Patch by Takao Kouji <kouji AT takao7.net>.

Fri Jan 16 13:28:09 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/minitest/test_mini_test.rb: the number of assertions must be
	  exactly equal to the number of assertion method calls that the end-user
	  would write. [ruby-dev:37703]

	* test/minitest/test_mini_spec.rb: ditto.

	* lib/minitest/unit.rb: ditto. 
	  Patch by David Flanagan <david AT davidflanagan.com>. [ruby-core:21350]

Fri Jan 16 12:24:39 2009  Koichi Sasada  <ko1@atdot.net>

	* thread.c (thread_start_func_2): call ruby_cleanup() if thread is
	  main thread.  [ruby-dev:37624]

Fri Jan 16 12:27:50 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub ($(INSNS), node_name.inc, known_errors.inc,
	  miniprelude.c, newline.c): if dependencies is newer than targets or
	  targets don't exist, try to create targets with BASERUBY. no need to
	  detect errors there because the absence of BASERUBY is not abnormal.
	  after the try, if the targets still don't exist, copy them from
	  $(srcdir).

Fri Jan 16 11:47:56 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_parse_in_main): fixed typo.

Fri Jan 16 02:25:46 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread.c (rb_thread_execute_interrupts): if signal is already
	  buffered, main thread should wait until timer thread delivers it.

	* thread.c (timer_thread_function): should defer delivery of a signal
	  if main thread does not yet trap a previous one.  [ruby-dev:37676]

Fri Jan 16 01:42:50 2009  Koichi Sasada  <ko1@atdot.net>

	* thread.c (call_trace_proc): as Matz said ([ruby-core:21183]),
	  should skip rb_str_new2() if rb_sourcefile() returns NULL.
	  rb_sourcefile() returns NULL if frame is toplevel of Fiber.
	  [ruby-core:21161] [Bug #985]

Fri Jan  9 12:29:46 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (test-sample), rubytest.rb: use runruby.rb

Fri Jan 16 01:09:37 2009  Koichi Sasada  <ko1@atdot.net>

	* ruby.c (process_options): decrement parse_in_eval to recognize
	  parsing main or normal eval script.

	* compile.c (rb_parse_in_main): return 1 if parsing main script.
	 (if parse_in_eval is negative value, it means main script)

	* parse.y (yycompile0): check rb_parse_in_main() to accumulate
	  script text.  Bug #848 [ruby-core:20450]

Fri Jan 16 00:57:34 2009  Koichi Sasada  <ko1@atdot.net>

	* lib/debug.rb: as wanabe-san pointed out,
	  set_trace_func should be completely final task in debug.rb.
	  Bug #847 [ruby-core:20449]

Fri Jan 16 00:27:03 2009  Koichi Sasada  <ko1@atdot.net>

	* vm.c (rb_vm_inc_const_missing_count, ruby_vm_const_missing_count): 
	  added.

	* vm_insnhelper.h: ditto.

	* variable.c (rb_const_get_0), insns.def: Constants should not be
	  cached if const_missing is called.  [ruby-core:21059] [Bug #967]

	* bootstraptest/test_class.rb: add a test.

Fri Jan 16 00:25:09 2009  Koichi Sasada  <ko1@atdot.net>

	* common.mk: btest-ruby should receive option with OPTS.

Fri Jan 16 00:21:10 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub ($(INSNS), node_name.inc, known_errors.inc,
	  miniprelude.c, newline.c): shoudn't copy when $(srcdir) != ".", too.
	  (this is a workaround.  we need more strict check.)

	* win32/Makefile.sub ($(INSNS)): shound't remove BASERUBY.

Fri Jan 16 00:19:55 2009  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_with_gvl): suppress warnings.

Thu Jan 15 20:44:30 2009  Tanaka Akira  <akr@fsij.org>

	* tool/file2lastrev.rb: RUBY_REVISION must be an integer.

Thu Jan 15 15:55:31 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* encoding.c (enc_set_default_encoding): should not treat US-ASCII
	  special here.  a patch from Yui NARUSE in [ruby-dev:37769].
	  [ruby-dev:37699]

Thu Jan 15 13:10:09 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in, win32/Makefile.sub (MISSING): added langinfo on mingw
	  and mswin.

	* encoding.c (rb_locale_charmap): use environments on mingw and mswin.

	* missing/langinfo.c (nl_langinfo_codeset): MS-Windows Japanese
	  environment uses Windows-31J derived from Shift_JIS, not EUC-JP.

Thu Jan 15 12:10:39 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub ($(INSNS), node_name.inc, known_errors.inc,
	  miniprelude.c, newline.c): copy only when $(srcdir) != pwd.

Wed Jan 14 23:57:28 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (rb_locale_charmap): fallback to codepage if no
	  locale is found.  [ruby-core:21110]

	* missing/langinfo.c (nl_langinfo_codeset): returns NULL if no
	  locale is found.

Wed Jan 14 22:38:30 2009  Tanaka Akira  <akr@fsij.org>

	* gc.c (negative_size_allocation_error_with_gvl): abolish a warning.
	  (negative_size_allocation_error): ditto.

	* ext/openssl/ossl.c (ossl_raise): ditto.

Thu Jan 15 13:10:58 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (COMPILERFLAG): for enc/trans/gb18030.c.

Thu Jan 15 00:06:12 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/trans/gb18030.trans: get rid of a 1.9 feature for cross
	  compile.  [ruby-core:21345]

Wed Jan 14 20:05:05 2009  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/trans/gb18030.trans, gb18030-tbl.rb:
	  new Chinese GB18030 transcoding (from Yoshihiro Kambayashi)

	* test/ruby/test_transcode.rb: added tests for the above
	  (from Yoshihiro Kambayashi)

	* transcode_data.h, transcode.c, tool/transcode_tblgen.rb:
	  added support for GB18030-specific 4-byte sequences
	  (with Yoshihiro Kambayashi)

Wed Jan 14 16:16:19 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/curses/extconf.rb: check ncursesw earlier than ncurses to
	  support UTF-8 strings.   non UTF-8 strings should be converted
	  explicitly.   [ruby-core:21094]

Wed Jan 14 13:09:00 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/extconf.rb (gai_strerror): checks if available and if
	  returns const pointer.

	* ext/socket/getaddrinfo.c (gai_strerror): defines only if non
	  available.  [ruby-core:21328]

Wed Jan 14 12:39:16 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_wait_readable, rb_io_wait_writable): need rb_fd_ptr.

	* io.c (appendline): reformed.

	* io.c (rb_io_s_pipe): reduced nest of rb_ensure of main block.

Tue Jan 13 21:45:53 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/ostruct.rb (OpenStruct#inspect): fixed the recursion check.
	  Patch by Kornelius Kalnbach.  [ruby-core:20992].

	* test/ostruct/test_ostruct.rb: test for inspect.
	  Patch by Kornelius Kalnbach.  [ruby-core:20992].

Tue Jan 13 21:28:14 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* object.c (rb_obj_not_match): rdoc.
	  Patch by Kornelius Kalnbach.  [ruby-core:20991]

Tue Jan 13 21:44:30 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (io_reopen, rb_io_init_copy): should register fptr to pipe_list
	  when copying pipe fptr.

Tue Jan 13 18:21:44 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (rb_io_close_read): call rb_io_fptr_cleanup() instead of
	  fptr_finalize() because the fptr has special finalizser if it is a
	  pipe.  [ruby-dev:37757] (3)

Tue Jan 13 18:19:49 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (rb_io_initialize): workaround for Windows. [ruby-dev:37686]
	  (also see [ruby-dev:37721])

Tue Jan 13 17:29:02 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/trans/make_transdb.rb (converters): should not depend on the
	  hash order for cross compile.

Tue Jan 13 16:39:11 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/intern.h, thread.c, win32/Makefile.sub (rb_fdset_t,
	  rb_fd_init, rb_fd_term, rb_fd_zero, rb_fd_set, rb_fd_clr, rb_fd_isset,
	  rb_fd_select, rb_fd_ptr, rb_fd_max, HAVE_RB_FD_INIT): new type,
	  functions, and macros for Windows.

	* win32/win32.c (extract_fd, rb_w32_select): use rb_fdset_t to expand
	  fd_array if needed.  [ruby-core:19946]

	* win32/win32.c (copy_fd): new funcion for rb_w32_select().

Tue Jan 13 12:31:54 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* tool/file2lastrev.rb (get_revisions): fixes problem with
	  svn on cygwin. [ruby-dev:37702].
	  Patch by Kouhei Sutou.

Tue Jan 13 11:58:04 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/input-method.rb: IRB did not prompt for MSwin32.
	  [ruby-dev:37686].
	  Patch by arton <artonx AT yahoo.co.jp>.

Tue Jan 13 12:10:42 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/socket/{getaddrinfo,getnameinfo}.c: need to include ws2tcpip.h
	  on Windows.

Tue Jan 13 03:07:28 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* instruby.rb: require "tool/mdoc2man.rb" before chdir if needed.

Tue Jan 13 02:54:54 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/socket/extconf.rb: use headers instead of "netdb.h" in checking
	  getnameinfo() and getaddrinfo() because Windows doesn't have it.
	  [ruby-dev:37757] (1)

	* ext/socket/sockport.h (SA_LEN): use sockaddr_in6 when defined AF_INET6
	  if INET6 is not defined.  winsock2's getaddrinfo() returns
	  sockaddr_in6 if ipv6 is available.

Wed Jan 14 13:19:21 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (rb_w32_aspawn): should not escape with carret
	  unless using cmd.exe.

Tue Jan 13 02:21:43 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (internal_cmd_match): extracted from
	  is_internal_cmd.

	* win32/win32.c (argv_size, join_argv): escapes redirection, pipe
	  and carret punctuations with carrets.

	* win32/win32.c (rb_w32_aspawn): ditto, and redirections and pipe
	  have no meanings.

Tue Jan 13 02:07:38 2009  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: use Encoding.find("locale") instead of
	  Encoding.locale_charmap

Tue Jan 13 00:57:56 2009  Tanaka Akira  <akr@fsij.org>

	* ext/socket/socket.c (sock_s_unpack_sockaddr_in): check too short
	  sockaddr.
	  (sock_s_unpack_sockaddr_un): ditto.

Mon Jan 12 17:23:05 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb (assert_nothing_raised): removes the
	  current trace to get rid of an issue of MiniTest::Unit#location.

Mon Jan 12 16:49:20 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* instruby.rb (install): erased a garbage.

Mon Jan 12 16:45:28 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (open_dir_handle): extracted from rb_w32_opendir.

	* win32/win32.c (winnt_stat): gets rid of strange behavior of
	  GetFileAttributes().  [ruby-core:21269]

Mon Jan 12 11:59:19 2009  Koichi Sasada  <ko1@atdot.net>

	* gc.c (ruby_xmalloc, ruby_xrealloc, ruby_xfree):
	  enable to use them without GVL.
	  if GC is invoked, acquire GVL during GC.
	  if NoMemoryError is raised, acquire GVL and raise it.

Mon Jan 12 10:39:19 2009  Koichi Sasada  <ko1@atdot.net>

	* thread.c: fix comment (terminology: Global VM Lock).

	* thread.c (blocking_region_begin, blocking_region_end):
	  save and clear th->blocking_region_buffer.

	* thread.c (rb_thread_call_with_gvl): check if it has GVL.

	* thread.c (ruby_thread_has_gvl_p): added.

	* vm_core.h: add decls.

Sun Jan 11 16:53:14 2009  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/erb.rb (PercentScanner): remove PercentScanner. fixed % after
	  %> bug. [ruby-dev:37751] [Bug #997] 

	* test/erb/test_erb.rb: ditto

Sun Jan 11 09:47:30 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_s_create): set nil as the value if assoc length
	  is not enough.  [ruby-core:21249]

Sat Jan 10 20:26:17 2009  Tanaka Akira  <akr@fsij.org>

	* version.h: make version string succinct:
	  "ruby 1.9.1p5000 (2009-01-10 trunk 21414) [i686-linux]".

Sat Jan 10 19:05:13 2009  Koichi Sasada  <ko1@atdot.net>

	* cont.c (cont_restore_1): should not be inlined.

Fri Jan  9 13:20:08 2009  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: rescue abnormal Encoding.locale_charmap value.

Fri Jan  9 10:40:52 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_process.rb (TestProcess::MANDATORY_ENVS): some
	  platforms need environments for shared objects.

Thu Jan  8 17:32:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* instruby.rb: should not depend on a library which does not exist
	  in 1.8.

Wed Jan  7 22:13:03 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* instruby.rb (man, gem): fixed errors.

Wed Jan  7 17:14:40 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* instruby.rb: use installed libraries.  [ruby-core:21006]

Wed Jan  7 17:13:38 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>
 
 	* instruby.rb (gem), lib/rubygems/defaults.rb (Gem.default_dir):
 	  use version invariant configuration.

	* instruby.rb: use installed libraries.  [ruby-core:21006]

	* instruby.rb (gem), lib/rubygems/defaults.rb (Gem.default_dir):
	  use version invariant configuration.

Thu Jan  8 00:31:58 2009  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit/assertions.rb (assert_no_match): don't count up as two
	  assertions.

Mon Jan  5 12:52:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (init_env): use user profile folder than personal
	  folder.

Mon Jan  5 17:59:43 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (cygwin): needs properly implemented nl_langinfo().
	  [ruby-core:21110]

	* missing/langinfo.c: added as suggested at [ruby-core:21015], from
	  http://www.cl.cam.ac.uk/~mgk25/ucs/langinfo.c.

	* missing/langinfo.c (nl_langinfo_0): fixed typos for SJIS.

Mon Jan  5 17:38:40 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* encoding.c (rb_locale_charmap): use GetConsoleCP() instead of
	  GetACP() because external encoding should be console's one.

	* encoding.c (rb_filesystem_encoding): use GetOEMCP() instead of
	  GetACP() because VFAT/FAT32 uses OEM CP.

Mon Jan  5 16:26:48 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (rb_filesystem_encoding): use ANSI codepage for file
	  system on cygwin.

	* encoding.c (rb_locale_charmap): reverted.  [ruby-core:21110]

Mon Jan  5 16:15:00 2009  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* ext/curses/curses.c (free_window): use xfree instead of free.
	  [ruby-dev:37200]

Mon Jan  5 08:41:13 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_file_s_stat): need type check for non string values.
	  [ruby-dev:37673]  fix: #964

	* file.c (rb_file_s_size, rb_file_s_atime, rb_file_s_mtime,
	  rb_file_s_ctime, rb_f_test): ditto.

Mon Jan  5 07:58:37 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* random.c (rb_f_srand): update RDoc.  [ruby-core:21113]

Thu Jan  8 07:30:52 2009  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb (OpenURI.redirectable?): reverted https redirection.

Sun Jan  4 18:10:10 2009  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/trans/gbk.trans, gbk-tbl.rb:
	  new Chinese GBK transcoding (from Yoshihiro Kambayashi)

	* test/ruby/test_transcode.rb: added tests for the above
	  (from Yoshihiro Kambayashi)

Sun Jan  4 17:55:55 2009  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* test/ruby/test_transcode.rb: added tests for GB2312
	  (from Yoshihiro Kambayashi)

	* enc/trans/chinese.trans: set valid byte patterns for
	  GB2312 and GB12345

Sun Jan  4 17:39:39 2009  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/trans/big5.trans, big5-tbl.rb:
	  new Chinese Big5 transcoding (from Yoshihiro Kambayashi)

	* test/ruby/test_transcode.rb: added tests for the above
	  (from Yoshihiro Kambayashi)

Sun Jan  4 15:41:37 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (rb_filesystem_encoding, rb_locale_charmap): uses
	  codepage on cygwin.  [ruby-core:20994]

Sun Jan  4 11:58:43 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* numeric.c (ruby_float_step): extracted from num_step().

	* range.c (range_step): uses ruby_float_step() for float range.
	  [ruby-dev:37691]

Sun Jan  4 11:11:31 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/extmk.rb (extmake): does not use both of makefile.rb and
	  extconf.rb at the same time.

	* lib/mkmf.rb (DLLIB): depends on Makefile.  [ruby-core:21096]

Sun Jan  4 03:30:18 2009  Tanaka Akira  <akr@fsij.org>

	* io.c (maygvl_copy_stream_wait_read): renamed to add prefix to
	  express GVL state.
	  (nogvl_copy_stream_wait_write): ditto.
	  (nogvl_copy_stream_sendfile): ditto.
	  (maygvl_copy_stream_read): ditto.
	  (nogvl_copy_stream_write): ditto.
	  (nogvl_copy_stream_read_write): ditto.
	  (nogvl_copy_stream_func): ditto.

Sun Jan  4 00:30:50 2009  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/erb.rb: merged r20850, r17881, r16811, r16763, r16748, r15829, 
	  r15794 and r15698 from ruby_1_8.

	* test/erb/test_erb.rb: ditto.

Sat Jan  3 22:24:36 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* common.mk, Makefile.in, win32/Makefile.sub (INSNS): move the macro
	  definition from common.mk to {Makefile.in,win32/Makefile.sub}.
	  [ruby-dev:37678]

Sat Jan  3 15:30:09 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* enc/trans/chinese.trans: added for transcoding EUC-CN and GB12345.

	* enc/trans/GB/: ditto.

Sat Jan  3 15:26:30 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* enc/trans/euc-cn.c: renemed from gb2312.c because GB2312 is
	  the name of a CSS.  it's encoding name is "EUC-CN".

Sat Jan  3 03:00:42 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* common.mk, Makefile.in, win32/Makefile.sub ($(INSNS), node_name.inc,
	  known_errors.inc, miniprelude.c, newline.c): move rules from common.mk
	  to {Makefile.in,win32/Makefile.sub} for nmake.
	  [ruby-core:20993]

Fri Jan  2 23:51:41 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_sleep.rb (test_sleep_5sec): stop gc.

Fri Jan  2 23:36:10 2009  Tanaka Akira  <akr@fsij.org>

	* ext/socket/socket.c: don't apply socktype hack [ruby-core:184] for
	  sock_s_getaddrinfo.
	  (sock_getaddrinfo): add socktype_hack argument.
	  (sock_addrinfo): call sock_getaddrinfo with socktype_hack.
	  (sock_s_getaddrinfo): call sock_getaddrinfo without socktype_hack.
	  [ruby-dev:37674]

Fri Jan  2 23:33:38 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/missing.h, sprintf.c: get rid of a warning of VC++.

Fri Jan  2 10:20:24 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/singleton.rb: fix documentation. [ruby-core:21038]

Fri Jan  2 22:25:46 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* process.c: use sigaction instead of sigset.  [ruby-core:21021]

Fri Jan  2 22:20:46 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_process.rb (test_wait_and_sigchild): remove debug
	  output.

Fri Jan  2 06:43:58 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* signal.c (rb_signal_buff_size): defined for check whether signal
	  is in the buffer or not.

	* thread_pthread.c (thread_timer): don't exit the loop when signal
	  is in the buffer. [ruby-dev:37637]

Thu Jan  1 22:27:55 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* spec/default.mspec: fix for builddir != srcdir

	* Makefile.in: ditto.

Thu Jan  1 20:50:09 2009  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* process.c (before_exec): it makes no sense for a conditional
	  expression to return a void value.

Thu Jan  1 15:08:46 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* tool/flie2lastrev.rb: supports git repositories which are cloned
	  from a git-svn gateway.
	  Patch by Hongli Lai. [ruby-core:21020]

Thu Jan  1 07:42:36 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/singleton.rb: fix indentation of RDoc text.  [ruby-core:21029]

Thu Jan  1 07:16:44 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in (distclean-ext, realclean-ext): use EXTS as default.

	* win32/Makefile.sub (distclean-ext, realclean-ext): try to remove ext
	  directory.

Thu Jan  1 06:56:28 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/file2lastrev.rb: unset PWD.

Wed Dec 31 14:12:35 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_to_float): replaced by to_flo definition from
	  math.c  [ruby-dev:37668]

	* math.c (Need_Float): use rb_to_float().

Wed Dec 31 19:35:57 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* spec/README: follows the change of directory structure in rubyspec.

	* spec/default.mspec: ditto. Also follows change of mspec command.

	* Makefile.in: ditto.

Wed Dec 31 15:45:18 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (copy_stream_body): don't check to_io because
	  Zlib::GzipWriter#to_io returns the underlying IO.

Wed Dec 31 14:52:33 2008  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_digest.c (GetDigestPtr): use StringValueCStr
	  instead of STR2CSTR.

	* ext/openssl/ossl_pkey_ec.c (ossl_ec_key_initialize): ditto.
	  (ossl_ec_group_initialize): ditto.

Tue Dec 30 21:17:00 2008  Tanaka Akira  <akr@fsij.org>

	* ext/socket/mkconstants.rb: use sock_define_uconst for INADDR_*
	  constants because Socket::INADDR_LOOPBACK should be 0x7f000001
	  instead of -0xffffff.

	* ext/socket/socket.c (sock_define_uconst): defined.

Tue Dec 30 18:23:10 2008  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/minitest/*.rb: Imported minitest 1.3.1 r4506.
	* test/minitest/*.rb: ditto.

Tue Dec 30 17:59:59 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* transcode.c: Minor fixes and tweaks in documentation.

Tue Dec 30 17:03:51 2008  Koichi Sasada  <ko1@atdot.net>

	* ext/dl/test/test_import.rb: fix a prototype decl.
	  pointed out by Takehiro Kubo [ruby-core:20971].

Tue Dec 30 16:56:09 2008  Koichi Sasada  <ko1@atdot.net>

	* thread.c (rb_thread_blocking_region): add a comment.

	* thread.c (rb_thread_call_without_gvl): added as a alias of
	  rb_thread_blocking_region().

	* thread.c (rb_thread_call_with_gvl): added.

	* vm_core.h (rb_thread_t#blocking_region_buffer): added for
	  rb_thread_call_with_gvl().

Mon Dec 29 22:37:17 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* process.c (rb_waitpid): retries waitpid when EINTR.
	  [ruby-core:19744].

Mon Dec 29 23:41:42 2008  Koichi Sasada  <ko1@atdot.net>

	* ext/dl/test/test_base.rb: add libc search logic.
	  this patch is written by Takehiro Kubo.
	  [ruby-core:20963] [Bug #932]

	* ext/dl/dl.h: Add ",..." as the last argument.
	  this patch is written by Takehiro Kubo.
	  Bug #633 [ruby-core:19289]

	* ext/dl/lib/dl/stack.rb: add add_padding() to calculate
	  alignment.  this patch is written by Takehiro Kubo.
	  Bug #633 [ruby-core:19289]

	* ext/dl/test/test_func.rb: atof()'s return value is double.
	  this patch is written by Takehiro Kubo.
	  Bug #633 [ruby-core:19289]

	* ext/dl/test/test_import.rb:
	  - atof()'s return value is double.
	  - The types of qsort's second and third argument are size_t.
	  - fprintf()'s return value is int.
	  this patch is written by Takehiro Kubo.
	  Bug #633 [ruby-core:19289]

Mon Dec 29 20:57:14 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* man/ri.1: new manpage.

Mon Dec 29 17:53:24 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* bin/erb: accepts options in more flexible styles.

Mon Dec 29 17:25:17 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/erb.rb (ERB): m17n of ERB. adds rdoc.
	  fixes #712. c.f. [ruby-dev:37516].

	* lib/erb.rb (ERB::Compiler#compile): recognizes magic comments.
	  returns a pair of compiled script and its script encoding.

	* lib/erb.rb (ERB#set_eoutvar): make generated scripts return a 
	  string in correct encoding.

	* lib/erb.rb (ERB#def_method): use Kernel#eval for encoding-awareness  
	  of the evaluated string.

	* bin/erb.rb (ERB::Main.run): adds -E and -U options.
	  String is no longer Enumerable.

	* man/erb.1: new manapage.

	* test/erb/test_erb_m17n.rb: new test case for m17n features.

Mon Dec 29 16:16:20 2008  Koichi Sasada  <ko1@atdot.net>

	* vm.c (vm_set_eval_stack, vm_set_main_stack, vm_set_top_stack): 
	  check stack overflow.  [ruby-dev:37646]

Mon Dec 29 14:50:19 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* Makefile.in (ext-clean): ext-clean always fails.

	* ext/dl/ripper/extconf.rb: adds y.output into the clean list.

Mon Dec 29 11:58:39 2008  Koichi Sasada  <ko1@atdot.net>

	* thread.c (rb_mutex_trylock): return false if Mutex owned
	  by current thread.  [ruby-core:20943]

	* thread.c (rb_mutex_lock): check dead lock (recursive lock) here.

	* test/ruby/test_thread.rb: add a test.

Mon Dec 29 07:15:16 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* cont.c: small RDoc fix mentioned from <radek.bulat at gmail.com>
	  in [ruby-core:20921].

Mon Dec 29 03:43:25 2008  Koichi Sasada  <ko1@atdot.net> 

	* ruby.c (process_options): set th->base_block only while
	  it is needed.  [ruby-dev:37634] [Bug #939]

	* ruby.c (require_libraries): clear th->base_block before
	  require libraries.

Sun Dec 28 18:39:57 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c: not force to override snprintf/vsnprintf.
	  [ruby-core:20824]

Sun Dec 28 21:33:52 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/ext/dl/test_base.rb : add BSD's case.

Sun Dec 28 21:09:12 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/dl/lib/dl/import.rb (DL::Importer#sizeof): follows
	  a feature change in 1.9.

Sun Dec 28 19:11:03 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (config.h): do not use snprintf/vsnprintf in
	  msvcrt.

	* sprintf.c: not force to override snprintf/vsnprintf.
	  [ruby-core:20824]

Sun Dec 28 17:10:13 2008  TAKANO Mitsuhiro (takano32)  <tak@no32.tk>

	* ext/dl/test/test_dl2.rb: modify strncpy, strcpy, qsort, types.
	  Patch by Takehiro Kubo.
	  Bug #633 [ruby-core:19289]
	* ext/dl/test/test_base.rb: /lib/libc.so is x86_64 binary in x86_64 architecture.

Sun Dec 28 18:36:33 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/rubygems/test_gem_command.rb
	  (test_add_option_overlapping_common_and_local_options):
	  follows r21066.

Sun Dec 28 17:21:36 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/rubygems/test_ext_configure_builder.rb (test_self_build_fail):
	  Extends pattern for FreeBSD's error message.

Sun Dec 28 12:24:14 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread.c (mutex_free, mutex_unlock): add qualifiers.

Sun Dec 28 10:28:04 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread.c (mutex_free): GC thread (main thread) has failed to unlock
	  a mutex that is locked by another thread, which makes the mutex
	  dangling in keeping_mutexes and causes [BUG] or stuck finally.
	  Now unlocking is performed as locking thread.

	* thread.c (mutex_unlock, rb_mutex_unlock, rb_mutex_unlock_all):
	  mutex_unlock receives a thread.

Sun Dec 28 05:44:44 2008  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/minitest/*.rb: Imported minitest 1.3.1 r4505.
	* test/minitest/*.rb: ditto.

Sun Dec 28 00:43:33 2008  Tanaka Akira  <akr@fsij.org>

	* runruby.rb: refactored to modify ENV as once.

Sat Dec 27 22:41:02 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/rdoc/test_rdoc_info_formatting.rb (setup, teadown): uses
	  mktmpdir and removes it alfter the test.

	* test/cgi/test_cgi_session.rb (setup, teadown): ditto.

Sun Dec 28 12:53:10 2008  TAKANO Mitsuhiro (takano32)  <tak@no32.tk>

	* ext/dl/test/test_base.rb: use libc.dylib when the platform is darwin.

Sat Dec 27 21:46:10 2008  TAKANO Mitsuhiro (takano32)  <tak@no32.tk>

	* ext/dl/test/test_base.rb: use lib64 when the architecture is x86_64.

Sat Dec 27 20:26:59 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_argv_size): if an argument is empty, it's size
	  is 2, not 0, because it will be converted to "".

Sat Dec 27 19:40:56 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (after_exec): needs to reset before restart timer
	  thread.

	* thread.c (thread_start_func_2): stops timer thread if forked in
	  the new thread.   [ruby-core:19385]

	* thread.c (rb_thread_atfork, rb_thread_atfork_before_exec): DRY.

Sat Dec 27 17:08:43 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* .gdbinit (dummy_gdb_enums.special_consts): forces to load debug
	  info on Mac OS X.

	* .gdbinit (rp): added T_ZOMBIE.

Sat Dec 27 16:18:02 2008  Koichi Sasada  <ko1@atdot.net>

	* eval.c (rb_frame_callee, rb_frame_caller): rb_frame_callee() 
	  should return method id on current frame.
	  add rb_frame_caller() to get method id on parent frame.
	  Bug #884 [ruby-dev:37446]

	* eval.c (rb_f_method_name): use rb_frame_caller()
	  instead of rb_frame_callee().

Sat Dec 27 15:28:12 2008  Tanaka Akira  <akr@fsij.org>

	* transcode.c (make_econv_exception): show source and destination
	  encoding.  [ruby-dev:37285]

Sat Dec 27 15:23:38 2008  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_yield_with_cfunc): rename parameter name
	  "blockptr" to "blockargptr".

Sat Dec 27 15:15:56 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* common.mk (revision.h): ignores failure of file2lastrev.

Sat Dec 27 15:02:38 2008  Koichi Sasada  <ko1@atdot.net>

	* ruby.c (process_options): fix to untouch th->mild_compile_error.
	  [ruby-dev:37621], [ruby-dev:37620]

Sat Dec 27 14:48:26 2008  Koichi Sasada  <ko1@atdot.net>

	* iseq.h, iseq.c (rb_iseq_new_main): add a type ISEQ_TYPE_MAIN.
	  [ruby-dev:37619]

	* compile.c (rb_dvar_defined, ruby_iseq_compile): ditto.

	* iseq.c (iseq_data_to_ary, iseq_load): ditto.

	* compile.c (iseq_compile_each): fix to check ip->compile_data.

Sat Dec 27 14:29:33 2008  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb (OpenURI.redirectable?): permit https redirection.
	  patch from Roman Shterenzon.  [ruby-core:20485]

Sat Dec 27 13:36:55 2008  Koichi Sasada  <ko1@atdot.net>

	* eval.c (get_errinfo): return th->errinfo value
	  if normal errinfo place (dynamic local viriable) is not found.
	  fixes Bug #732 [ruby-dev:37046].

	* bootstraptest/test_proc.rb: add a test.

Sat Dec 27 11:41:45 2008  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_call_method, vm_call_cfunc): use original id instead of
	  calling id when NODE_CFUNC or NODE_BMETHOD.
	  fixes Bug #632 [ruby-core:19282].

	* vm_eval.c (vm_call0, vm_call_super): ditto.

	* vm_method.c (rb_add_method, rb_alias): store original id
	  in nd_file field of NODE_METHOD.

	* test/stringio/test_stringio.rb: add a test.

Sat Dec 27 13:09:36 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* man/irb.1: adds -v, -h, -E, and -U.

Sat Dec 27 09:48:54 2008  Koichi Sasada  <ko1@atdot.net>

	* vm.c (Init_VM): create and define TOPLEVEL_BINDING at first.

	* vm.c (vm_set_main_stack, rb_iseq_eval_main): added.

	* parse.y (rb_parser_compile_file): fix to check parse_in_eval flag.

	* eval.c (ruby_exec_node): use rb_iseq_eval_main()
	  instead of rb_iseq_eval().

	* iseq.c (rb_iseq_new_main), vm_core.h: added.
	  main script (specified by -e or script name) should be run
	  under TOPLEVEL_BINDING using Kernel#eval.  Above changes
	  simulate Kernel#eval behaviour.  [ruby-dev:37240]

	* compile.c (make_name_for_block): skip iseq except block type.
	  this fix is needed for [ruby-dev:37240], and also fixes
	  [ruby-dev:35392].

Sat Dec 27 05:38:59 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (after_fork): ignores a termination request in the
	  parent process.  [ruby-dev:37447]

Sat Dec 27 01:52:39 2008  James Edward Gray II  <jeg2@ruby-lang.org>

	* lib/csv.rb:  Using a more robust transcoding scheme to produce
	  ASCII compatible inspect() messages.  [ruby-dev:37591]

Mon Dec 22 16:32:21 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_pack): encoding of packed string only from 'm',
	  'M', and 'u' should be US-ASCII.  [ruby-dev:37284]

	* pack.c (pack_pack): encoding of packed string only from 'U'
	  should be UTF-8.  also upgrade US-ASCII strings to UTF-8.

Sat Dec 27 09:14:17 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* cont.c: rdoc for Fiber. patch by Muhammad Ali.
	  [ruby-core:20894]

Fri Dec 26 18:04:10 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (fptr_finalize): don't allocate objects if noraise.
	  (finish_writeconv): add noalloc argument to be able to avoid
	  object allocation.
	  (finish_writeconv_arg): introduced again.
	  (finish_writeconv_sync): follow the above change.

Mon Dec 22 09:54:43 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (gettable_gen): the encoding of __FILE__ should be
	  rb_filesystem_encoding().  [ruby-list:45733]

	* parse.y (gettable_gen): __FILE__ should be ASCII-8BIT when
	  filesystem encoding is US-ASCII and __FILE__ contains non 7bit
	  characters.

Fri Dec 26 15:50:45 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser::List#summarize): gives priority
	  to latter switches.  [ruby-dev:36692]

	* lib/optparse.rb (OptionParser#summarize): do not append
	  unnecessary line terminator.

Fri Dec 26 14:01:38 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (fptr_finalize): close the IO object even if finish_writeconv or
	  flush is failed.
	  (finish_writeconv): don't raise.  return errno or exception.
	  (finish_writeconv_arg): removed.
	  (finish_writeconv_sync): follow finish_writeconv change.

	* transcode.c (rb_econv_make_exception): new function.

	* include/ruby/encoding.h (rb_econv_make_exception): declared.

Fri Dec 26 17:04:14 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/input-method.rb (IRB::StdioInputMethod#initialize):
	  removed a 'p' for debugging.

Thu Dec 25 20:57:01 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* transcode.c (str_transcode0): set encoding when String#encode was
	  given explicit but the same destination and source encoding.

Thu Dec 25 19:35:51 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* transcode.c (sym_ignore): remove useless symbol.

Mon Dec 22 21:31:11 2008  Tanaka Akira  <akr@fsij.org>

	* numeric.c (int_ord): Integer#ord implemented.

Tue Dec 16 22:15:17 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/minitest/unit.rb (MiniTest::Assertions#assert_instance_of):
	  should assert by instance_of?, not ===.  [ruby-dev:37458]

	* lib/minitest/unit.rb (MiniTest::Assertions#assert_instance_of):
	  typo fixed.

Mon Dec 15 20:59:10 2008  Tanaka Akira  <akr@fsij.org>

	* ext/pty/pty.c (child_info): add slavename.
	  (chfunc): use slavename.
	  (establishShell): set slavename.
	
Tue Dec  9 13:23:18 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (check_cfunc): use function pointer.

Thu Nov 27 10:40:52 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_div2): should return
	  Integer for #div operation.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_div2): should raise
	  ZeroDivisionError if divisor is zero.  [ruby-dev:37207]

Mon Nov  3 00:36:44 2008  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* test/win32ole/test_win32ole_event.rb: rename test class.

	* test/win32ole/test_win32ole_variant_outarg.rb: add in order
	  to use ADO instead of Internet Explorer.
	  remove test/win32ole/test_win32ole_variant_with_ie.rb.

	* test/win32ole/orig_data.csv: ditto.

Sun Nov  2 22:12:41 2008  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (ole_event_free): invoke IConnectionPoint::Unadvise
	  before invoking IConnectionPoint::Release.

	* test/win32ole/test_win32ole_event.rb, test/win32ole/err_in_callback.rb,
	  test/win32ole/test_err_in_callback.rb: Use ActiveX Data Object
	  Library instead of InternetExplorer.

Sun Nov  2 22:06:55 2008  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* win32/Makefile.sub: add RUNRUBYOPT. [ruby-dev:37009]

Thu Dec 25 17:49:45 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* transcode.c (decorate_convpath): show type of escaping for
	  xml_attr_quote or some conversions.

Thu Dec 25 17:06:13 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (rb_io_initialize): check fd validity.  [ruby-dev:36646]

Thu Dec 25 16:23:31 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (flush_before_seek): check io_fflush result.
	  (rb_io_check_readable): ditto.
	  (rb_io_flush): ditto.
	  (rb_io_fsync): ditto.
	  (remain_size): ditto.
	  (rb_io_write_nonblock): ditto.
	  (finish_writeconv): ditto.
	  (fptr_finalize): ditto.
	  (io_reopen): ditto.
	  (rb_io_reopen): ditto.
	  (copy_stream_body): ditto.

Thu Dec 25 15:54:00 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_fflush): flush write buffer without write lock in
	  finalizers.  [ruby-dev:37572]

	* io.c (rb_io_fptr_finalize): clear write lock before finalizing.

Thu Dec 25 15:07:22 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (fptr_finalize): close the IO object even if close(2) is failed.

Thu Dec 25 14:51:43 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/rdoc/parser.rb (RDoc::Parser.binary?): should read in binary mode.

Thu Dec 25 13:28:20 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (rb_io_flush): fsync() after buffer is flushed on win32.
	  [ruby-core:20043]

Thu Dec 25 14:32:23 2008  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_method_search): fix control flow bug.
	  (commited at r20981)

Thu Dec 25 13:13:00 2008  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_method_search): return rb_cObject if there is no
	  super class.  [ruby-dev:37587]

	* bootstraptest/test_method.rb: add tests for above.

Thu Dec 25 12:49:12 2008  Koichi Sasada  <ko1@atdot.net>

	* proc.c (proc_new): should use proc_dup() if block has Proc.

	* vm.c (vm_make_proc_from_block): should use rb_cProc for block.

	* vm.c (vm_make_proc): add an assertion.

	* bootstraptest/test_proc.rb: add a test.

Thu Dec 25 12:44:27 2008  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_yield_with_cfunc): check block has Proc.

Thu Dec 25 05:53:01 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* template/id.h.tmpl, id.h (ruby_method_ids): not depend on if
	  token are defined as macros.  [ruby-dev:37553]

	* template/id.h.tmpl, id.h (ruby_method_ids_check): enclosed in a
	  struct.

Thu Dec 25 01:52:34 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (thread_start_func_2): sets native thread key.

Thu Dec 25 01:09:23 2008  TAKAO Kouji  <kouji@takao7.net>

	* test/readline/test_readline_history.rb: check the encoding that
	  is in the Readline::HISTORY.

Wed Dec 24 22:36:06 2008  Koichi Sasada  <ko1@atdot.net>

	* error.c, vm_dump.c: change message by rb_bug().

Wed Dec 24 21:57:39 2008  Koichi Sasada  <ko1@atdot.net>

	* compile.c (iseq_peephole_optimize): fix typo.

Sun Dec 21 13:38:04 2008  Koichi Sasada  <ko1@atdot.net>

	* vm.c (invoke_block_from_c): fix to point right cfp.

	* vm.c (vm_make_proc, vm_make_proc_from_block), vm_core.h:
	  remove unused parameter cfp.

	* vm_insnhelper.c, proc.c (proc_new): ditto.

Wed Dec 24 20:59:12 2008  Koichi Sasada  <ko1@atdot.net>

	* error.c (exc_equal): == method should not raise Exception.
	  [ruby-dev:37519]

	* sample/test.rb: fix test

Fri Dec 19 07:45:37 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* error.c (exc_equal): duck typing equal to make it transitive.
	  [ruby-dev:34880]

Wed Dec 24 20:33:45 2008  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_call_method): use class of method defined
	  instead of receiver's class on bmethod.  fixes [ruby-core:20786]

	* bootstraptest/test_method.rb: add a test for above.

	* vm_insnhelper.c (vm_setup_method): remove unused parameter klass.

	* vm_insnhelper.h (CALL_METHOD): ditto.

	* insns.def, vm_eval.c: ditto.

Wed Dec 24 20:15:50 2008  Koichi Sasada  <ko1@atdot.net>

	* tool/file2lastrev.rb (get_revisions): fix to ignore end of line.

Wed Dec 24 13:33:38 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (HAVE_LONG_LONG, HAVE_OFF_T): revised for autoconf
	  2.62 or later.

Wed Dec 24 06:29:32 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (OBJDUMP, OBJCOPY): autoconf list is not comma
	  separated.

	* configure.in (AC_HEADER_STDC, AC_CHECK_HEADERS, AC_CHECK_FUNCS):
	  removed duplicated checks.

Wed Dec 24 03:21:21 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* misc/ruby-mode.el: added comment to mention newer version
	  bundled with Emacs 23 or later.  a patch from Phil Hagelberg
	  <phil at hagelb.org> in [ruby-core:20838].

Tue Dec 23 23:49:37 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (rb_io_init_copy): call io_seek only if io_tell succeeds.

Tue Dec 23 20:28:28 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* io.c: rdoc for File::open and 1.9 feature in file modes.

	* transcode.c: rdoc for String#encode

Tue Dec 23 19:51:24 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (rb_w32_spawn): deals with quoted commands.

Tue Dec 23 18:44:21 2008  Tanaka Akira  <akr@fsij.org>

	* strftime.c (rb_strftime): use locale insensitive functions for tr_TR
	  locale.

Tue Dec 23 17:38:03 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit/assertions.rb (assert_equal): show small differences
	  for Regexp and Float.

Tue Dec 23 16:49:48 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_spawn): support normal commands with arguments.

Tue Dec 23 15:46:43 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/mathn.rb: Math.sqrt(NaN) should be NaN. [ruby-dev:37537]

Tue Dec 23 15:46:47 2008  Eric Hodel  <drbrain@segment7.net>
	* gem_prelude.rb:  Match full RubyGems behavior when a gem can't be
	  found.

Tue Dec 23 15:30:02 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (pipe_open): need to initialize args.

Tue Dec 23 14:18:14 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/st.h: need to include defines.h because LONG_LONG is
	  defined there.

Tue Dec 23 13:52:05 2008  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/parser/c.rb:  Don't coalesce adjacent comment blocks.
	  [bug#901]

Tue Dec 23 08:10:05 2008  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/installer.rb: Fix documentation.  [bug#827]

Tue Dec 23 08:04:58 2008  Eric Hodel  <drbrain@segment7.net>

	* gem_prelude.rb: Don't remove methods twice.  [bug#555]

Wed Dec 24 20:15:50 2008  Koichi Sasada  <ko1@atdot.net>

	* tool/file2lastrev.rb (get_revisions): fix to ignore end of line.

Tue Dec 23 15:48:55 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* tool/file2lastrev.rb: shouldn't use single quote in shell's command
	  line if you want to support Windows.

Tue Dec 23 15:36:58 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* tool/file2lastrev.rb: detects vcs directory properly on
	  building outside of srcdir. [ruby-dev:37555] [ruby-dev:37561]

Mon Dec 22 19:31:19 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* common.mk (revision.h): uses tool/file2lastrev.rb to support
	  git-svn.

	* version.h: changed version string as
	  `ruby 1.9.1 (2008-12-22 patchlevel-5000 trunk 20912)
	  [i386-darwin9.6.0]'.

Mon Dec 22 21:08:54 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit/assertions.rb (assert_nothing_raised): increment
	  assertion count.  [ruby-dev:37480]

Mon Dec 22 19:10:44 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* thread_win32.c (Init_native_thread): need to call
	  ruby_thread_set_native() here.

Mon Dec 22 18:00:36 2008  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/tcltklib.c: fix wrong flag value.

Mon Dec 22 14:35:59 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_external_str_new_with_enc): set ASCII-8BIT if
	  encoding is US-ASCII and string contains 8bit characters.

Mon Dec 22 12:26:18 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* cygwin/GNUmakefile.in (rubydll.def), win32/mkexports.rb
	  (Exports#exports): added VERSION.

Tue Dec 23 00:16:48 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* sprintf.c (rb_str_format): fix buffer overflow.

Mon Dec 22 12:25:09 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* missing/vsnprintf.c (BSD_vfprintf): fix for test_sprintf_comb.rb, by
	  wanabe in [ruby-dev:36935].

Mon Dec 22 12:05:14 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (mingw): no longer uses snprintf and vsnprintf of
	  msvcrt.  [Bug#6]

	* win32/win32.c (rb_w32_vsnprintf, rb_w32_snprintf): removed.

	* win32/Makefile.sub (config.h): vsnprintf exists in VC7 or later.

	* win32/mkexports.rb (Exports#initialize): aliases
	  rb_w32_vsnprintf and rb_w32_snprintf for binary compatibility.

	* sprintf.c (rb_str_format): uses snprintf instead of sprintf.

	* numeric.c (flo_to_s, rb_num2long, rb_num2ll): ditto.

Sat Dec 20 15:34:36 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/rake.rb (Rake::FileList#egrep): change open mode to "rb",
	  i.e. default to binary.    [ruby-dev:37385]

	* lib/rake.rb (Rake::FileList#egrep): allow specifying reading
	  encoding, e.g. FileList['*.rb'].egrep(/require/, encoding:
	  "ascii-8bit")

Mon Dec 22 10:59:31 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_upto): should return enumerator if called
	  without block.  [ruby-dev:37526]

Thu Dec 25 00:59:06 2008  TAKAO Kouji  <kouji@takao7.net>

	* test/readline/test_readline_history.rb: did not check the
	  encoding that is in the Readline::HISTORY. I will fix it.

Mon Dec 22 02:54:56 2008  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: temporary patch for trouble on TkAqua (> Tk8.4.9).

	* ext/tk/sample/demos-jp/widget: set encoding to a demo-code string to
	  avoid garbled text on the Code Window.

Sun Dec 21 14:48:51 2008  TAKAO Kouji  <kouji@takao7.net>

	* test/readline/test_readline_history.rb: checked encoding.

Sun Dec 21 13:50:37 2008  TAKAO Kouji  <kouji@takao7.net>

	* test/readline/test_readline.rb
	  (TestReadline#test_some_characters_methods): checked encoding.

Sun Dec 21 14:55:18 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (SPLAT_PROC): splat values by hand.

Sun Dec 21 12:23:16 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (SPLAT_PROC): fix for regexp.  [ruby-dev:37514]

Mon Dec 22 15:25:03 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* thread.c (Thread#set_trace_func, #add_trace_func): removed.
	  This is an unsupported feature in 1.9.1 and will be supported 
	  in 1.9.2. [ruby-core:19581]
	  (thread_add_trace_func): removes unnecessary function.
	  (thread_add_trace_func_m): ditto.
	  (thread_set_trace_func_m): ditto.

Sat Dec 20 18:28:26 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dln.c (dln_find_1): supplements an extension for executable
	  files on DOSish platforms.

	* io.c (pipe_open): use rb_w32_aspawn() for array form.

	* win32/win32.c (rb_w32_pipe_exec): no longer used.

	* win32/win32.c (rb_w32_spawn, rb_w32_aspawn): deals with batch
	  files and commands with extensions.  [ruby-core:20695]

	* win32/win32.c (has_redirection): supports environment variables
	  references.

Fri Dec  5 01:37:02 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_read): ERROR_BROKEN_PIPE is not a real error
	  at this point.

	* io.c (pipe_open): use rb_w32_spawn() instead of rb_w32_pipe_exec()
	  to use our own redirection scheme.

	* lib/rake.rb (Rake::MultiTask): invoke_prerequisites should be
	  private.  a patch from okkez in [ruby-dev:37399]

Sat Dec 20 10:59:16 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/locale.rb (IRB::Locale#initialize)
	  initializes instance variables to suppress warnings.
	  typo fix to ignore LoadError: [ruby-dev:37508]

Fri Dec 19 17:01:35 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_extract_encoding_option): "internal_encoding: nil"
	  to specify no-transcoding.  and other corner case fixed.
	  [ruby-dev:37496]

	* hash.c (rb_hash_lookup2): new function to look-up hash with
	  default value.

Fri Dec 19 15:51:48 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (process_options): get rid of warning on DOSISH.

Thu Dec 18 19:31:54 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/init.rb (IRB.opt_parse): (M17N) adds -U and -E as command
	  line options. [ruby-dev:37161]. Fixes #711. 
	  improved long optinos.

	* lib/irb/init.rb (IRB.set_encoding): new subroutine for IRB.opt_parse

	* lib/irb/input-method.rb (IRB::StdioInputMethod): (M17N) regards
	  scripts that user types as encoded in the external_encoding. 

	* lib/irb/input-method.rb (IRB::ReadlineInputMethod): ditto.

	* lib/irb/input-method.rb (IRB::FileInputMethod): (M17N) respects
	  magic comment.

	* lib/irb/help.rb (IRB.print_usage): (M17N) respects magic comment 
	  in the resource file.

	* lib/irb/lc/help-message: adds -U and -E.

	* lib/irb/lc/ja/help-message: ditto. re-encoded from ISO-2022-JP into UTF-8.

	* lib/irb/lc/ja/encoding_aliases.rb: new file. provides Japanese specific
	  character encoding name table for backward compatibility.

	* lib/irb/lc/ja/error.rb: re-eoncoded from ISO-2022-JP into UTF-8.
	  magic comment.

	* lib/irb/locale.rb: integrated with Ruby 1.9's M17N support.

	* lib/irb/magic-file.rb: new file. utility to handle files with magic
	  comment and opens in the correct encoding.

	* lib/irb/ruby-lex.rb (RubyLex#each_top_level_statement): recovers
	  character encoding for a statement after it lexed so that irb can
	  eval the statement in correct encoding.

	* lib/irb/src_encoding.rb: new file. utility.

Thu Dec 18 21:12:28 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/session.rb: fix bug for ignore session_id option.
	  report from [ruby-core:18635], [Bug #572]

	* lib/cgi/core.rb: use Encoding#find when encoding set.

	* test/cgi/test_cgi_session.rb: test for session_id specified.

Thu Dec 18 16:48:12 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/optparse/version.rb: remove variable shadowing to stop
	  warning.   [ruby-core:20612]

	* lib/irb/completion.rb, lib/net/imap.rb, lib/prime.rb,
	  lib/rinda/ring.rb, lib/racc/parser.rb,
	  lib/shell/command-processor.rb, lib/yaml/yamlnode.rb: ditto.

	* lib/racc/parser.rb: remove space before parentheses.

	* lib/shell/command-processor.rb, lib/shell/process-controller.rb:
	  use parentheses around arguments.

	* lib/irb/ext/change-ws.rb, lib/rexml/validation/relaxng.rb,
	  lib/yaml/baseemitter.rb: indentation fix.

	* lib/matrix.rb: small cosmetic change.

Thu Dec 18 08:15:04 2008  James Edward Gray II  <jeg2@ruby-lang.org>

	* lib/xmlrpc/server.rb:  Restricting method inspection to show only
	  non-inherited public methods.  [ruby-core:20603]

	* lib/xmlrpc/server.rb:  Fixing method inspection so it doesn't 
	  trigger XMLRPC::FaultException when used.  [ruby-core:20604]

Wed Dec 17 19:39:44 2008  Tanaka Akira  <akr@fsij.org>

	* ext/socket/socket.c (unix_recv_io): relax msg_controllen error
	  check.

Wed Dec 17 19:37:30 2008  Tanaka Akira  <akr@fsij.org>

	* ext/pty/extconf.rb: check util.h for OpenBSD.

	* ext/pty/pty.c: include util.h if available.

Wed Dec 17 19:23:28 2008  Keiju Ishitsuka  <keiju@ruby-lang.org>

	* lib/matrix.rb: shut up warning. [ruby-dev:37481] [Bug #899]

Sat Dec 13 08:35:14 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c (nucomp_canonicalization): renamed.

	* ext/math/complex.c: followed the above change.

	* rational.c (nurat_canonicalization): renamed.

	* ext/math/rational.c: followed the above change.

	* configure.in: defines a new macro.

Wed Dec 17 15:44:28 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_pop_m): use enum ary_take_pos_flags.

	* array.c (rb_ary_push_m): add modification check before actual
	  operation.   [ruby-dev:37440]

Wed Dec 17 15:35:39 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* configure.in (OBJDUMP, OBJCOPY): 
	  Also BSD's ports prefixes GNU binutils with 'g'.

Wed Dec 17 11:39:39 2008  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/bigdecimal/test_bigdecimal.rb (TestBigDecimal#test_hash):
	  shut up warning.  see [ruby-dev:37437]

Wed Dec 17 11:01:35 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_hash): gets rid of collisions between differen
	  encoding strings.  [ruby-core:20526]

Tue Dec 16 22:55:11 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* bin/testrb: set $0.

Tue Dec 16 21:59:02 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (VpToString): reverted modification
	  (that caused a bug) in r20359.  [ruby-dev:37370]

	* ext/bigdecimal/bigdecimal.c (BigDecimal_limit): comment update.
	  [ruby-dev:37465]

Tue Dec 16 22:42:16 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/test/unit.rb (Test::Unit.setup_argv): sorry, fixed wrong commit.

Tue Dec 16 21:59:29 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/test/unit.rb (Test::Unit.setup_argv): ALT_SEPARATOR support.

Tue Dec 16 20:24:20 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date/format.rb (_parse): m17n compliant.

Tue Dec 16 19:43:53 2008  Tanaka Akira  <akr@fsij.org>

	* re.c: use strlcpy for error messages.

Tue Dec 16 16:41:51 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (stmt): returns dispatched result.

	* parse.y (primary): also in ripper, saves in_def before restoring.

Tue Dec 16 12:30:56 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (ac_cv_header_ucontext_h): do not use ucontext.h on Mac
	  OS X 10.5 or later.  merged from MacPorts.

	* configure.in (ac_cv_func_daemon): daemon(3) is deprecated on Mac OS
	  X 10.5 or later.

Tue Dec 16 11:37:07 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ruby.c (set_arg0): use strlcpy() instead of strncpy().

	* load.c (rb_feature_p): ditto.

	* dln.c (dln_load): ditto.

Tue Dec 16 09:14:28 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (block_call): block should not be given to yield.
	  [ruby-core:20583]

Mon Dec 15 23:48:39 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* thread.c (sleep_timeval): cast tv_usec to long to shut up
	  warnings on OSX.  [ruby-dev:37449]

Mon Dec 15 23:29:49 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (process_options): revive global sub, gsub, chop, chomp
	  only when auto looping options (-p/-n) is specified.
	  [ruby-core:20570]

Mon Dec 15 21:01:46 2008  Tanaka Akira  <akr@fsij.org>

	* ext/pty/pty.c (chfunc): make it static.

Mon Dec 15 20:16:46 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* common.mk (EXTMK_ARGS): shouldn't use ``\"'' because cmd.exe eat
	  ''\'' in such quotes.

Mon Dec 15 19:07:31 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (config.h): define CANONICALIZATION_FOR_MATHN
	  to follow r20683.

Mon Dec 15 18:12:34 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/rake/packagetask.rb (Rake::PackageTask): small document
	  update from okkez in [ruby-dev:37443]

Mon Dec 15 16:26:46 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_callee_setup_arg_complex): uses cfp from
	  blockptr instead of the current cfp.  [ruby-core:20544]

Wed Dec 17 09:50:19 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_metaclass.rb: removed codes for my debugging.
	  sorry. [ruby-dev:37470]

Mon Dec 15 14:56:59 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_metaclass.rb: new test case for metaclass hierarchy.

	* class.c (make_metametaclass): new function. extracted from
	  rb_make_metaclass.

	* class.c (rb_make_metaclass): uses make_metametaclass when called for a
	  metaclass.

	* class.c (rb_singleton_class): creates a meta^(n+2)-class in
	  addition to a meta^(n+1)-class when called for a meta^(n)-class.
	  This is because the returned meta^(n+1) class must acts as an instance of 
	  Class, metaclass of Class, ..., meta^(n+1)-class of Class,
	  Module, metaclass of Module, ..., meta^(n+1)-class of Module,
	  Object, metaclass of Object, ..., meta^(n+2)-class of Object,
	  BasicObject, metaclass of BasicObject, ..., meta^(n+2)-class of
	  and BasicObject even when Class, Module, Object or BasicObject has
	  not have its meta^(i)-class yet. 

Mon Dec 15 15:13:22 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* id.h, template/id.h.tmpl (ruby_method_ids): sees YYTOKENTYPE too.
	  [ruby-dev:37436]

Mon Dec 15 15:02:24 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (EXTMK_ARGS): needs MINIRUBY for cross-compile.
	  [ruby-core:20131]

Mon Dec 15 14:39:37 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (vm_call0): NODE_ZSUPER supported.  [ruby-core:20480]

	* vm_eval.c (vm_call_super): uses method_missing().

	* vm_eval.c (method_missing): get rid of too large alloca.

	* vm_eval.c (rb_call0, method_missing): uses idMethodMissing.

	* vm_method.c (rb_add_method, remove_method, rb_undef): uses
	  id__send__.

	* vm_method.c (Init_eval_method): removed IDs which are defined as
	  immediate values.

Mon Dec 15 11:35:27 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (vm_backtrace): defaults to script name for C functions.

Mon Dec 15 11:32:18 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (rubylib_mangled_path, rubylib_mangled_path2): cannot use
	  locale encoding before load path is initialized

	* ruby.c (ruby_init_loadpath_safe): ditto.

	* ruby.c (process_options): loads encdb so that encodings can be
	  loaded, then associates script name and load paths with the
	  locale encoding.

Sun Dec 14 14:26:11 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* spec/README: directory structrue changed

Sun Dec 14 01:35:48 2008  Tanaka Akira  <akr@fsij.org>

	* process.c (forked_child): new variable.
	  (before_exec): don't call rb_thread_stop_timer_thread if
	  forked_child.
	  (after_exec): reset forked_child after rb_thread_start_timer_thread.
	  (rb_fork): set forked_child just after fork in child.

	* ext/pty/pty.c (chfunc): extracted from establishShell.
	  (establishShell): use rb_fork.

	  [ruby-dev:37418]

Sat Dec 13 18:34:43 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (sym_printable): wrong condition for string iteration.

Sat Dec 13 15:52:27 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (sym_equal): remove documentation error "Otherwise,
	  compares them as strings".  [ruby-dev:37398]

Sat Dec 13 15:55:37 2008  TAKAO Kouji  <kouji@takao7.net>

	* ruby.c (process_options): fixed default_internal is nil.
	  (closes #862)

Sat Dec 13 13:03:20 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c: use rb_usascii_str_new2 instead of rb_str_new2.

	* rational.c: ditto.

Fri Dec 12 22:12:46 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c, rational.c: do not use RUBY_VERSION_CODE.

Fri Dec 12 10:20:55 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* complex.c, rational.c: do not use RUBY_VERSION_CODE.

Tue Dec 16 12:41:52 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* configure.in (OBJDUMP, OBJCOPY): 
	  (darwin) MacPorts prefixes GNU binutils with 'g'.

Sun Dec  7 23:17:33 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in (LIBRUBY_SO): localizes non-public symbols.

	* configure.in (OBJDUMP, OBJCOPY): for dealing with binary files.

Mon Dec 15 10:00:36 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (btest-ruby): use RUNRUBY instead of MINIRUBY to load the
	  shared library.  [Bug #849]

Sun Dec 14 09:14:37 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* reverts r20713.

Sat Dec 13 22:17:30 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* common.mk (help): describes more targets.
	  based on a patch by Michael Klishin. [ruby-core:20523].

Sat Dec 13 16:04:48 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* encoding.c (default_external): endless recursion during
	  loading a locale encoding on some locale.
	  fixed by Nobuyoshi Nakada.

	* string.c (sym_inspect): quote if symbol contains non-printable
	  characters.  [ruby-dev:37398]

Sat Dec 13 14:24:38 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/enc/test_utf16.rb: feature changed in r20626.
	  follows it.

Sat Dec 13 13:41:44 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_m17n_comb.rb: feature changed in r20626.
	  follows it.

Sat Dec 13 12:48:57 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_m17n.rb: feature changed in r20626.
	  follows it.

Sat Dec 13 12:38:16 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/minitest/test.rb (MinTest::Unit#location): 
	  skips user-defined assertions as MiniTest's.
	  e.g. for test/ruby/test_m17n.rb.

Wed Dec 10 12:56:32 2008  Akinori MUSHA  <knu@iDaemons.org>

	* enumerator.c (enumerator_rewind): If the enclosed object
	  responds to a "rewind" method, call it; cf. [ruby-dev:37268]

Sat Dec 13 09:17:33 2008  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/minitest/*.rb: Imported minitest 1.3.1 r4503.
	* test/minitest/test_mini_test.rb: ditto.
	* lib/miniunit/autorun.rb: added (as part of r4503).
	
Sat Dec 13 01:10:03 2008  TAKAO Kouji  <kouji@takao7.net>

	* ext/readline/readline.c
	  (readline_s_get_completion_append_character): uses locale
	  encoding but not ASCII-8BIT.

Fri Dec 12 19:24:47 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* common.mk (run, runruby, parse, gdb, gdb-ruby): you can also run
	  other scripts than $(srcdir)/test.rb.

Fri Dec 12 19:13:43 2008  TAKAO Kouji  <kouji@takao7.net>

	* ext/readline/readline.c (readline_readline): changed the message
	  of IOError to 'closed stdin' from 'stdin closed' if stdin was
	  closed.

Fri Dec 12 11:00:52 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (rb_feature_p): load path must be expanded.
	  [ruby-dev:37388]

Fri Dec 12 10:19:21 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_string_value_ptr, rb_to_id): do not use a side
	  effect expression in RSTRING_PTR.

	* string.c (rb_str_split_m): simplified the argument of
	  RSTRING_LEN.

Thu Dec 11 23:48:00 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/cmath.rb (sqrt): should pass nan to the original method.

Thu Dec 11 19:31:45 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit/assertions.rb: extracted from lib/test/unit.rb.
	  lib/test/unit/testcase.rb: ditto.
	  at asakusa.rb.  [ruby-core:20014]

Thu Dec 11 19:23:09 2008  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_io.rb (test_dup_many): extracted from test_dup.
	  test in ruby subprocess.  at asakusa.rb.  [ruby-dev:35648]

Thu Dec 11 19:16:30 2008  Tanaka Akira  <akr@fsij.org>

	* lib/pathname.rb (Pathname#=~): undefed.  at asakusa.rb.
	  [ruby-core:19690]

Thu Dec 11 13:09:01 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (reg_enc_error): raise EncodingCompatibilityError for
	  encoding incompatibility.  [ruby-core:18600]

	* re.c (rb_reg_prepare_enc): more consistent error message.
	  [ruby-core:18611]

Fri Dec 12 19:29:07 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* encoding.c (rb_enc_set_default_external): default_internal can be
	  nil, but default_external cannot.

	* encoding.c (rb_set_default_internal): adds rdoc.

	* encoding.c (enc_find): ditto.

Fri Dec 12 14:09:55 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* encoding.c (enc_get_default_encoding): removed.
	  Generalizing rb_default_{external,internal}_encoding seems to be
	  difficult. 
	  default_external cannot be NULL even before detected. [ruby-dev:37390]

	* encoding.c (rb_default_external_encoding): has its own
	  implementation again.

	* encoding.c (rb_default_internal_encoding): ditto.

	* gem_prelude.rb: added notice.

	* ruby.c (rubylib_mangled_path, rubylib_mangled_path2): uses locale
	  encoding but not ASCII-8BIT.

	* ruby.c (process_options): refers less to default_external.

Thu Dec 11 20:05:17 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (rb_enc_aliases_enc_i): skips default internal.

Thu Dec 11 13:36:18 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (enc_set_default_encoding): allowed to set default
	  encoding.

	* encoding.c (rb_locale_encoding): removed Encoding::LOCALE.

	* encoding.c (rb_enc_set_default_external): ditto.

	* encoding.c (rb_enc_set_default_internal): ditto.

	* encoding.c (rb_enc_set_default_internal): defines internal
	  encoding as nil.

Thu Dec 11 10:25:25 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* test/ruby/test_bignum.rb (TestBignum#test_convert): remove
	  platform dependent call of Process.wait.  coverage should be
	  accomplished by other method.  [ruby-dev:36062]

Thu Dec 11 10:18:35 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/rexml/document.rb (REXML::Document#write): require
	  rexml/formatters/transitive if transitive flag is on.  a patch
	  from akira yamada in [ruby-dev:36230].  fix #553

	* lib/rexml/element.rb (REXML::Element#write): ditto.

	* lib/rexml/formatters/transitive.rb (REXML::Formatters::Transitive#write_element): 
	  add hack for IE.  [ruby-dev:36230]

Thu Dec 11 02:37:22 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* math.c (domain_check): should not raise EDOM exception for NaN
	  value if operand is also NaN.  affects acos, asin, acosh, atanh,
	  log, log2, log10, sqrt, gamma, lgamma. [ruby-dev:37357]

Thu Dec 11 01:21:58 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* thread.c (rb_mutex_unlock): shut up warning.  a patch from
	  Kazuhiro NISHIYAMA in [ruby-dev:37345]. fix #846

Wed Dec 10 23:58:56 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c: avoided warnings on cpp. [ruby-dev:37344]

	* rational.c: ditto.

Wed Dec 10 12:46:52 2008  Akinori MUSHA  <knu@iDaemons.org>

	* enumerator.c (enumerator_next): Fix a typo: s/rewinded/rewound/.

	* lib/prime.rb (Prime::OldCompatibility#each): Ditto.

Wed Dec 10 11:25:53 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* re.c (rb_reg_initialize): raise RegexpError when encoding
	  is dummy encoding. [ruby-dev:37091]

Tue Dec  9 18:35:35 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/trans/single_byte.trans, cp850-tbl.rb, cp852-tbl.rb,
	  cp855-tbl.rb, koi8-r-tbl.rb, koi8-u-tbl.rb, tis-620-tbl.rb:
	  new single-byte transcodings (from Yoshihiro Kambayashi)

	* test/ruby/test_transcode.rb: added tests for the above
	  (from Yoshihiro Kambayashi), small cosmetic fixes

Tue Dec  9 13:33:53 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each), gc.c (assign_heap_slot),
	  (gc_mark_children), parse.y (vtable_alloc, vtable_free, vtable_add),
	  proc.c (proc_to_s), thread.c (terminate_i, rb_thread_terminate_all),
	  (thread_start_func_2, blocking_region_begin, blocking_region_end),
	  (rb_thread_kill), thread_pthread.c (native_thread_create),
	  (ubf_pthread_cond_signal), vm.c (check_env, thread_free), vm_dump.c
	  (vm_env_dump_raw, vm_stack_dump_each, vm_thread_dump_state),
	  (vm_call0): use void pointer for %p.

	* cont.c (fiber_status), template/insns.inc.tmpl (ruby_vminsn_type),
	  vm_insnhelper.h (BOP): ISO C forbids comma at end of enumerator
	  list.

	* vm_insnhelper.c (check_cfunc): use function pointer.

Tue Dec  9 12:08:47 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* .gdbinit (rp): fixed typo for T_STRUCT.

Tue Dec  9 03:21:37 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* mkconfig.rb: fix for continued lines.  based on a patch from
	  Marcus Rueckert <darix AT opensu.se> at [ruby-core:20420].

Fri Dec  5 22:56:24 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_make_exception): single argument to raise may be
	  string compatible object.

Tue Dec  9 00:54:01 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/make-snapshot (package): enc.mk in snapshot is dummy and should
	  not deal with objects.  [ruby-core:20422]

Tue Dec  9 00:17:50 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/depend (clean-srcs): split out from clean.

Mon Dec  8 23:34:18 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* pack.c (pack_pack): fixed odd act of 'm*', 'M*', and 'P*'.
	  just ignores '*' in these cases.
	  [ruby-dev:37289]

Mon Dec  8 18:31:41 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* pack.c (pack_pack): fixed length for odd length string.
	  [ruby-dev:37283]

Mon Dec  8 10:32:33 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (set_option_encoding_once): dry.

	* ruby.c (proc_options): checks extra argument for -E/--encoding.

Sun Dec  7 23:47:37 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (LIBPATHFLAG): use numbered specifier if RPATHFLAG
	  is set.  [ruby-talk:322136]

Sat Dec  6 17:51:35 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* pack.c (pack_pack): 'u0' is not special differently from 'm0'.

Tue Dec  9 11:50:46 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* pack.c (pack_pck): fixed [ruby-dev:37295]. 
	  Array#pack always has returned an US-ASCII string when
	  the given format ended with 'u', 'M' or 'm'.

Sat Dec  6 14:35:06 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* pack.c (pack_pack): set US-ASCII and CODERANGE_7BIT
	  when quoted-printable ('M') and base64 ('m').
	  [ruby-dev:37284]

	* pack.c (pack_unpack): ditto.

Thu Dec 11 11:51:36 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (rb_locale_encoding): removed Encoding::LOCALE.

	* encoding.c (rb_enc_set_default_external): ditto.

	* encoding.c (rb_enc_set_default_internal): ditto.

Thu Dec 11 11:11:03 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/st.h (size_t): needs stddef.h or stdlib.h.
	  [ruby-core:20339]

Wed Dec 10 01:28:46 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* common.mk (win32.obj): depend on headers.

Sat Dec  6 18:33:16 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/make-snapshot (package): added RM and CP.  [ruby-dev:37288]

Fri Dec  5 21:45:45 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* rational.c (nurat_{to_s,inspect}): performance improvement.

Fri Dec  5 21:42:44 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c: inpsect should not depend on to_s.

Fri Dec  5 12:38:48 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_set_sequence): uses rb_compile_warning() for
	  warning at compilation time.

Fri Dec  5 12:35:46 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (ruby_iseq_compile, ruby_iseq_translate_threaded_code),
	  (ruby_insns_name_array, ruby_iseq_build_from_ary): prefixed with
	  ruby_.

	* iseq.c (ruby_iseq_load, ruby_insn_make_insn_table): ditto.

Fri Dec  5 10:01:43 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_cmp_m): fixed rdoc.  pointed out by <Thomas
	  C. Mitchell AT gmail.com> at [ruby-talk:321967]

Fri Dec  5 07:58:30 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (io_binwrite): arg.offset should be updated after retry.

Fri Dec  5 03:29:17 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (rb_get_load_path): returns the load path without
	  touching.

	* load.c (rb_feature_provided): new function to return the loading
	  path in addition to rb_provided().

	* load.c (search_required): sets path if loading.

	* variable.c (autoload_provided): load paths are expanded to check
	  if loading.

	* variable.c (autoload_node): keeps autoload mark while loading.
	  [ruby-core:20235]

	* variable.c (rb_const_get_0): loops while autoload mark is set.

Fri Dec  5 01:19:21 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_pack): propagate taint status from format string to
	  result string.

Thu Dec  4 23:02:13 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* spec/default.mspec: follows changes in rubyspec project.
	  inherits configurations from ruby.1.9.mspec.

Thu Dec  4 22:13:55 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/ruby/test_complex.rb: added some tests.

	* test/ruby/test_rational.rb: ditto.

Fri Dec  5 18:13:56 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_read, rb_w32_write, rb_w32_isatty): check
	  whether fd is valid.

Thu Dec  4 23:31:12 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (waitpid): fix bug of checking child slot.

	* win32/win32.c (FindChildSlotByHandle): new.

Thu Dec  4 16:58:12 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/rubygems/validator.rb (Gem#remove_leading_dot_dir): make
	  this method private.  a patch from okkez in [ruby-dev:37245]

Thu Dec  4 16:16:09 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/gserver.rb: fixed type in sample code.  a report from Oleg
	  Puchinin.

Thu Dec  4 14:54:32 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/rubygems/local_remote_options.rb (Gem#add_update_sources_option): 
	  little documentation fix.  a patch from okkez.  [ruby-dev:37271]

Thu Dec  4 13:56:31 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/curses/curses.c (window_getch): avoid ISPRINT() macro which
	  has an issue with OpenSolaris.  [ruby-core:20189]

	* ext/curses/curses.c (curses_getch): no ISPRINT(). [ruby-core:20294]

	* signal.c (ruby_signal): EINVAL from sigaction(2) is not a bug.

Thu Dec  4 11:38:40 2008  Akinori MUSHA  <knu@iDaemons.org>

	* vm_method.c (rb_obj_respond_to): Remove a duplicated rdoc
	  comment and fix a markup error.

Thu Dec  4 06:04:16 2008  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/menu.rb: TkOptionMenubutton.new fails to treat 
	  'parent' and 'variable' options on a Hash argument.

Thu Dec  4 05:06:47 2008  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: bug fix. use ::RubyVM instead of ::VM 
	  [ruby-list:45676]

	* ext/tk/tcltklib.c: update RELEASE_DATE

Thu Dec  4 01:37:47 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c (nurat_{to_s,inspect}): provides better representation
	  for in-finite imag part.

Thu Dec  4 01:22:41 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c (f_signbit): NaN may be signed value.

Wed Dec  3 22:54:39 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (expr): keyword_not can continue across newline.
	  [ruby-core:20252]

Wed Dec  3 14:48:52 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/tk/tcltklib.c (ip_ruby_cmd, ip_invoke_with_position): must
	  not access internal union directly.  [ruby-list:45670]

Wed Dec  3 12:24:08 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_getc, rb_io_readchar): documentation correction from
	  Emiel van de Laar.  [ruby-core:20212]

	* ext/stringio/stringio.c (strio_readchar): ditto.

Wed Dec  3 09:26:29 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/rexml/xpath.rb (REXML::XPath.first): apply documentation
	  patch from Ken Bloom in [ruby-core:20213].

	* lib/rexml/xpath.rb (REXML::XPath.each): ditto.

Wed Dec  3 02:53:24 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_range.rb: add a test.

Wed Dec  3 02:26:07 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_string.rb: add some tests.

Mon Dec  1 12:00:45 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* cont.c (rb_fiber_start): calls with exact argument number.
	  [ruby-core:20088]

Mon Dec  1 16:06:15 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* signal.c (register_sigaltstack): no need to define on non-sigaltstack
	  platform.

Sun Nov 30 21:41:10 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* man/rake.1: new manual page

Sat Nov 29 23:56:44 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* man/irb.1 (EXAMPLES): new section

Sat Nov 29 19:19:32 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regparse.c (is_invalid_quantifier_target): Perl and old Ruby
	  accepts quantifier on anchors.  [ruby-core:20161]

Sat Nov 29 00:18:30 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* cont.c (fiber_alloc): separate allocation and initialization.
	  allow subclass to override #initialize.   [ruby-core:20086]

Fri Nov 28 18:31:21 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (sock_s_getaddrinfo): refactored to remove
	  code duplication regarding getaddrinfo.

	* ext/socket/socket.c (sock_getaddrinfo): should have updated for
	  Mac OS X.  a patch from Shumpei Akai in [ruby-dev:37234]

Thu Nov 27 21:41:29 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* strftime.c (rb_strftime): should add padding for %%.

Thu Nov 27 16:32:53 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* signal.c (register_sigaltstack): stores alt stack for debug
	  purpose.

Thu Nov 27 16:12:33 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* signal.c (ruby_sigaction_t): added.

Thu Nov 27 15:59:16 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (ruby_stack_check): no check if using sigaltstack.

	* signal.c (ALT_STACK_SIZE): default minimum size is insufficient
	  for method calls.

	* signal.c (sigsegv): handles stack overflow if possible.

	* thread.c (ruby_thread_stack_overflow): helper function to raise
	  sysstack_error.

	* thread_pthread.c (ruby_stack_overflowed_p): checks for stack
	  overflow.

Wed Nov 26 23:15:47 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* strftime.c (STRFTIME): use rb_strftime() recursively, instead of
	  platform's strftime().

Wed Nov 26 22:46:23 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (VpException): bigdecimal zero
	  division should raise FloatDomainError if mode
	  VP_EXCEPTION_ZERODIVIDE is set.  [ruby-dev:37204]

	* ext/bigdecimal/bigdecimal.c (BigDecimal_mode): should handle
	  VP_EXCEPTION_ZERODIVIDE.

Wed Nov 26 15:16:07 2008  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* ext/gdbm/gdbm.c (rb_gdbm_nextkey): fix memory leak.

Wed Nov 26 03:17:48 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_to_r): raise exception
	  for nan/inf conversion.  [ruby-dev:37187] fix #793

	* ext/bigdecimal/bigdecimal.c (BigDecimal_to_i): ditto.

Wed Nov 26 03:00:59 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (VpAlloc): avoid ALLOCA_N() to avoid
	  segmentation fault caused by (insanely) long decimal values.
	  [ruby-dev:37189] fix #794

	* ext/bigdecimal/bigdecimal.c (BigDecimal_dump, BigDecimal_to_i,
	  BigDecimal_to_f, BigDecimal_to_s, BigDecimal_split,
	  BigDecimal_inspect): ditto.

	* ext/bigdecimal/bigdecimal.c (VpToString): small performance
	  improvement.

Wed Nov 26 00:26:30 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* strftime.c (STRFTIME): should add padding for %[xXrR] etc.
	  [ruby-dev:37185] fix: #792

Tue Nov 25 16:26:12 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_times): taint (and untrust) status should be
	  inherited by "ary * 0".  [ruby-dev:37024]

Tue Nov 25 15:54:07 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* strftime.c (rb_strftime): should not swallow incomplete
	  formatter, e.g. "%E".  [ruby-dev:37170] fix: #787

	* strftime.c (rb_strftime): clear flags before processing unknown
	  formatter, e.g. "%i".  [ruby-dev:37180]

Tue Nov 25 10:35:29 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* strftime.c (rb_strftime): "%^P" should convert to upper case.
	  [ruby-dev:37180]

Tue Nov 25 07:51:18 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* strftime.c (FMT): use "%0d" formatter for zero padding, not "%.d".
	  [ruby-dev:37168]  fix: #768

	* strftime.c (rb_strftime): %s to use zero padding by default.
	  [ruby-dev:37180]

Tue Nov 25 03:37:42 2008  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tkextlib/blt/tabset.rb, 
	  ext/tk/lib/tkextlib/blt/tabnotebook.rb: 
	  fix many bugs. Now, those work properly.

Tue Nov 25 03:26:04 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (num_step): treat infinite step specially.
	  [ruby-dev:37157] fix: #781.

Tue Nov 25 01:23:25 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date/format.rb (strftime): ignores '_' flag for %[LN].

Sat Nov 29 00:27:33 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* thread.c, thread_pthread.c, thread_win32.c: merges nobu's commits - 
	  r20117, r20123, r20124, r20127, r20132-r20134, r20138, r20140, r20141 
	  and r20160 - from trunk into ruby_1_9_1.

	* thread_pthread.c (thread_timer): checks working flags again.

	* thread_pthread.c (rb_thread_create_timer_thread): do not wait never
	  coming signal if failed to create tiemr thread.

	* thread_pthread.c (native_cond_timedwait): returns error code.

	* thread_pthread.c (thread_timer, rb_thread_create_timer_thread):
	  handshakes properly.

	* thread_pthread.c (thread_timer): initializes mutex each time.

	* thread_win32.c (thread_start_func_1): use already gotten stack info.

	* thread.c (thread_timer): pthread_cond_timedwait returns ETIMEDOUT
	  when timed out.

	* thread_pthread.c (thread_timer): uses pthread_cond_timedwait always
	  instead of pthread_kill.

	* thread.c (thread_timer): uses timedwait on cygwin.

	* thread.c (rb_thread_stop_timer_thread): terminates timer thread
	  immediately.

Tue Nov 25 00:08:22 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (rb_fork): stops the timer thread during fork.
	  [ruby-dev:37117]

	* thread.c (rb_thread_start_timer_thread): timer thread needs
	  system_working to be set.

Mon Nov 24 23:27:28 2008  Shugo Maeda  <shugo@ruby-lang.org>

	* strftime.c (rb_strftime): The # flag should work with %a, %A, %b,
	  %B, and %h.  [ruby-dev:37162]

	* test/ruby/test_time.rb (test_strftime): ditto.

Mon Nov 24 23:16:32 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* signal.c (register_sigaltstack): should not add external
	  variable (with some cosmetic changes).  [ruby-dev:37158]

Mon Nov 24 22:57:25 2008  Shugo Maeda  <shugo@ruby-lang.org>

	* strftime.c (rb_strftime): A width specifier for %t and %n should
	  work.  [ruby-dev:37160]

Mon Nov 24 22:07:07 2008  Shugo Maeda  <shugo@ruby-lang.org>

	* strftime.c (rb_strftime): The precision of %0N should be 9.
	  [ruby-dev:37156]

	* test/ruby/test_time.rb (test_strftime): ditto.

Mon Nov 24 21:38:23 2008  Shugo Maeda  <shugo@ruby-lang.org>

	* strftime.c (rb_strftime): The default precision should be 1, not
	  0.  [ruby-dev:37155]

	* test/ruby/test_time.rb (test_strftime): ditto.

Mon Nov 24 18:35:00 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/time.rb: r20251 reverted.  The patched behavior do not round
	  trip.  [ruby-core:19988]

Sun Nov 23 16:04:05 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* signal.c (default_handler, Init_signal): compile error if
	  USE_SIGALTSTACK is not defined.

Sun Nov 23 13:39:49 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/pty/pty.c: reverts 20326. [ruby-dev:37146].

Sat Nov 22 23:59:06 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/time.rb: reverts r20305. [ruby-dev:37144].

Sat Nov 22 18:24:24 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_file_world_writable_p): should return nil for non
	  world-writable files.

Sat Nov 22 10:31:25 2008  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tkextlib/blt.rb, ext/tk/lib/tkextlib/blt/vector.rb: 
	  fix NameError bug.

Sat Nov 22 03:41:22 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/pty/pty.c (get_device_once): abandon asynchronous exception
	  that might cause serious problem if a program terminated early.
	  asynchronous exception is a very bad thing anyway.  use
	  Process.waitpid(pid) or PTY.check(pid) to poll program
	  termination. if PTY.check is called with optional second
	  argument being true, it raises an exception same as one from
	  previous behavior.  [incompatible] fix: [ruby-core:19583]

Fri Nov 21 22:17:15 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (usage): -W description updated.  [ruby-core:19858]

Sat Nov 22 23:03:47 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* signal.c (ALT_STACK_SIZE): 4KB is not enough on Mac OS X.
	  Uses SIGSTKSZ.

Fri Nov 21 21:50:54 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* signal.c (register_sigaltstack): use alternative stack for
	  SIGSEGV to avoid uncaught stack overflow. based on a patch from
	  Hiro Yoshioka <hyoshiok at miraclelinux.com> in [ruby-dev:37134].
	  [ruby-dev:36993]

Fri Nov 21 16:06:54 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* vm.c (thread_free): th->vm may be NULL when pthread_create
	  failed for ENOMEM.  [ruby-dev:37095]

Thu Nov 20 07:33:15 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/logger.rb (Logger): should handle the case that cvs/svn do
	  not expand $Id keyword.  [ruby-core:19991]

Thu Nov 20 07:27:36 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/minitest/unit.rb (MiniTest::Assertions#capture_io): adjust
	  indentation to shut up warning.  [ruby-core:19993]

Wed Nov 19 17:48:05 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/syck/rubyext.c (rb_syck_mktime): return DateTime for a value
	  out of range of Time.   [ruby-core:19919]

Sat Nov 22 21:29:54 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_method.rb (test_default_accessiblity): test case for
	  [ruby-dev:37124].

Wed Nov 19 14:14:38 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* node.h (NOEX_MODFUNC): should be include NOEX_PRIVATE. 
	  [ruby-dev:37124]

Wed Nov 19 03:01:04 2008  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* test/rinda/test_rinda.rb: fixed fails occasionally [ruby-dev:37119].
	  thanks, shinichiro.h.

Wed Nov 19 02:39:31 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (Init_syserr): moved function definition itself from
	  template/known_errors.inc.tmpl.

Wed Nov 19 01:10:52 2008  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb (DRbConn::alive?): fixed NoMethodError problem
	  from NaHi [ruby-dev:37110].

Wed Nov 19 01:05:26 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* cont.c (cont_mark, cont_capture, cont_restore_1): speed up
	  continuation by copying only valid YARV stack.  [ruby-dev:37106]

Wed Nov 19 00:03:13 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/time.rb: according to RFC2822, -0000 means local time, +0000
	  means UTC.  a patch from Chun Wang.   [ruby-core:19578]

Tue Nov 18 23:02:23 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* proc.c (proc_eq): equivalence check should not done by pointer
	  comparison, but should be based on iseq contents.   [ruby-dev:37101]

Tue Nov 18 20:30:08 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/net/ftp.rb (Net::FTP#open_socket): SOCKSsocket is obsolete.
	  a patch from Alan Johnson <alan.wayne.johnson at gmail.com> in
	  [ruby-core:19982].

Tue Nov 18 16:18:23 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/logger.rb (ProgName): fixed for svn, based on a patch from
	  Nobuhiro IMAI at [ruby-dev:37108].

Tue Nov 18 15:56:55 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/webrick/httprequest.rb (WEBrick::HTTPRequest#read_request_line): 
	  use possessive match for path retrieval to avoid huge recursion
	  for insanely long path.

Tue Nov 18 15:50:11 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_desc): re might be NULL.

	* regerror.c (onig_error_code_to_format): message updated.

Tue Nov 18 09:42:11 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser::make_switch): makes default
	  conversion to splat.  [ruby-list:45645]

Mon Nov 17 18:05:16 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/depend (LIBS): fixed for disable-shared.  [ruby-dev:37103]

Mon Nov 17 11:12:24 2008  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* bin/erb: remove -K option.

Mon Nov 17 02:19:03 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (LIBRUBYARG_STATIC): fixed for --enable-rpath.

Sat Nov 15 22:46:32 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* re.c (rb_reg_regsub): returns -1 unless ascii as well as
	  rb_enc_ascget().  [ruby-dev:37097]

Sat Nov 15 22:23:45 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (LDSHARED): do not suppress debug info if higher debug
	  level is given, on cygwin and mingw.

Thu Nov 13 11:31:13 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_barrier_wait): gets rid of recursive deadlock.

Thu Nov 13 06:08:44 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_barrier_{new,wait,release,destroy}): use Mutex so that
	  circular requires fail with deadlock.  [ruby-core:19821]

Wed Nov 12 07:16:01 2008  David Flanagan  <david@think32>

	* ruby.c (set_internal_encoding_once): fix typo in error string

Wed Nov 12 03:30:59 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/intern.h (rb_{external,locale}_str_new_cstr): optimized
	  versions for literal strings.

Wed Nov 12 03:28:41 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (rb_require_safe): destroys barrier after successfully
	  loaded, to get rid of loading same library again.  [ruby-core:19798]

	* thread.c (rb_barrier_wait): can not wait destroyed barrier.

	* thread.c (rb_barrier_destroy): destroys barrier so that no longer
	  waited.

Tue Nov 11 21:22:28 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic#check_path): REL_PATH should a
	  symbol.  [ruby-core:19805]

Tue Nov 11 23:02:27 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* man/ruby.1 (RUBYOPT): wrote which option can appear.
	  (--yydebug): wrote "do not use".
	  (--dump): wrote "do not use".

Tue Nov 11 20:49:29 2008  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* configure.in: fix SEGV on Mac OS X 10.5.3 with pthread.
	  a patch from Wataru Kimura in Bug #193 [ruby-core:17333].

Tue Nov 11 23:24:23 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ruby.c: merges r20053 and r20067 from trunk into ruby_1_9_1.

	* ruby.c (moreswitches): splits option string and passes arguments.

	* ruby.c (proc_options): checks if allowed in RUBYOPT.

	* ruby.c (process_options): allows long style options in RUBYOPT.

	* ruby.c (load_file_internal): ditto in shebang.  [ruby-dev:36979]

	* ruby.c (process_options): delays setting safe level.
	  [ruby-dev:36997]

Tue Nov 11 23:36:45 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_accept): commit miss.

Tue Nov 11 23:02:27 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* man/ruby.1 (RUBYOPT): wrote which option can appear.
	  (--yydebug): wrote "do not use".
	  (--dump): wrote "do not use".

Tue Nov 11 14:40:40 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* test/ruby/test_transcode.rb: unnecessary setup method
	  (setup_really_needed?) removed

Tue Nov 11 14:25:25 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/trans/single_byte.trans, macgreek-tbl.rb, macroman-tbl.rb,
	  macromania-tbl.rb, macturkish-tbl.rb, macukraine-tbl.rb,
	  ibm437-tbl.rb, ibm852-tbl.rb, ibm855-tbl.rb, ibm857-tbl.rb,
	  ibm860-tbl.rb, ibm861-tbl.rb, ibm862-tbl.rb, ibm863-tbl.rb,
	  ibm865-tbl.rb, ibm866-tbl.rb, ibm869-tbl.rb, ibm775-tbl.rb:
	  new single-byte transcodings (from Yoshihiro Kambayashi)

	* test/ruby/test_transcode.rb: added tests for the above
	  (from Yoshihiro Kambayashi)

Tue Nov 11 13:20:23 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_to_r): moved from
	  bigdecimal/util, converted into C.  [ruby-dev:36805]

Tue Nov 11 07:55:57 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date.rb (inspect): changed the format.

Mon Nov 10 17:34:50 2008  Akinori MUSHA  <knu@iDaemons.org>

	* test/sdbm/test_sdbm.rb (TestSDBM#test_index): Reflect the method
	  name change from #index to #key and remove a duplicated test
	  method.

Mon Nov 10 10:50:43 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/delegate.rb (Delegator.delegating_block): should not refer
	  DelegateClass specific @delegate_dc_obj.  a patch from Erik
	  Hollensbe in [ruby-core:19671].

Sun Nov  9 13:04:52 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* struct.c (rb_struct_initialize_m): avoid unnecessary array
	  allocation.

Sun Nov  9 04:10:19 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_dump.c (control_frame_dump): suppresses finished method name.

Sun Nov  9 00:02:01 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/session/pstore.rb: fix indentation.

Sat Nov  8 23:47:45 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/session.rb (FileStore): use marshalized data.

	* test/cgi/session_dir: add a session directory in test.

	* test/cgi/test_cgi_session.rb: add a test. 

Sat Nov  8 21:57:03 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/session.rb: remove debug code. 

Sat Nov  8 21:33:53 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/session.rb: fix indentation. 

Sat Nov  8 18:11:14 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/webrick/httpproxy.rb (WEBrick::HTTPProxyServer#do_CONNECT):
	  use #bytesize instead of #size.  a patch submitted from
	  raspberry lemon in  [ruby-core:18571].

	* lib/webrick/httpauth/digestauth.rb, lib/webrick/httpproxy.rb,
	  lib/webrick/httprequest.rb, lib/webrick/httpservlet/cgi_runner.rb,
	  lib/webrick/httpservlet/abstract.rb, lib/webrick/httpresponse.rb,
	  lib/webrick/httpservlet/cgihandler.rb, lib/webrick/utils.rb: ditto.

Sat Nov  8 17:31:41 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/stringio/stringio.c (strio_ungetc): ungetc position should
	  not be changed from 1.8.   [ruby-core:19632]

Sat Nov  8 17:15:08 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/optparse.rb (OptionParser#make_switch): 1.9 Symbols respond
	  to :match.  a patch from keith cascio, <keith at ucla.edu>.
	  [ruby-core:19730]

Sat Nov  8 12:10:15 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/gdbm/gdbm.c (fgdbm_index): make #index warn like Hash.
	  [ruby-dev:37039]

	* ext/sdbm/init.c (Init_sdbm): typo fixed.  [ruby-dev:37039]

Sat Nov  8 07:07:48 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* configure.in: detect stdio buffer pointers for uClibc.  a patch
	  from Brian Candler <B.Candler at pobox.com> in [ruby-core:12020].
	  [ruby-core:19713]

Sat Nov  8 06:51:42 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/dbm/dbm.c (fdbm_index): make #index warn like Hash.

	* ext/dbm/dbm.c (fdbm_key): new method.

	* ext/sdbm/init.c: ditto.

Sat Nov  8 06:20:42 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/curses/curses.c: curses encoding should obey locale.

	* ext/curses/curses.c (curses_getch): 1.9 getch should return one
	  character string for single byte string.  wchar_t support may
	  follow in the future.

Sat Nov  8 05:46:50 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/io.h (rb_io_t): added write_lock to serialize.
	  [ruby-core:19668]

	* gc.c (gc_mark_children): mark write_lock.

	* gc.c (rb_gc_call_finalizer_at_exit): Mutex also needs to be
	  deferred.

	* io.c (io_fflush, io_binwrite, fptr_finalize): serializes writing.

Tue Nov 11 17:37:47 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_accept): secure fd before accept because if
	  error causes in securing, cannot restore the state of accepted
	  socket.
	  fixed [ruby-core:19728]

Sat Nov  8 05:31:25 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* safe.c (safe_setter): add warning for $SAFE=3.

Fri Nov  7 22:51:49 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* inits.c (rb_call_inits): do not repeat.

Fri Nov  7 12:26:00 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/irb.rb (IRB::Irb#eval_input): remove extra  @context.prompt_i.
	  [ruby-core:19718]

Fri Nov  7 11:55:30 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* nkf.c: update to r1.188. fixes for 16bit environment.

Fri Nov  7 07:32:55 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/yaml/rubytypes.rb: support Rational and Complex as 1.8
	  does.  a patch from Hiroshi Moriyama in [ruby-dev:36899].

Fri Nov  7 06:58:59 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (Init_String): remove Symbol#===.  [ruby-dev:37026]

Fri Nov  7 02:00:12 2008  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/rexml/entity.rb (unnormalized): do not call
	  document.record_entity_expansion if document is nil.
	  see <http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=502535>.
	  Thanks, Naohisa Goto.

	* test/rexml/test_document.rb: ditto.

Fri Nov  7 01:24:20 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/make-snapshot: binary encoding spec is no longer needed in 1.9.

Mon Nov 10 09:56:20 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (ifs_open_socket): should retry without proto_buffer
	  if cannot find the suitable protocol. a patch from Heesob Park.
	  fixed [ruby-core:19713]

Thu Nov  6 22:05:36 2008  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (fole_s_connect, fole_initialize,
	  folevariant_initialize): check argument type of WIN32OLE.connect,
	  WIN32OLE.new, WIN32OLE_VARIANT.new.

	* test/win32ole/test_win32ole.rb (test_s_new_exc, test_s_connect_exc):
	  ditto.

	* test/win32ole/test_win32ole_variant.rb (test_s_new_exc): ditto.

	* test/win32ole/test_win32ole_method.rb: add assertion of
	  WIN32OLE_METHOD.new.

Tue Nov  4 08:00:00 2008  TAKANO Mitsuhiro (takano32)  <tak@no32.tk>

	* test/zlib/test_zlib.rb(test_readchar): compare in same type.

Tue Nov  4 03:28:31 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_join): do not repeat self in a recursive array.
	  [ruby-dev:37019]

Tue Nov  4 01:56:46 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/intern.h (rb_mutex_synchronize): fixed prototype.

	* thread.c (rb_mutex_synchronize): fixed function name.

Mon Nov  3 16:32:54 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* missing.h: needs RUBY_EXTERN instead of extern for mswin.

Sat Nov  1 07:09:40 2008  Eric Hodel  <drbrain@segment7.net>

	* gem_prelude.rb:  Don't require rubygems/defaults.rb.

Mon Nov  3 13:01:13 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* array.c (rb_ary_take_first_or_last): renamed rb_ary_partial more
	  appropriately.
	  (ary_take_pos_flags): new enum. makes the fourth argument of
	  rb_ary_take_first_or_last more descriptive.
	  (rb_ary_partial): renamed rb_ary_partial0 more appropriately.
	  takes a new parameter klass for what class to instanciate.

Mon Nov  3 13:00:26 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* range.c (rb_range_beg_len): rb_raise takes C values as arguments.
	  [BUG] ranges turned into other value in a message of RangeError.

Mon Nov  3 06:41:19 2008  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (ole_event_free): invoke IConnectionPoint::Unadvise
	  before invoking IConnectionPoint::Release.

	* test/win32ole/test_win32ole_event.rb, test/win32ole/err_in_callback.rb,
	  test/win32ole/test_err_in_callback.rb, 
	  test/win32ole/test_win32ole_variant_outarg.rb,
	  test/win32ole/orig_data.csv: Use ActiveX Data Object
	  Library instead of InternetExplorer.
	  remove test/win32ole/test_win32ole_variant_with_ie.rb.

Sun Nov  2 16:41:52 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/zlib/zlib.c (Init_zlib): defines readbyte instead redefining
	  readchar.

Fri Oct 31 21:58:50 2008  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/converter.rb (RSS::Converter): use String#encode.

Fri Oct 31 18:05:05 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/trans/single_byte.trans, maccroatioan-tbl.rb,
	  maccyrillic-tbl.rb, maciceland-tbl.rb: new single-byte
	  transcodings (from Yoshihiro Kambayashi)

	* test/ruby/test_transcode.rb: added tests for the above
	  (from Yoshihiro Kambayashi)

Fri Oct 31 12:51:25 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (dir_globs): need taint check.  reported by steve
	  <oksteev at gmail.com>

Fri Oct 31 12:42:45 2008  wanabe  <s.wanabe@gmail.com>

	* array.c (rb_ary_decrement_share): fix to work recycling
	  shared-array without the following.  [ruby-dev:36991]

	* array.c (ary_make_substitution): don't recycle substitution array.

Fri Oct 31 11:35:38 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (rb_enc_set_default_internal): no alias "internal" if
	  defalt internal is not set.  [ruby-dev:37000]

Fri Oct 31 21:28:14 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/webrick/httpauth/digestauth.rb
	  (WEBrick::HTTPAuth::DigestAuth#initialize): fix typo.

Fri Oct 31 18:51:42 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_array.rb (test_array_subclass): test for r20076.

Fri Oct 31 18:42:19 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* array.c (ary_partial0): recovers the mistakenly change feature at r19723.
	  Array#[m,n] had returned an Array even for an instance of a
	  subclass.

Fri Oct 31 12:27:52 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* spec/default.mspec: supports that the build directory != srcdir.

Thu Oct 30 23:32:17 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/test_delegate.rb (test_syscallerror_eq): ignored because the
	  behaviour is now unspecified.

Thu Oct 30 21:32:15 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* array.c (rb_ary_permutation): hide temporal array.

Thu Oct 30 14:45:45 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/trans/single_byte.trans: refactoring to make it easier
	  to add more transcodings (with Yoshihiro Kambayashi)

	* enc/trans/iso-8859-1-tbl.rb: new file to avoid having to
	  treat ISO-8859-1 as special

Thu Oct 30 14:10:46 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_pack): templates a, A, Z should propagate encoding
	  of original strings.  templates b, B, h, H brings ASCII-8BIT to
	  the result.

Thu Oct 30 09:31:45 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (rb_locale_encoding): makes an alias for locale.
	  [ruby-dev:36976]

	* encoding.c (rb_enc_set_default_external): ditto for external.

	* encoding.c (rb_enc_set_default_internal): ditto for internal.

Thu Oct 30 03:30:25 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (load_file_internal): should not set script encoding to
	  ASCII-8BIT.

	* ruby.c (load_file_internal): do not auto convert scripts even
	  when default_internal is set.  [ruby-core:19579]

Thu Oct 30 02:20:33 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* array.c (rb_ary_sort_bang): remove SEGV when replacing array with
	  embedded one during sort.  [ruby-dev:36983]

	* test/ruby/test_array.rb (test_sort!): add tests for above.

Thu Oct 30 01:44:23 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_array.rb: add some tests.

Thu Oct 30 01:32:15 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* array.c (rb_ary_splice): remove redundant check.

Thu Oct 30 01:24:55 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* string.c (rb_str_cmp): fix condition which always returned true
	  because ENCODING_GET returns unsigned long.

Thu Oct 30 01:10:32 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_array.rb (test_permutation): add a test that replaces
	  array during permutation.

Wed Oct 29 23:31:34 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_check_dummy_enc): new function to check dummy
	  encoding.

	* string.c (rb_str_upcase_bang): case conversion functions should
	  not be applicable to strings in dummy encoding.  [ruby-dev:36985]

Wed Oct 29 23:57:29 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* array.c (rb_ary_sort_bang): replacing array during sort broke
	invariant of array.  [ruby-dev:36983]

Wed Oct 29 21:06:46 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_rewind): should reset fptr->readconv if it's
	  available.

	* io.c (more_char): clear readconv at EOF.

	* test/ruby/test_file.rb: should not read after EOF.  use rewind
	  instead.

Wed Oct 29 20:45:08 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/webrick/utils.rb (start_server): provide a reference to log of
	  webrick.

	* test/webrick/test_httpproxy.rb, test/webrick/test_httpauth.rb,
	  test/webrick/test_cgi.rb, test/webrick/test_httpserver.rb,
	  test/webrick/test_server.rb, test/webrick/test_filehandler.rb: use
	  webrick log as an assertion message.

Wed Oct 29 16:41:17 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* pack.c (pack_pack): set encoding from packing string and UTF-8 for
	  "U".  [ruby-core:19590]

Wed Oct 29 15:50:00 2008  TAKANO Mitsuhiro (takano32)  <tak@no32.tk>

	* complex.c (imp1, imp2): should declare type.
	  [BUG] at IA-64

Wed Oct 29 14:36:50 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (revision.h): have to be updated daily or by non-trivial
	  commits.

Wed Oct 29 13:18:02 2008  Akinori MUSHA  <knu@iDaemons.org>

	* README, README.ja: Update the portability section.

Wed Oct 29 13:02:17 2008  Akinori MUSHA  <knu@iDaemons.org>

	* configure.in (rb_cv_lib_xpg4_needed): Drop legacy FreeBSD
	  support regarding libxpg4.  Those old versions of FreeBSD
	  shipped with the library don't have a working pthread library
	  anyway.

Wed Oct 29 11:50:57 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (dln-a-out): cannot make shared library nor work with
	  ELF.  [ruby-core:19571]

Wed Oct 29 11:01:46 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_open): shouldn't seek here.

	* win32/win32.c (rb_w32_write): write to the end of the file when
	  FAPPEND is specified.

Wed Oct 29 09:30:04 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (load_file_internal): cache common interned IDs.

Wed Oct 29 00:43:39 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c: uses macro in declarations.

Wed Oct 29 00:29:46 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_open): need to seek to the end of the file when
	  O_APPEND is specified.

Wed Oct 29 00:08:05 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* math.c (rb_math_{atan2,cos,cosh,hypot,log,sin,sinh,sqrt}): added.

	* complex.c: follows the above change.

Tue Oct 28 23:29:06 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/nkf.c (kanji_convert): output unicode chars.
	  [ruby-dev:36957]

	* ext/nkf/nkf-utf8/nkf.c (numchar_getc): increase buffer size.
	  reported and patched at [ruby-dev:36957] by mame.

Tue Oct 28 23:03:46 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_proc.rb: filled all patterns for testing
	  vm_yield_setup_args.

Tue Oct 28 23:05:35 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c: continues to support canonicalization *unofficially*
	  for an odd library mathn for the time being (only 1.9.x).
	  since grand mathn must be very very special library for us.

	* rational.c: ditto.

	* ext/mathn/*/*: follow the above changes.

Tue Oct 28 21:31:55 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* parse.y (parser_yylex): check EOF explicitly.

Tue Oct 28 21:11:58 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (extract_binmode): new function to extract binmode/textmode
	  options from hash.

	* io.c (rb_io_extract_modeenc): use above function.

	* io.c (rb_io_s_pipe): recognize binmode/textmode options.

	* io.c (make_readconv): now can specify the size of cbuf.

	* io.c (read_all, appendline, io_getc, rb_io_ungetc): follow above
	  change.

	* win32/win32.c (rb_w32_pipe_exec): internal fds should be always
	  binmode.

Tue Oct 28 17:22:35 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* tool/make-snapshot.rb: merged back from trunk.

Tue Oct 28 16:43:05 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* tool/make-snapshot.rb: had returned wrong sizes for generated
	  archives.

Tue Oct 28 12:42:28 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* tool/make-snapshot.rb (package): did not accept tagnames with the
	  prefix "previewN"

Tue Oct 28 12:06:07 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/rubygems/test_gem.rb (@default_dir_re): considers 
	  --program-suffix and prefix configure options.

Tue Oct 28 11:06:48 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* version.h: set 1.9.1 into Ruby's version number.

Tue Oct 28 10:42:50 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* gem_prelude.rb: considers --program-suffix and prefix configure
	  options.

	* lib/rubygems/defaults.rb: ditto.

Tue Oct 28 09:51:48 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* bootstraptest/test_thread.rb: ignore some exceptions.
	  [ruby-dev:36951]

Tue Oct 28 09:19:40 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (RUNRUBY): now ruby requires something from
	  gem_prelude, so need to set library path.

Mon Oct 27 22:29:11 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* vm_insnhelper.c (vm_yield_setup_args): supports optional parameters.
	  Fixed [ruby-core:19503].

	* vm_insnhelper.c (vm_yield_setup_block_args): a new function. extracted
	  from vm_yield_setup_args.

	* vm_insnhelper.c (vm_yield_setup_block_args_complex): ditto.

	* test/ruby/test_proc.rb: added tests for arguments on a Proc from
	  Kernel#proc called.

Mon Oct 27 20:03:05 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/mathn/complex/complex.c: no need to define rb_cComplex because
	  it's already defined at $(srcdir)/complex.c.

	* ext/mathn/rational/rational.c: no need to define rb_cRational because
	  it's already defined at $(srcdir)/rational.c.

Mon Oct 27 15:58:25 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (load_file): preserves $..  [ruby-dev:36937]

	* io.c (argf_init): initial value of $. should be 0.
	  see [ruby-dev:36937].

Mon Oct 27 15:38:38 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/minitest/test_mini_test.rb
	  (test_assert_raises_triggered_different): the test failed when a
	  file path in the backtrace contontains something except [\w\/\.],
	  e.g. hyphen, Japanese characters or backslash.

	* test/minitest/test_mini_test.rb
	  (test_assert_raises_triggered_subclass): ditto.

Mon Oct 27 15:32:08 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/minitest/test_mini_test.rb: fixed that r19958 made
	  test-all fail when the ruby was built at $(srcdir).

Mon Oct 27 12:04:58 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/envutil.rb: reverted the changeset 19948 because it
	  concealed unexpected behaviours of ruby.

	* test/ruby/test_io.rb: ditto.

Mon Oct 27 12:02:53 2008  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* ext/nkf/nkf.c (rb_nkf_convert): should specify type of variable.

Mon Oct 27 11:34:56 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/minitest/test_mini_test.rb (test_filter_backtrace):
	  fixed failure on Ruby built at out of $(srcdir).

	* test/minitest/test_mini_test.rb (test_Filter_backtrace_unit_starts):
	  ditto.

Mon Oct 27 10:02:47 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (read_all): the 3rd argument maybe Qnil.

Mon Oct 27 01:29:55 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/nkf/test_nkf.rb: add a test for [ruby-dev:36909].

Mon Oct 27 01:05:48 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf.c (rb_nkf_convert): avoid GC.
	  reported in [ruby-dev:36909] and patched [ruby-dev:36941] by mame.

Sun Oct 26 21:28:42 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/json/test_json.rb: remove dependency on permutation gem.

Sun Oct 26 19:18:36 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (blocking_region_{begin,end}): declared as inline.

	* util.c (freedtoa): used only when MULTIPLE_THREADS is not defined.

	* win32/win32.c (rb_w32_pipe): serial is DWORD.

	* ext/etc/etc.c (sGroup): getgrent may not be available.

Sun Oct 26 18:11:40 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/wait/{extconf.rb,wait.c}: needs sys/ioctl.h for fcntl on
	  cygwin.

Sun Oct 26 18:18:39 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gem_prelude.rb: disables debug and verbose flags to suppress failure
	  messages.  interpolation does not occur inside single quotes.

Sun Oct 26 18:42:21 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/envutil.rb (assert_in_out_err): disables builtin rubygems
	  to get rid of the interference.

	* test/ruby/test_io.rb (ruby): ditto.

Sun Oct 26 13:30:28 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (read_all): use the given buffer to read when needs readconv.
	  based on the patch by wanabe <s.wanabe AT gmail.com> at
	  [ruby-dev:36931].

Sun Oct 26 07:57:35 2008  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems*:  Update to RubyGems 1.3.1 r1909.

Sun Oct 26 07:35:56 2008  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/minitest/unit.rb: Imported minitest 1.3.0 r4429.
	* test/minitest/*: ditto.

Sun Oct 26 02:16:29 2008  Yuki Sonoda (Yugui)   <yugui@yugui.jp>

	* configure.in ($MANTYPE): followed ruby.1, which had moved.

	* instruby.rb (:man): ditto.

	* mdoc2man.rb: fixed for the case Xr with 2 arguments.

Sun Oct 26 01:42:45 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* man/irb.1: new manual page.

Sun Oct 26 00:11:48 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* man/ruby.1: moved into man/. added some descriptions.

	* man/goruby.1: new file.

	* instruby.rb (:man): followed ruby.1.

Sat Oct 25 20:05:22 2008  Narihiro Nakamura  <authorNari@gmail.com>

	* gc.c (gc_profile_result): bug fix. The millisecond is 1/1000.

Sat Oct 25 11:12:40 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ruby.c (usage): updated the description of -E option.

Sat Oct 25 09:54:10 2008  James Edward Gray II  <jeg2@ruby-lang.org>

	* lib/csv.rb:  Fixed a bug in read_to_char() that would slurp
	  whole files if the encoding was invalid.  It will now read
	  up to 10 bytes ahead to find a valid character boundary or
	  give up.  [ruby-core:19465]

	* test/csv/test_features.rb, test/csv/test_table.rb, test/csv/test_row.rb:
	  Loosened some tests to check for a compatible? Encoding instead
	  of an exact Encoding.  [ruby-core:19470]

Sat Oct 25 07:42:49 2008  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc*: Update to RDoc 2.2.2 r192.

Sat Oct 25 04:00:31 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/us_ascii.c (us_ascii_mbc_enc_len): made static.  a patch by
	  Tadashi Saito <shiba AT mail2.accsnet.ne.jp> at [ruby-dev:36916]

	* signal.c (signal_buff): made static.  a patch by Tadashi Saito
	  <shiba AT mail2.accsnet.ne.jp> at [ruby-dev:36915]

	* util.c (freedtoa): made static to get rid of name clash.  a patch by
	  Tadashi Saito <shiba AT mail2.accsnet.ne.jp> at [ruby-dev:36913]

	* util.c (ruby_dtoa): added prefix, ditto.

Sat Oct 25 03:43:25 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (lambda): need to adjust lpar_beg for both of the parser and
	  ripper.

Sat Oct 25 01:29:34 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/mathn/rational/rational.c: undef duplicated macro definition
	  first to shut up the warning.

	* ext/mathn/rational/rational.c (rb_rational_new_mathn): specify
	  omitted return value.

Sat Oct 25 00:14:41 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_sample): fixed sizes and randomness.

Fri Oct 24 23:04:42 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* configure.in (sitedir): considers --program-prefix and
	  --program-suffix.
	  (vendordir): ditto.
	  (rubyhdrdir): ditto.

	* mkconfig.rb (CONFIG["rubylibdir"]): ditto.

	* win32/Makefile.sub: ditto.

	* instruby.rb (:rdoc): ditto.

	* lib/rdoc/ri/paths.rb (RDoc::RI::Paths): ditto.

Fri Oct 24 22:59:27 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_array.rb (test_sample): add tests for size of
	  returned array and randomness.

Fri Oct 24 21:50:21 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* id.h, template/id.h.tmpl (enum ruby_method_ids): reordered.

Fri Oct 24 21:19:45 2008  Keiju Ishitsuka  <keiju@ruby-lang.org>

	* ext/mathn/rational.c: change several global functions.

Fri Oct 24 21:05:38 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/html.rb: allow symbolized key.

	* test/cgi/test_cgi_tag_helper.rb: add a test.

Fri Oct 24 20:54:53 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (exts): renamed to get rid of the existent directory.

Fri Oct 24 20:45:41 2008  Keiju Ishitsuka  <keiju@ruby-lang.org>

	* ext/mathn/rational.c: change several global functions to static
	  function.

Fri Oct 24 19:57:19 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_dump): should have removed commented out
	  unnecessary code.  [ruby-cvs:27131]

Fri Oct 24 19:16:36 2008  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* id.h (enum ruby_method_ids): ISO C forbids comma at end of
	  enumerator list.

Fri Oct 24 18:29:00 2008  Keiju Ishitsuka  <keiju@ruby-lang.org>

	* lib/mathn.rb: moved into ext/mathn/rational/rational.c and
	  ext/mathn/complex/complex.c.
	* ext/mathn: new mathn ext-libralies.

Fri Oct 24 18:21:31 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* test/ruby/test_array.rb (TestArray#test_join): should restore
	  global variable after the test.  [ruby-dev:36896]

	* test/ruby/test_hash.rb (TestHash#test_to_s): ditto.

Fri Oct 24 17:43:26 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (lambda): need to adjust lpar_beg for ripper as well.
	  [ruby-dev:36702]

Fri Oct 24 16:13:12 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/core.rb (read_multipart): change field value as String
	  from StringIO or Tempfile when multipart parse except file field.
	  add files method that can get uploaded files. [ruby-dev:36547]

	* test/cgi/test_cgi_multipart.rb: fix the test for core.rb.

Fri Oct 24 14:22:48 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (ext): split out the target for extension library.

	* common.mk (encs): depends on enc and trans.

Fri Oct 24 10:23:24 2008  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/ruby/test_signal.rb (TestSignal#test_exit_action): Thread
	  may terminate before sysread. [ruby-dev:36835]

Thu Oct 23 22:06:23 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* distruby.rb: removed. "make dist" uses tool/make-snapshot for the 1.9
	  series. distruby.rb has been no longer used.

Thu Oct 23 17:30:29 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_class_instance_methods): rdoc fixed.  [ruby-core:19458]

Thu Oct 23 16:19:33 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/irb/init.rb (IRB.load_modules): catch LoadError explicitly.
	  a patch from Daniel Berger <Daniel.Berger at qwest.com> in
	  [ruby-core:19451].  fix [ruby-core:19450]

Thu Oct 23 16:16:17 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/socket.c (sock_s_getservbyport): check if the port range.
	  [ruby-core:19460]

Thu Oct 23 14:08:07 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/socket.c (sock_s_getservbyname): unuse unnecessary
	  object.

	* ext/socket/socket.c (sock_s_getservbyport): the port should be
	  converted before the proto so that the #to_int of the former cannot
	  alter the latter.

Thu Oct 23 10:55:08 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_dump): use \u{ff} escape for UTF-8 encoding
	  string.

Thu Oct 23 09:26:22 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/socket/socket.c (sock_s_getservbyport): cast to get rid of
	  warning.

Thu Oct 23 08:06:03 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (sock_s_getservbyport): port should be
	  network byte order.  a patch from Dave Thomas in [ruby-core:19454].

Thu Oct 23 01:26:25 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_conv_enc_opts): new function to convert with
	  specifying ecflags and ecopts.

	* ext/zlib/zlib.c (gzfile_newstr): specify ecflags and ecopts for
	  conversion using above function.

	* ext/zlib/zlib.c (gzfile_newstr): use own rb_econv_t for dummy
	  encoding to handling stateful encoding (e.g. iso-2022-jp).
	  [ruby-dev:36857]

	* ext/zlib/zlib.c (gzfile_getc): ditto.

Thu Oct 23 01:24:49 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (create_tmpsrc): get rid of side effects.

Thu Oct 23 00:10:01 2008  Koichi Sasada  <ko1@atdot.net>

	* cont.c: separate data structure between rb_fiber_t and
	  rb_context_t (rb_fiber_t includes rb_context_t).
	  rb_fiber_t has double linked list of fibers in same threads.

Wed Oct 22 17:25:17 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (pipe_open): remove unnecessary flush before fork.
	  a patch from Kazuhiro NISHIYAMA <zn at mbf.nifty.com>
	  in [ruby-dev:36840].

Wed Oct 22 16:27:57 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_yield_setup_args): should not drop arguments
	  corresponding to default paramters.

Wed Oct 22 14:59:30 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (f_larglist): should not allow semicolon separated local
	  variable declarations if formal argument list is not surrounded
	  by parentheses, mostly because semicolon outside of parentheses
	  appears to terminate the expression.

Wed Oct 22 14:52:17 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_external_str_new_with_enc): no implicit strlen call.
	  [ruby-dev:36854]

	* string.c (rb_external_str_new_cstr): new function to create
	  string from external NUL terminated C string.

	* string.c (rb_locale_str_new_cstr): ditto.

	* ext/readline/readline.c: now use rb_locale_str_new_cstr().

	* test/sdbm/test_sdbm.rb (TestSDBM#test_delete_with_block):
	  deleted key to the block may be a copy of specified key.

	* test/dbm/test_dbm.rb (TestDBM#test_delete_with_block): ditto.

Wed Oct 22 13:16:47 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (unescape_escaped_nonascii): back out the last change on
	  the function.  [ruby-dev:36818]

Wed Oct 22 07:09:19 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/zlib/zlib.c (rb_gzreader_ungetc): should be able to unget
	  Fixnum.

	* ext/stringio/stringio.c (strio_ungetc): should convert unget
	  string.

	* ext/stringio/stringio.c (strio_ungetbyte): new method.

Wed Oct 22 05:46:25 2008  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/vm.h: write a comment.

	* common.mk: remove vm.h from any rules.
	  vm.h is not needed on this version.

	* vm_core.h: ditto.

Wed Oct 22 05:39:39 2008  Koichi Sasada  <ko1@atdot.net>

	* parse.y (arg_concat_gen): concat target node should be NODE_ARRAY.
	  [ruby-core:19413]

	* bootstraptest/test_method.rb: add tests.

Wed Oct 22 00:29:13 2008  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* test/rinda/test_rinda.rb (test_core_03_notify): Fixed test failures
	  [ruby-dev:36837].

Wed Oct 22 00:22:06 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_external_str_new_with_enc): wrong condition to
	  calculate strlen().

	* ext/readline/readline.c: add encoding support.

Tue Oct 21 23:12:24 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/stringio/stringio.c (strio_write): should convert writing
	  string to the encoding of the buffer.

	* hash.c (rb_any_hash): typo fixed.

	* ext/zlib/zlib.c (rb_gzwriter_write): oops, IO string conversion
	  need to be done by to_s.

Tue Oct 21 22:38:58 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (open_key_args): should adjust argc, argv in struct
	  foreach_arg.

Tue Oct 21 21:52:00 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/zlib/zlib.c (rb_gzwriter_write): conversion should be done
	  using to_str, not to_s.

	* ext/zlib/zlib.c (rb_gzwriter_write): need proper conversion
	  according to gz encoding.

	* ext/zlib/zlib.c (rb_gzreader_ungetc): convert string encoding
	  before unget.

Tue Oct 21 21:33:36 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit.rb (assert_nothing_raised): raise with backtrace.

Tue Oct 21 20:12:19 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit.rb (assert_nothing_raised): set backtrace.

Tue Oct 21 18:17:42 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/zlib/zlib.c: remove obsolete prototype macros.

	* ext/zlib/zlib.c (struct gzfile): add encoding field to gzfile
	  structure.

	* ext/zlib/zlib.c (rb_gzreader_getc): now works on characters.

	* ext/zlib/zlib.c (rb_gzreader_getbyte): new method to retrieve
	  single byte.

	* ext/zlib/zlib.c (rb_gzreader_readbyte): ditto.

	* ext/zlib/zlib.c (rb_gzreader_each_byte): renamed from each_char

	* ext/zlib/zlib.c (rb_gzreader_ungetc): allow unget strings.

	* ext/zlib/zlib.c (rb_gzreader_ungetbyte): renamed from ungetc.

Tue Oct 21 13:28:42 2008  Shugo Maeda  <shugo@ruby-lang.org>

	* io.c, include/ruby/intern.h (rb_io_ascii8bit_binmode): externed.

	* ext/socket/socket.c (init_sock): use rb_io_ascii8bit_binmode()
	  instead of rb_io_binmode().

Tue Oct 21 13:17:39 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* mdoc2man.rb: moved into tools/.

	* instruby.rb: followed the change of mdoc2man.

Tue Oct 21 11:34:04 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/iconv/iconv.c (strip_glibc_option, map_charset): check if
	  encoding is a string.  based on the patch by Hiroshi Moriyama at
	  [ruby-dev:36811].

	* test/iconv/test_basic.rb (test_invalid_arguments): added tests.

Tue Oct 21 10:40:37 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_file_open_internal): should initialize fmode before using.

Tue Oct 21 08:56:37 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* regparse.c (parse_char_class): CCV_SB is only for single
	  byte.  [ruby-dev:36786]

Tue Oct 21 01:49:55 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_extract_modeenc): plain rb/wb should set ASCII-8BIT
	  to the external_encoding.

	* io.c (rb_file_open_internal): ditto.

	* io.c (NEED_WRITECONV): no conversion when the external_encoding
	  is ASCII-8BIT.

	* io.c (do_writeconv): skip ASCII-8BIT.

Tue Oct 21 00:51:59 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (rb_io_ascii8bit_binmode): renamed from rb_io_binmode.
	  (rb_io_binmode): don't change encoding conversion.
	  (rb_io_binmode_m): call rb_io_ascii8bit_binmode.

Mon Oct 20 21:19:00 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/core.rb (read_multipart): file's encoding is ascii-8bit
	  from file field of multipart form.

Mon Oct 20 20:16:25 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/zlib/zlib.c (Init_zlib): add getbyte as an alias to getc.
	  [ruby-dev:36801]

Mon Oct 20 17:31:17 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* error.c (exc_equal): should not compare recursively.
	  [ruby-dev:36796]

Mon Oct 20 16:48:43 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* include/ruby/ruby.h (ExportStringValue): new macro to convert
	  string in internal encoding to external to export.

	* string.c (rb_str_export): new function to do conversion to
	  external encoding.

	* ext/sdbm/init.c: encoding conversion support.

	* ext/dbm/dbm.c: ditto.

Mon Oct 20 15:42:02 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_locale_str_new): new function to convert string
	  from locale to internal encoding.

Mon Oct 20 09:47:13 2008  Tanaka Akira  <akr@fsij.org>

	* test/runner.rb: search srcdir/test/arg at first to find test/ruby
	  directory when "ruby" is specified.

Mon Oct 20 08:20:01 2008  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: support Encoding.default_internal.

	* ext/tk/tcltklib.c: ditto.

	* ext/tk/extconf.rb: improve the strategy for searching Tcl/Tk headers.

Mon Oct 20 00:57:04 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit.rb (Test::Unit.setup_argv): call given block for
	  filtering files.

	* test/runner.rb: search srcdir/test/arg, srcdir/arg.

	* bin/testrb: show usage if no files given.

Sun Oct 19 21:19:16 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (srcs): removed ID_H_TARGET.

	* tool/generic_erb.rb: always overwrites if no if-change option.
	  sends the result to stdout if no output option.

	* template/id.h.tmpl: shows which token differs.

Sun Oct 19 18:15:15 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/trans/single_byte.trans: adding WINDOWS-wwww encodings
	  (wwww = 874/1250/1251/1253/1254/1255/1256/1257)
	  (contributed by Yoshihiro Kambayashi)

	* enc/trans/windows-wwww-tbl.rb: 8 new files
	  (contributed by Yoshihiro Kambayashi)

	* test/ruby/test_transcode.rb: added test_windows_wwww
	  (contributed by Yoshihiro Kambayashi)

Sun Oct 19 07:37:13 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/cmath.rb (log2,cbrt,frexp,ldexp,hypot,erf,erfc,gamma,lgamma):
	  should be also provided as module function.  [ruby-dev:36787]

Sun Oct 19 07:25:08 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* keywords, lex.c.src, opt_insn_unif.def, opt_operand.def: moved rarely changed
	  input files for code generators into defs/ directory.

	* Makefile.in (lex.c): followed keywords and lex.c.src.

	* common.mk (parser.o): followed keywords.
	  (INSNS): followed opt_*.def

	* tools/instruction.rb: followed opt_*.def.

Sun Oct 19 12:28:01 2008  James Edward Gray II  <jeg2@ruby-lang.org>

	* test/csv/*:  Renamed tc_* files to test_* to fit in within Ruby's
	  testing process.

Sun Oct 19 00:15:03 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit.rb (assert_nothing_thrown): don't intern.

Sat Oct 18 14:40:32 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (num_sadded): remove newly defined singleton method
	  that should not exist after exception handling.  [ruby-dev:36569]

Sat Oct 18 14:27:49 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (opt_block_arg): allow trailing comma after usual
	  arguments.  not after block argument.

Sat Oct 18 13:30:53 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_external_str_new): a new function to convert from
	  external encoding to internal encoding.  if something went
	  wrong, it returns a string with the external encoding.

	* string.c (rb_external_str_new_with_enc): same as above besides
	  you can specify the source encoding.

	* ruby.c (ruby_set_argv): use rb_external_str_new()

	* ruby.c (set_arg0, ruby_script): ditto.

Sat Oct 18 04:08:18 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/tempfile.rb (Tempfile#initialize): now Tempfile.new takes
	  keyword arguments to open().  [ruby-dev:36756]

Sat Oct 18 17:10:10 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* tool/transcode-tblgen.rb: added set_valid_byte_pattern
	  to reduce coupling between table generation script and
	  specific encodings.

	* enc/trans/single_byte.trans: using set_valid_byte_pattern

Sat Oct 18 16:39:39 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* transcode.c: in transcode_search_path, eliminated a warning
	  on cygwin about pathlen potentially not being initialized

Sat Oct 18 13:40:27 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit.rb (assert_nothing_thrown): implemented.

Sat Oct 18 01:33:22 2008  WATANABE Hirofumi  <eban@ruby-lang.org>

	* common.mk: use added options for generic_erb.rb.

Sat Oct 18 00:47:51 2008  wanabe  <s.wanabe@gmail.com>

	* array.c: don't recycle shared-array while sort!.

Fri Oct 17 22:04:38 2008  wanabe  <s.wanabe@gmail.com>

	* array.c: recycle shared-array when it isn't referenced.

Fri Oct 17 20:29:26 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_initialize_m): specify ARG_ENCODING_NONE instead of
	  ARG_ENCODING_FIXED for Regexp.new("", nil, "n").  [ruby-dev:36761]

	* test/ruby/test_regexp.rb (TestRegexp#test_initialize): test
	  updated.

Fri Oct 17 19:46:20 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/ifchange, win32/ifchange.bat: --timestamp option added.

	* tool/generic_erb.rb: --timestamp, --output and --if-change options
	  added.

Fri Oct 17 18:33:12 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* array.c (ary_resize_capa): renamed RESIZE_CAPA.

Fri Oct 17 18:16:51 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* test/bigdecimal/test_bigdecimal.rb (TestBigDecimal#test_sqrt_bigdecimal):
	  test updated.  a patch from TAKANO Mitsuhiro <takano32 at jus.or.jp> in
	  [ruby-dev:36736].

Fri Oct 17 18:14:57 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (uncommon.mk): ignores failures at loading.

	* test/rubygems/gemutilities.rb (RubyGemTestCase#build_rake_in):
	  get rid of interference with other tests.

Fri Oct 17 18:06:39 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* transcode.c (str_transcode0): String#encode without argument now
	  behave as if :undef => :replace, :invalid => :replace specified.

	* transcode.c (rb_econv_prepare_opts): should preserve options in
	  any case.

Fri Oct 17 11:48:18 2008  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/socket.c (init_sock): sockets should be binmode.

	* test/socket/test_tcp.rb (test_encoding): ditto.

Fri Oct 17 10:26:13 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* tool/insns2vm.rb: remove -Kn option in shebang line because it's
	  inconsistent with -Ks commandline option in common.mk.

Fri Oct 17 01:26:09 2008  Tanaka Akira  <akr@fsij.org>

	* transcode.c (transcode_restartable0): in_pos and out_pos never be
	  NULL, now.

Fri Oct 17 00:39:19 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/test/unit.rb: sort the order of executing tests.

Fri Oct 17 00:24:15 2008  Tanaka Akira  <akr@fsij.org>

	* io.c (rb_io_binmode): reset encoding conversion.

Fri Oct 17 00:16:08 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* io.c (rb_getc, rb_io_fread, rb_io_fwrite, rb_read_pending):
	  remove deprecated functions which do not work.  [ruby-dev:36697]

Thu Oct 16 23:48:34 2008  Tanaka Akira  <akr@fsij.org>

	* common.mk (TESTS): removed to re-enable test for minitest.

Thu Oct 16 23:37:11 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* compile.c (iseq_set_sequence): fix memory leak.

Thu Oct 16 23:27:27 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit.rb (assert_equal): avoid incompatible character
	  encodings error.

Thu Oct 16 23:23:27 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit.rb (assert_equal): failure message changed.

Thu Oct 16 22:52:54 2008  Tanaka Akira  <akr@fsij.org>

	* lib/test/unit: removed test/unit.

	* lib/test/unit.rb: new compatibility layer using minitest.

	* bin/testrb: use above.

	* test/runner.rb: ditto.

Thu Oct 16 14:34:16 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk, enc/depend (enc, trans): targets for sources.

Thu Oct 16 14:30:30 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* instruby.rb (lib): installs all files other than README etc.

Thu Oct 16 09:48:03 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_initialize_m): changed the message to clarify the
	  third option argument is now ignored.  [ruby-dev:36753]

Thu Oct 16 08:14:39 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (proc_options): no warning when default_external already
	  set by -E.

	* test/ruby/test_rubyoptions.rb (TestRubyOptions#test_rubyopt):
	  put -K after -E to set script encoding.

Thu Oct 16 06:20:36 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* test/ruby/test_transcode.rb (TestTranscode#test_errors):
	  String#encode now works without any argument. [ruby-dev:36740]

Wed Oct 15 23:48:22 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* .gdbinit (rp): REGEXP handling fixed.

	* string.c (rb_str_rindex_m): need not to call rb_enc_check on
	  regexp.

	* re.c (unescape_escaped_nonascii): try ASCII-8BIT encoding for
	  broken strings.

Wed Oct 15 23:11:10 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/delegate.rb (DelegateClass): restored 1.8 behavior for
	  DelegateClass as well.  [ruby-dev:36739]

Wed Oct 15 22:19:14 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* array.c (RESIZE_CAPA): check whether len is longer than capacity.

	* array.c (rb_ary_compact_bang): resize ary before changing capacity.
	  fixed [ruby-dev:36704]

Wed Oct 15 16:57:30 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* version.h (RUBY_DESCRIPTION): remove unnecessary space.

Tue Oct 14 23:18:15 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/delegate.rb (Delegator): simplified and restored 1.8
	  behavior.  [ruby-dev:35986]

Tue Oct 14 21:50:40 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (TESTS): skips minitest by default, since it interferes
	  with test/unit.

Tue Oct 14 21:36:29 2008  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (load_conv_function51932): check
	  having IMultiLanguage2 or IMultiLanguage. [ruby-dev:36716]

	* ext/win32ole/extconf.rb: ditto.

Tue Oct 14 20:45:29 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (Init_IO): $FILENAME and $* must be read-only.  [ruby-dev:36698]

	* variable.c (*_getter, *_setter, *_marker): made public.

	* include/ruby/ruby.h (rb_gvar_*_{getter,setter,marker}): declared.

Tue Oct 14 20:32:09 2008  Tanaka Akira  <akr@fsij.org>

	* enc/trans/single_byte.trans (transcode_tblgen_singlebyte): renamed
	  from transcode_tblgen_windows.
	  (transcode_tblgen_iso8859): use transcode_tblgen_singlebyte.

Tue Oct 14 19:32:14 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (process_options): -U should be allowed in RUBYOPT
	  environment variable.  [ruby-dev:36720]

Tue Oct 14 14:11:17 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (proc_options): -U can be followed by other options.

Tue Oct 14 13:30:30 2008  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/trans/single_byte.trans: added windows-1252

	* enc/trans/windows-1252-tbl.rb: new file
	  (contributed by Yoshihiro Kambayashi)

	* tool/transcode-tblgen.rb: listed windows-1252 as '1byte'

	* test/ruby/test_transcode.rb: added test_windows_1252
	  (contributed by Yoshihiro Kambayashi)

Tue Oct 14 12:22:32 2008  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/ruby/test_variable.rb (TestVariable#test_variable): add
	  a test of [ruby-dev:36698].

Tue Oct 14 11:14:29 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* transcode.c (str_transcode0): should not raise error when
	  default_internal is not set.  [ruby-core:19309]

Tue Oct 14 11:14:26 2008  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/net/pop.rb: check for invalid APOP timestamp. (CVE-2007-1558)
	  [ruby-dev:36631]

	* test/net/pop/test_pop.rb: ditto.

Tue Oct 14 09:39:32 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (set_internal_encoding_once): check double contradicted
	  specification of the encoding from command line.

	* ruby.c (set_external_encoding_once): ditto.

Tue Oct 14 08:28:31 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (parser_yylex): allow reserved word to be keyword argument.

Mon Oct 13 19:07:52 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* parse.y (token_info_pop): show source filename. [ruby-dev:36710]

Mon Oct 13 08:59:08 2008  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (load_conv_function51932): support
	  CP51932 on cygwin and mingw32. thanks to arton.

	* test/win32ole/test_win32ole.rb (test_cp51932): ditto.

Mon Oct 13 07:54:00 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (proc_options): add -U command line option to specify
	  utf-8 as default_internal.

Mon Oct 13 07:42:57 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* transcode.c (str_transcode0): String#encode() with no encoding
	  specified transcode the string into Encoding.default_internal.
	  inspired by [ruby-core:19298].

Sun Oct 12 18:00:18 2008  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (set_ole_codepage, ole_cp2encoding,
	  ole_wc2mb, ole_vstr2wc, ole_mb2wc): support CP51932 (only mswin32).

	* test/win32ole/test_win32ole.rb: ditto.

Sun Oct 12 12:03:38 2008  Koichi Sasada  <ko1@atdot.net>

	* vm.c, vm_insnhelper.h (ruby_vm_redefined_flag): apply optimization
	  patch proposed by Paul Brannan.  [ruby-core:19171]

Sun Oct 12 09:46:36 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* strftime.c (rb_strftime): suppressed warnings on cygwin.

Sat Oct 11 19:49:35 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_prepare): use utf-8 encoding directly.

Sat Oct 11 10:20:17 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (CLEANINGS): uses escaped form tabs to preventing the
	  confusion.  [ruby-talk:317345]

Sat Oct 11 08:51:13 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rake.rb (Rake::Application#standard_exception_handling): removed
	  unnecessary SystemExit, and exits with false instead of system
	  dependent value.  [ruby-talk:317330]

Sat Oct 11 03:54:05 2008  Koichi Sasada  <ko1@atdot.net>

	* parse.y: optimize 'for' statement when one variable given.

	* benchmark/bm_loop_for.rb: added.

	* benchmark/bm_loop_times.rb: modified.

Sat Oct 11 12:09:05 2008  James Edward Gray II  <jeg2@ruby-lang.org>

	* lib/csv/csv.rb:  Added support for Encoding::default_internal.
	* lib/csv/csv.rb:  Switched to new Hash syntax.

Fri Oct 10 22:16:55 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (comment_at_top): needed for ripper too.

Fri Oct 10 22:07:05 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby.h: updated macros for headers.  [ruby-core:19275]

Fri Oct 10 19:21:50 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (magic_comment_encoding): warns when ignored.

	* parse.y (parser_magic_comment): replaces '-' with '_'.

	* parse.y (parser_yylex): allows magic comments indented and the
	  second line or later.

Fri Oct 10 17:26:50 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json/ext/parser/parser.c (JSON_parse_string):
	  associate encoding.

Fri Oct 10 10:18:21 2008  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/test/*: reverted back to test/unit.
	* test/test/*: ditto
	* lib/minitest/*: Imported minitest 1.3.0 r4333.

Fri Oct 10 03:41:31 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (rb_str_format): check if codepoint for %c is valid.
	  [ruby-dev:36691]

Fri Oct 10 01:55:48 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (enc_names): minor improvement.

Fri Oct 10 00:21:39 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (ParseError.filter_backtrace): removes internal
	  backtrace.

Fri Oct 10 00:11:16 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* transcode.c (rb_econv_add_converter): remove unnecessary NULL check.

Thu Oct  9 23:53:23 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-style.el (ruby-style-c-mode): buffer may not have file
	  name.

Thu Oct  9 23:30:47 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* process.c (run_exec_dup2): fix resource leak.

Thu Oct  9 23:19:02 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* process.c (rb_run_exec_options): fix resource leak.

Thu Oct  9 22:13:58 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_module.rb (test_remove_class_variable): add a test
	  for Class#remove_class_variable.

	* test/ruby/test_object.rb (test_remove_instance_variable): add a test
	  for Object#remove_instance_variable.

Thu Oct  9 22:04:38 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* variable.c (rb_mod_remove_cvar): fix r19711.

Thu Oct  9 21:17:50 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* ext/syck/syck.c (syck_lookup_sym): remove reading uninitialized
	  variable.

Thu Oct  9 16:34:15 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json/ext/generator/extconf.rb: fix target.

	* ext/json/ext/parser/extconf.rb: ditto.

Thu Oct  9 14:37:59 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* include/ruby/ruby.h: embeds the elements of an array into its
	  struct RArray for # of elements <= 3.

	* array.c: ditto.

	* gc.c (gc_mark_children): following the change of struct RArray.

	* ext/tk/tcltklib.c (ip_ruby_cmp): ditto.

	* parse.y (coverage): ditto.

	* proc.c (curry): ditto.

	* .gdbinit: ditto.

Thu Oct  9 11:29:33 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* encoding.c (Init_Encoding): new instance method Encoding#names,
	  returns its name and alias names.

	* encoding.c (enc_names): defined for Encoding#names.

	* encoding.c (enc_names_i): defined for enc_names.

Thu Oct  9 08:47:38 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* thread.c (rb_thread_wait_fd_rw): should not block by select if
	  there's only one thread living.  fixed [ruby-dev:36646].

Wed Oct  8 20:59:52 2008  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (ole_init_cp): initialize WIN32OLE.codepage
	  according to Encoding.default_internal and
	  Encoding.default_external.

Wed Oct  8 17:02:21 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json/lib/json/pure/generator.rb (utf8_to_json):
	  process each unpacked Unicode character.

Wed Oct  8 15:00:22 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json/lib/json/pure/parser.rb
	  (JSON::Pure::Parser#parse_string): force_encoding("UTF-8").

Wed Oct  8 11:56:15 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/test/unit/assertions.rb: assert_nothing_thrown,
	  assert_raise, assert_not_equal, assert_no_match, assert_not_nil,
	  assert_not_same are coming back as alias.

Wed Oct  8 11:18:12 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (autoload_delete, autoload_file): should not delete
	  autoload table, since it may be shared with duplicated modules.
	  [ruby-core:19181]

Wed Oct  8 02:38:28 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* encoding.c (rb_default_internal_encoding): merged a patch from
	  Michael Selig <michael.selig at fs.com.au> in [ruby-core:18985].

	* io.c (rb_io_ext_int_to_encs): ditto.

	* ruby.c (proc_options): support default internal encoding in -E
	  option.

Wed Oct  8 00:03:39 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date.rb (today,now): should produce own instances.
	  [ruby-talk:317020]

Tue Oct  7 16:43:51 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json/lib/json/pure/generator.rb (utf8_to_json):
	  force_encoding before gsub.

Tue Oct  7 16:35:41 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json/lib/json/pure/generator.rb (utf8_to_json):
	  downcase the result of Unicode escape.

Mon Oct  6 16:44:52 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/core.rb (CGI::QueryExtension::initialize_query): fix the
	  condition.

	* test/cgi/test_cgi_core.rb: bug fix encoding.
	  thanks to TAKANO Mitsuhiro <takano32 at jus.or.jp> .

	* test/cgi/test_cgi_multipart.rb: temporary comment in.

Mon Oct  6 15:22:08 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (gc_mark_children): ignores T_ZOMBIE.

Mon Oct  6 12:45:20 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* test/ruby/test_module.rb (TestModule#_wrap_assertion): add
	  definition.  is this really needed?

	* test/ruby/test_module.rb (TestModule#test_mod_constants): should
	  not depend on global Module constants.

Mon Oct  6 12:38:36 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/test/unit/assertions.rb (Test::Assertions#assert_nothing_raised):
	  should take optional message argument.

Mon Oct  6 12:18:23 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_comparable): string comparison should be
	  transitive.  [ruby-dev:36484]

	* test/ruby/test_m17n_comb.rb (TestM17NComb#test_str_eq): test
	  updated.

Mon Oct  6 09:00:58 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* test/bigdecimal/test_bigdecimal.rb (test_sqrt_bigdecimal): test
	  updated.  a patch from TAKANO Mitsuhiro <takano32 at jus.or.jp>
	  in [ruby-dev:36669].

Sun Oct  5 23:34:28 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb ($config_h): now always defines for old libraries.

Sun Oct  5 23:06:55 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_mod_modfunc): method undefined in included module
	  may not have nd_body.  [ruby-core:18738]

Sun Oct  5 21:28:58 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/rational.rb: resolved conflicts of aliases.

	* lib/mathn.rb: avoided some warnings.

Sun Oct  5 18:51:50 2008  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb: remove debug code introduced by previous change.

Sun Oct  5 17:49:35 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/open-uri.rb (OpenURI.open_uri): set encoding to strio.

Sun Oct  5 17:39:21 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/stringio/stringio.c (strio_set_encoding): defined for
	  StringIO#set_encoding.

Sun Oct  5 11:24:42 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* eval.c: come back definition of environ.

Sun Oct  5 09:19:49 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/utf8tbl.c: update table.

Sat Oct  4 22:50:14 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* dln.c: Ruby no longer supports VMS.

	* error.c: ditto.

	* eval.c: ditto.

	* eval_intern.h: ditto.

	* include/ruby/defines.h: ditto.

	* include/ruby/ruby.h: ditto.

	* io.c: ditto.

	* process.c: ditto.

	* ruby.c: ditto.

	* vms/config.h: removed.

	* vms/vms.h: ditto.

	* vms/vmsruby_private.c: ditto.

	* vms/vmsruby_private.h: ditto.

Sat Oct  4 22:44:23 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* dln.c: Ruby no longer supports Windows CE.

	* eval.c: ditto.

	* include/ruby/defines.h: ditto.

	* include/ruby/win32.h: ditto.

	* ruby.c: ditto.

	* strftime.c: ditto.

	* win32/Makefile.sub: ditto.

	* win32/win32.c: ditto.

	* ext/tk/extconf.rb: ditto.

	* lib/fileutils.rb: ditto.

	* test/fileutils/test_fileutils.rb: ditto.

	* wince/*: removed.

Sat Oct  4 22:35:06 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* dln.c: Ruby no longer supports MacOS 9 or before.

	* eval.c: ditto.

	* eval_intern.h: ditto.

	* ext/extmk.rb: ditto.

	* ext/tk/sample/tkextlib/treectrl/demo.rb: ditto.

	* ext/tk/stubs.c: ditto.

	* file.c: ditto.

	* hash.c: ditto.

	* include/ruby/defines.h: ditto.

	* ruby.c: ditto.

	* signal.c: ditto.

	* vm_core.h: ditto.

Sat Oct  4 22:30:28 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* dln.c: Ruby no longer supports MS-DOS.

	* ext/sdbm/_sdbm.c: ditto.

	* ext/sdbm/sdbm.h: ditto.

	* gc.c: ditto.

	* hash.c: ditto.

	* include/ruby/defines.h: ditto.

	* include/ruby/util.h: ditto.

	* io.c: ditto.

	* process.c: ditto.

	* ruby.c: ditto.

	* strftime.c: ditto.

	* util.c: ditto.

Sat Oct  4 22:14:15 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* djgpp/GNUmakefile.in: removed. Ruby no longer supports djgpp.

	* djgpp/README.djgpp: ditto.

	* djgpp/config.hin: ditto.

	* djgpp/config.sed: ditto.

	* djgpp/configure.bat: ditto.

	* djgpp/mkver.sed: ditto.

	* ext/Setup.dj: ditto.

	* dln.c: removed djgpp supports.

	* file.c: ditto.

	* gc.c: ditto.

	* io.c: ditto.

	* process.c: ditto.

	* ruby.c: ditto.

	* signal.c: ditto.

	* util.c: ditto.

	* vm_core.h: ditto.

	* lib/fileutils.rb: ditto.

	* lib/mkmf.rb: ditto.

	* ext/socket/socket.c: ditto.

	* test/fileutils/test_fileutils.rb: ditto.

	* test/ruby/test_env.rb: ditto.

	* test/ruby/test_path.rb: ditto.

Sat Oct  4 21:59:39 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* x68/_dtos18.c: removed. Ruby no longer supports human68k.

	* x68/_round.c: ditto.

	* x68/fconvert.c: ditto.

	* x68/select.c: ditto.

	* ext/Setup.x68: ditto.

	* missing/x68.c: ditto.

	* dln.c (dln_find_exe_r): removed human68k supports.
	  (dln_find_1): ditto.

	* lib/mkmf.rb: ditto.

	* ext/extmk.rb (Init_ext): ditto.

	* ext/socket/socket.c (init_sock): ditto.

	* gc.c (GC_MALLOC_LIMIT): ditto.
	  (rb_setjmp, rb_jmpbuf): ditto.
	  (mark_current_machine_context): ditto.

	* include/ruby/defines.h (PATH_ENV): ditto.

	* io.c: ditto.

	* process.c: ditto.

	* ruby.c: ditto.

	* test/ruby/test_env.rb: ditto.

	* test/ruby/test_path.rb: ditto.

	* LEGAL

Sat Oct  4 19:02:36 2008  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date/format.rb: no need to require the "lib/rational.rb".

Sat Oct  4 19:02:59 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf.c (rb_nkf_enc_get): don't replicate encoding.
	  [ruby-dev:36575]

Sat Oct  4 18:47:22 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/stringio/stringio.c (strio_external_encoding): defined.

	* ext/stringio/stringio.c (strio_internal_encoding): defined.

	* ext/stringio/stringio.c (Init_stringio): define above.

Sat Oct  4 15:52:17 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/mini/test_mini_test.rb: recovered.
	  It had been temporarily removed at r19645.

	* test/mini/test_mini_mock.rb: ditto.

	* test/mini/test_mini_spec.rb: ditto.

	* lib/test/**/*: replaced by miniunit.
	  miniunit had been temporarily reverted at r19643 but
	  now recovered.

Sat Oct  4 15:33:26 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* common.mk (gdb-ruby): new target. it runs ruby under controlled by
	  gdb.

	* common.mk (dist): accepts RELNAME variable as the second argument of
	  make-snapshot.rb.

Sat Oct  4 12:17:46 2008  Keiju Ishitsuka  <keiju@ruby-lang.org>

	* lib/irb/irb/ext/save-history.rb: change load_history using File.expand_path. see [ruby-dev:36660]. Thanks Kouhei Sutou.
	* lib/irb/irb/context.rb: convert string Symbol of instance variable names in IRB:Context#inspect.

Fri Oct  3 22:43:04 2008  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/dl/extconf.rb ($distcleanfiles): added callback-?.c into
	  the distclean list.

Fri Oct  3 19:33:21 2008  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json/lib/json/pure.rb (module JSON): remove Iconv dependency.

	* ext/json/lib/json/pure/generator.rb (utf8_to_json): process as
	  binary and remove Iconv dependency.

	* ext/json/lib/json/pure/parser.rb (parse_string): ditto.

Fri Oct  3 14:04:05 2008  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/{configure.bat,setup.mak,Makefile.sub): add --program-prefix
	  configure option support.

Thu Oct  2 21:22:43 2008  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/core.rb (CGI::QueryExtension): delete MorphingBody
	  and replace like as 1.8's in multipart reading.
		see [ruby-dev:36443],
	  reference from CGIAlt http://cgialt.rubyforge.org/

	* test/cgi/test_cgi_multipart.rb : fixed multipart test.

Thu Oct  2 20:46:17 2008  Tanaka Akira  <akr@fsij.org>

	* string.c (rb_str_sub_bang): fix coderange.

Wed Oct  1 22:54:09 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/rexml/parsers/lightparser.rb, lib/debug.rb: remove unused when
	  clauses.

Wed Oct  1 22:43:59 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/xmlrpc, lib/rexml, test/ruby/test_array.rb,
	  test/ruby/test_unicode_escape.rb, test/scanf/test_scanf.rb,
	  test/rss/rss-assertions.rb: fix indentation to remove warning.

Wed Oct  1 21:36:35 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (rb_gc_call_finalizer_at_exit): finalize deferred IO and Data.

	* gc.c (rb_gc_call_finalizer_at_exit): defers IO finalization.
	  [ruby-dev:36646]

Wed Oct  1 19:11:48 2008  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (marshal_dump): fixed for check_dump_arg.

	* marshal.c (marshal_dump): initializes dump_arg before any funcall.
	  [ruby-dev:36648]

Wed Oct  1 00:54:32 2008  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_split_m): should use rb_str_subseq() which use
	  offset and length by bytes.  [ruby-dev:36641]

Wed Oct  1 00:29:48 2008  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_settracefunc.rb (test_call, test_class): line number
	  was changed at r19592.

Wed Oct  1 00:20:38 2008  Tanaka Akira  <akr@fsij.org>

